/*******************************************************************************
 * Copyright (c) 2016 ALL4TEC & CEA LIST.
 * All rights reserved. This program and the accompanying materials
 * are made available under the terms of the Eclipse Public License v1.0
 * which accompanies this distribution, and is available at
 * http://www.eclipse.org/legal/epl-v10.html
 *   
 * Contributors:
 *      ALL4TEC & CEA LIST - initial API and implementation
 *******************************************************************************/
package org.polarsys.esf.esflocalanalysis;

import org.polarsys.esf.esfsafetyconcepts.sdysfuctions.ISFailureMode;

/**
 * <!-- begin-user-doc -->
 * A representation of the model object '<em><b>Abstract SFailure Mode LAnalysis</b></em>'.
 * <!-- end-user-doc -->
 *
 * <p>
 * The following features are supported:
 * </p>
 * <ul>
 * <li>{@link org.polarsys.esf.esflocalanalysis.IAbstractSFailureModeLAnalysis#getSBlockLAnalysis <em>SBlock
 * LAnalysis</em>}</li>
 * <li>{@link org.polarsys.esf.esflocalanalysis.IAbstractSFailureModeLAnalysis#getSFailureMode <em>SFailure
 * Mode</em>}</li>
 * </ul>
 *
 * @see org.polarsys.esf.esflocalanalysis.IESFLocalAnalysisPackage#getAbstractSFailureModeLAnalysis()
 * @model abstract="true"
 * @generated
 */
public interface IAbstractSFailureModeLAnalysis
    extends IAbstractSPropagationElement {

    /**
     * Returns the value of the '<em><b>SBlock LAnalysis</b></em>' container reference.
     * It is bidirectional and its opposite is
     * '{@link org.polarsys.esf.esflocalanalysis.ISBlockLAnalysis#getSFailureModesLAnalysisList <em>SFailure Modes
     * LAnalysis List</em>}'.
     * <!-- begin-user-doc -->
     * <p>
     * If the meaning of the '<em>SBlock LAnalysis</em>' container reference isn't clear,
     * there really should be more of a description here...
     * </p>
     * <!-- end-user-doc -->
     * 
     * @return the value of the '<em>SBlock LAnalysis</em>' container reference.
     * @see #setSBlockLAnalysis(ISBlockLAnalysis)
     * @see org.polarsys.esf.esflocalanalysis.IESFLocalAnalysisPackage#getAbstractSFailureModeLAnalysis_SBlockLAnalysis()
     * @see org.polarsys.esf.esflocalanalysis.ISBlockLAnalysis#getSFailureModesLAnalysisList
     * @model opposite="sFailureModesLAnalysisList" required="true" transient="false" ordered="false"
     * @generated
     */
    ISBlockLAnalysis getSBlockLAnalysis();

    /**
     * Sets the value of the '{@link org.polarsys.esf.esflocalanalysis.IAbstractSFailureModeLAnalysis#getSBlockLAnalysis
     * <em>SBlock LAnalysis</em>}' container reference.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * 
     * @param value the new value of the '<em>SBlock LAnalysis</em>' container reference.
     * @see #getSBlockLAnalysis()
     * @generated
     */
    void setSBlockLAnalysis(ISBlockLAnalysis value);

    /**
     * Returns the value of the '<em><b>SFailure Mode</b></em>' reference.
     * <!-- begin-user-doc -->
     * <p>
     * If the meaning of the '<em>SFailure Mode</em>' reference isn't clear,
     * there really should be more of a description here...
     * </p>
     * <!-- end-user-doc -->
     * 
     * @return the value of the '<em>SFailure Mode</em>' reference.
     * @see #setSFailureMode(ISFailureMode)
     * @see org.polarsys.esf.esflocalanalysis.IESFLocalAnalysisPackage#getAbstractSFailureModeLAnalysis_SFailureMode()
     * @model ordered="false"
     * @generated
     */
    ISFailureMode getSFailureMode();

    /**
     * Sets the value of the '{@link org.polarsys.esf.esflocalanalysis.IAbstractSFailureModeLAnalysis#getSFailureMode
     * <em>SFailure Mode</em>}' reference.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * 
     * @param value the new value of the '<em>SFailure Mode</em>' reference.
     * @see #getSFailureMode()
     * @generated
     */
    void setSFailureMode(ISFailureMode value);

} // IAbstractSFailureModeLAnalysis
