/*******************************************************************************
 * Copyright (c) 2016 ALL4TEC & CEA LIST.
 * All rights reserved. This program and the accompanying materials
 * are made available under the terms of the Eclipse Public License v1.0
 * which accompanies this distribution, and is available at
 * http://www.eclipse.org/legal/epl-v10.html
 *   
 * Contributors:
 *      ALL4TEC & CEA LIST - initial API and implementation
 *******************************************************************************/
package org.polarsys.esf.esflocalanalysis;

import java.util.Map;

import org.eclipse.emf.common.util.DiagnosticChain;

import org.eclipse.uml2.uml.Connector;

/**
 * <!-- begin-user-doc -->
 * A representation of the model object '<em><b>SDysfunctional Association</b></em>'.
 * <!-- end-user-doc -->
 *
 * <p>
 * The following features are supported:
 * </p>
 * <ul>
 * <li>{@link org.polarsys.esf.esflocalanalysis.ISDysfunctionalAssociation#getSPortLAnalysis <em>SPort
 * LAnalysis</em>}</li>
 * <li>{@link org.polarsys.esf.esflocalanalysis.ISDysfunctionalAssociation#getSBarrierLAnalysis <em>SBarrier
 * LAnalysis</em>}</li>
 * <li>{@link org.polarsys.esf.esflocalanalysis.ISDysfunctionalAssociation#getSFailureModeLAnalysis <em>SFailure Mode
 * LAnalysis</em>}</li>
 * <li>{@link org.polarsys.esf.esflocalanalysis.ISDysfunctionalAssociation#getBase_Connector <em>Base
 * Connector</em>}</li>
 * </ul>
 *
 * @see org.polarsys.esf.esflocalanalysis.IESFLocalAnalysisPackage#getSDysfunctionalAssociation()
 * @model annotation="http://www.eclipse.org/uml2/2.0.0/UML originalName='SDysfunctionalAssociation '"
 * @generated
 */
public interface ISDysfunctionalAssociation
    extends IAbstractSLocalAnalysisElement {

    /**
     * Returns the value of the '<em><b>SPort LAnalysis</b></em>' reference.
     * <!-- begin-user-doc -->
     * <p>
     * If the meaning of the '<em>SPort LAnalysis</em>' reference isn't clear,
     * there really should be more of a description here...
     * </p>
     * <!-- end-user-doc -->
     * 
     * @return the value of the '<em>SPort LAnalysis</em>' reference.
     * @see #setSPortLAnalysis(ISPortLAnalysis)
     * @see org.polarsys.esf.esflocalanalysis.IESFLocalAnalysisPackage#getSDysfunctionalAssociation_SPortLAnalysis()
     * @model ordered="false"
     * @generated
     */
    ISPortLAnalysis getSPortLAnalysis();

    /**
     * Sets the value of the '{@link org.polarsys.esf.esflocalanalysis.ISDysfunctionalAssociation#getSPortLAnalysis
     * <em>SPort LAnalysis</em>}' reference.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * 
     * @param value the new value of the '<em>SPort LAnalysis</em>' reference.
     * @see #getSPortLAnalysis()
     * @generated
     */
    void setSPortLAnalysis(ISPortLAnalysis value);

    /**
     * Returns the value of the '<em><b>SBarrier LAnalysis</b></em>' reference.
     * <!-- begin-user-doc -->
     * <p>
     * If the meaning of the '<em>SBarrier LAnalysis</em>' reference isn't clear,
     * there really should be more of a description here...
     * </p>
     * <!-- end-user-doc -->
     * 
     * @return the value of the '<em>SBarrier LAnalysis</em>' reference.
     * @see #setSBarrierLAnalysis(ISBarrierLAnalysis)
     * @see org.polarsys.esf.esflocalanalysis.IESFLocalAnalysisPackage#getSDysfunctionalAssociation_SBarrierLAnalysis()
     * @model ordered="false"
     * @generated
     */
    ISBarrierLAnalysis getSBarrierLAnalysis();

    /**
     * Sets the value of the '{@link org.polarsys.esf.esflocalanalysis.ISDysfunctionalAssociation#getSBarrierLAnalysis
     * <em>SBarrier LAnalysis</em>}' reference.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * 
     * @param value the new value of the '<em>SBarrier LAnalysis</em>' reference.
     * @see #getSBarrierLAnalysis()
     * @generated
     */
    void setSBarrierLAnalysis(ISBarrierLAnalysis value);

    /**
     * Returns the value of the '<em><b>SFailure Mode LAnalysis</b></em>' reference.
     * <!-- begin-user-doc -->
     * <p>
     * If the meaning of the '<em>SFailure Mode LAnalysis</em>' reference isn't clear,
     * there really should be more of a description here...
     * </p>
     * <!-- end-user-doc -->
     * 
     * @return the value of the '<em>SFailure Mode LAnalysis</em>' reference.
     * @see #setSFailureModeLAnalysis(IAbstractSFailureModeLAnalysis)
     * @see org.polarsys.esf.esflocalanalysis.IESFLocalAnalysisPackage#getSDysfunctionalAssociation_SFailureModeLAnalysis()
     * @model required="true" ordered="false"
     * @generated
     */
    IAbstractSFailureModeLAnalysis getSFailureModeLAnalysis();

    /**
     * Sets the value of the
     * '{@link org.polarsys.esf.esflocalanalysis.ISDysfunctionalAssociation#getSFailureModeLAnalysis <em>SFailure Mode
     * LAnalysis</em>}' reference.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * 
     * @param value the new value of the '<em>SFailure Mode LAnalysis</em>' reference.
     * @see #getSFailureModeLAnalysis()
     * @generated
     */
    void setSFailureModeLAnalysis(IAbstractSFailureModeLAnalysis value);

    /**
     * Returns the value of the '<em><b>Base Connector</b></em>' reference.
     * <!-- begin-user-doc -->
     * <p>
     * If the meaning of the '<em>Base Connector</em>' reference isn't clear,
     * there really should be more of a description here...
     * </p>
     * <!-- end-user-doc -->
     * 
     * @return the value of the '<em>Base Connector</em>' reference.
     * @see #setBase_Connector(Connector)
     * @see org.polarsys.esf.esflocalanalysis.IESFLocalAnalysisPackage#getSDysfunctionalAssociation_Base_Connector()
     * @model required="true" ordered="false"
     * @generated
     */
    Connector getBase_Connector();

    /**
     * Sets the value of the '{@link org.polarsys.esf.esflocalanalysis.ISDysfunctionalAssociation#getBase_Connector
     * <em>Base Connector</em>}' reference.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * 
     * @param value the new value of the '<em>Base Connector</em>' reference.
     * @see #getBase_Connector()
     * @generated
     */
    void setBase_Connector(Connector value);

    /**
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * <!-- begin-model-doc -->
     * sPortSLAnalysis OR sBarrierLAnalysis
     * 
     * @param diagnostics The chain of diagnostics to which problems are to be appended.
     * @param context The cache of context-specific information.
     * <!-- end-model-doc -->
     * @model
     * @generated
     */
    boolean Constraint1(DiagnosticChain diagnostics, Map<Object, Object> context);

} // ISDysfunctionalAssociation
