/*******************************************************************************
 * Copyright (c) 2016 ALL4TEC & CEA LIST.
 * All rights reserved. This program and the accompanying materials
 * are made available under the terms of the Eclipse Public License v1.0
 * which accompanies this distribution, and is available at
 * http://www.eclipse.org/legal/epl-v10.html
 *   
 * Contributors:
 *      ALL4TEC & CEA LIST - initial API and implementation
 *******************************************************************************/
package org.polarsys.esf.esflocalanalysis;

import org.eclipse.uml2.uml.Property;

import org.polarsys.esf.esfsafetyconcepts.sdysfuctions.ISFailureEvent;

/**
 * <!-- begin-user-doc -->
 * A representation of the model object '<em><b>SFailure Event LAnalysis</b></em>'.
 * <!-- end-user-doc -->
 *
 * <p>
 * The following features are supported:
 * </p>
 * <ul>
 * <li>{@link org.polarsys.esf.esflocalanalysis.ISFailureEventLAnalysis#getSFailure <em>SFailure</em>}</li>
 * <li>{@link org.polarsys.esf.esflocalanalysis.ISFailureEventLAnalysis#getBase_Property <em>Base Property</em>}</li>
 * <li>{@link org.polarsys.esf.esflocalanalysis.ISFailureEventLAnalysis#getSBlockLAnalysis <em>SBlock
 * LAnalysis</em>}</li>
 * </ul>
 *
 * @see org.polarsys.esf.esflocalanalysis.IESFLocalAnalysisPackage#getSFailureEventLAnalysis()
 * @model
 * @generated
 */
public interface ISFailureEventLAnalysis
    extends IAbstractSPropagationElement {

    /**
     * Returns the value of the '<em><b>SFailure</b></em>' reference.
     * <!-- begin-user-doc -->
     * <p>
     * If the meaning of the '<em>SFailure</em>' reference isn't clear,
     * there really should be more of a description here...
     * </p>
     * <!-- end-user-doc -->
     * 
     * @return the value of the '<em>SFailure</em>' reference.
     * @see #setSFailure(ISFailureEvent)
     * @see org.polarsys.esf.esflocalanalysis.IESFLocalAnalysisPackage#getSFailureEventLAnalysis_SFailure()
     * @model ordered="false"
     * @generated
     */
    ISFailureEvent getSFailure();

    /**
     * Sets the value of the '{@link org.polarsys.esf.esflocalanalysis.ISFailureEventLAnalysis#getSFailure
     * <em>SFailure</em>}' reference.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * 
     * @param value the new value of the '<em>SFailure</em>' reference.
     * @see #getSFailure()
     * @generated
     */
    void setSFailure(ISFailureEvent value);

    /**
     * Returns the value of the '<em><b>Base Property</b></em>' reference.
     * <!-- begin-user-doc -->
     * <p>
     * If the meaning of the '<em>Base Property</em>' reference isn't clear,
     * there really should be more of a description here...
     * </p>
     * <!-- end-user-doc -->
     * 
     * @return the value of the '<em>Base Property</em>' reference.
     * @see #setBase_Property(Property)
     * @see org.polarsys.esf.esflocalanalysis.IESFLocalAnalysisPackage#getSFailureEventLAnalysis_Base_Property()
     * @model required="true" ordered="false"
     * @generated
     */
    Property getBase_Property();

    /**
     * Sets the value of the '{@link org.polarsys.esf.esflocalanalysis.ISFailureEventLAnalysis#getBase_Property <em>Base
     * Property</em>}' reference.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * 
     * @param value the new value of the '<em>Base Property</em>' reference.
     * @see #getBase_Property()
     * @generated
     */
    void setBase_Property(Property value);

    /**
     * Returns the value of the '<em><b>SBlock LAnalysis</b></em>' container reference.
     * It is bidirectional and its opposite is
     * '{@link org.polarsys.esf.esflocalanalysis.ISBlockLAnalysis#getSFailureEventLAnalysis <em>SFailure Event
     * LAnalysis</em>}'.
     * <!-- begin-user-doc -->
     * <p>
     * If the meaning of the '<em>SBlock LAnalysis</em>' container reference isn't clear,
     * there really should be more of a description here...
     * </p>
     * <!-- end-user-doc -->
     * 
     * @return the value of the '<em>SBlock LAnalysis</em>' container reference.
     * @see #setSBlockLAnalysis(ISBlockLAnalysis)
     * @see org.polarsys.esf.esflocalanalysis.IESFLocalAnalysisPackage#getSFailureEventLAnalysis_SBlockLAnalysis()
     * @see org.polarsys.esf.esflocalanalysis.ISBlockLAnalysis#getSFailureEventLAnalysis
     * @model opposite="sFailureEventLAnalysis" required="true" transient="false" ordered="false"
     * @generated
     */
    ISBlockLAnalysis getSBlockLAnalysis();

    /**
     * Sets the value of the '{@link org.polarsys.esf.esflocalanalysis.ISFailureEventLAnalysis#getSBlockLAnalysis
     * <em>SBlock LAnalysis</em>}' container reference.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * 
     * @param value the new value of the '<em>SBlock LAnalysis</em>' container reference.
     * @see #getSBlockLAnalysis()
     * @generated
     */
    void setSBlockLAnalysis(ISBlockLAnalysis value);

} // ISFailureEventLAnalysis
