/*******************************************************************************
 * Copyright (c) 2016 ALL4TEC & CEA LIST.
 * All rights reserved. This program and the accompanying materials
 * are made available under the terms of the Eclipse Public License v1.0
 * which accompanies this distribution, and is available at
 * http://www.eclipse.org/legal/epl-v10.html
 *   
 * Contributors:
 *      ALL4TEC & CEA LIST - initial API and implementation
 *******************************************************************************/
package org.polarsys.esf.esflocalanalysis;

import org.eclipse.emf.common.util.EList;

import org.eclipse.uml2.uml.Port;

import org.polarsys.esf.esfarchitectureconcepts.ISPort;

/**
 * <!-- begin-user-doc -->
 * A representation of the model object '<em><b>SPort LAnalysis</b></em>'.
 * <!-- end-user-doc -->
 *
 * <p>
 * The following features are supported:
 * </p>
 * <ul>
 * <li>{@link org.polarsys.esf.esflocalanalysis.ISPortLAnalysis#getSFailureModesLAnalysisList <em>SFailure Modes
 * LAnalysis List</em>}</li>
 * <li>{@link org.polarsys.esf.esflocalanalysis.ISPortLAnalysis#getSBlockLAnalysis <em>SBlock LAnalysis</em>}</li>
 * <li>{@link org.polarsys.esf.esflocalanalysis.ISPortLAnalysis#getSPort <em>SPort</em>}</li>
 * <li>{@link org.polarsys.esf.esflocalanalysis.ISPortLAnalysis#getBase_Port <em>Base Port</em>}</li>
 * <li>{@link org.polarsys.esf.esflocalanalysis.ISPortLAnalysis#getSDirectionLAnalysis <em>SDirection
 * LAnalysis</em>}</li>
 * </ul>
 *
 * @see org.polarsys.esf.esflocalanalysis.IESFLocalAnalysisPackage#getSPortLAnalysis()
 * @model
 * @generated
 */
public interface ISPortLAnalysis
    extends IAbstractSLocalAnalysisElement {

    /**
     * Returns the value of the '<em><b>SFailure Modes LAnalysis List</b></em>' reference list.
     * The list contents are of type {@link org.polarsys.esf.esflocalanalysis.IAbstractSFailureModeLAnalysis}.
     * <!-- begin-user-doc -->
     * <p>
     * If the meaning of the '<em>SFailure Modes LAnalysis List</em>' reference list isn't clear,
     * there really should be more of a description here...
     * </p>
     * <!-- end-user-doc -->
     * 
     * @return the value of the '<em>SFailure Modes LAnalysis List</em>' reference list.
     * @see org.polarsys.esf.esflocalanalysis.IESFLocalAnalysisPackage#getSPortLAnalysis_SFailureModesLAnalysisList()
     * @model ordered="false"
     * @generated
     */
    EList<IAbstractSFailureModeLAnalysis> getSFailureModesLAnalysisList();

    /**
     * Returns the value of the '<em><b>SBlock LAnalysis</b></em>' container reference.
     * It is bidirectional and its opposite is
     * '{@link org.polarsys.esf.esflocalanalysis.ISBlockLAnalysis#getSPortLAnalysis <em>SPort LAnalysis</em>}'.
     * <!-- begin-user-doc -->
     * <p>
     * If the meaning of the '<em>SBlock LAnalysis</em>' container reference isn't clear,
     * there really should be more of a description here...
     * </p>
     * <!-- end-user-doc -->
     * 
     * @return the value of the '<em>SBlock LAnalysis</em>' container reference.
     * @see #setSBlockLAnalysis(ISBlockLAnalysis)
     * @see org.polarsys.esf.esflocalanalysis.IESFLocalAnalysisPackage#getSPortLAnalysis_SBlockLAnalysis()
     * @see org.polarsys.esf.esflocalanalysis.ISBlockLAnalysis#getSPortLAnalysis
     * @model opposite="sPortLAnalysis" required="true" transient="false" ordered="false"
     * @generated
     */
    ISBlockLAnalysis getSBlockLAnalysis();

    /**
     * Sets the value of the '{@link org.polarsys.esf.esflocalanalysis.ISPortLAnalysis#getSBlockLAnalysis <em>SBlock
     * LAnalysis</em>}' container reference.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * 
     * @param value the new value of the '<em>SBlock LAnalysis</em>' container reference.
     * @see #getSBlockLAnalysis()
     * @generated
     */
    void setSBlockLAnalysis(ISBlockLAnalysis value);

    /**
     * Returns the value of the '<em><b>SPort</b></em>' reference.
     * <!-- begin-user-doc -->
     * <p>
     * If the meaning of the '<em>SPort</em>' reference isn't clear,
     * there really should be more of a description here...
     * </p>
     * <!-- end-user-doc -->
     * 
     * @return the value of the '<em>SPort</em>' reference.
     * @see #setSPort(ISPort)
     * @see org.polarsys.esf.esflocalanalysis.IESFLocalAnalysisPackage#getSPortLAnalysis_SPort()
     * @model required="true" ordered="false"
     * @generated
     */
    ISPort getSPort();

    /**
     * Sets the value of the '{@link org.polarsys.esf.esflocalanalysis.ISPortLAnalysis#getSPort <em>SPort</em>}'
     * reference.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * 
     * @param value the new value of the '<em>SPort</em>' reference.
     * @see #getSPort()
     * @generated
     */
    void setSPort(ISPort value);

    /**
     * Returns the value of the '<em><b>Base Port</b></em>' reference.
     * <!-- begin-user-doc -->
     * <p>
     * If the meaning of the '<em>Base Port</em>' reference isn't clear,
     * there really should be more of a description here...
     * </p>
     * <!-- end-user-doc -->
     * 
     * @return the value of the '<em>Base Port</em>' reference.
     * @see #setBase_Port(Port)
     * @see org.polarsys.esf.esflocalanalysis.IESFLocalAnalysisPackage#getSPortLAnalysis_Base_Port()
     * @model required="true" ordered="false"
     * @generated
     */
    Port getBase_Port();

    /**
     * Sets the value of the '{@link org.polarsys.esf.esflocalanalysis.ISPortLAnalysis#getBase_Port <em>Base Port</em>}'
     * reference.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * 
     * @param value the new value of the '<em>Base Port</em>' reference.
     * @see #getBase_Port()
     * @generated
     */
    void setBase_Port(Port value);

    /**
     * Returns the value of the '<em><b>SDirection LAnalysis</b></em>' attribute.
     * The literals are from the enumeration {@link org.polarsys.esf.esflocalanalysis.SDirectionLAnalysis}.
     * <!-- begin-user-doc -->
     * <p>
     * If the meaning of the '<em>SDirection LAnalysis</em>' attribute isn't clear,
     * there really should be more of a description here...
     * </p>
     * <!-- end-user-doc -->
     * 
     * @return the value of the '<em>SDirection LAnalysis</em>' attribute.
     * @see org.polarsys.esf.esflocalanalysis.SDirectionLAnalysis
     * @see #setSDirectionLAnalysis(SDirectionLAnalysis)
     * @see org.polarsys.esf.esflocalanalysis.IESFLocalAnalysisPackage#getSPortLAnalysis_SDirectionLAnalysis()
     * @model required="true" ordered="false"
     * @generated
     */
    SDirectionLAnalysis getSDirectionLAnalysis();

    /**
     * Sets the value of the '{@link org.polarsys.esf.esflocalanalysis.ISPortLAnalysis#getSDirectionLAnalysis
     * <em>SDirection LAnalysis</em>}' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * 
     * @param value the new value of the '<em>SDirection LAnalysis</em>' attribute.
     * @see org.polarsys.esf.esflocalanalysis.SDirectionLAnalysis
     * @see #getSDirectionLAnalysis()
     * @generated
     */
    void setSDirectionLAnalysis(SDirectionLAnalysis value);

} // ISPortLAnalysis
