/*******************************************************************************
 * Copyright (c) 2016 ALL4TEC & CEA LIST.
 * All rights reserved. This program and the accompanying materials
 * are made available under the terms of the Eclipse Public License v1.0
 * which accompanies this distribution, and is available at
 * http://www.eclipse.org/legal/epl-v10.html
 *   
 * Contributors:
 *      ALL4TEC & CEA LIST - initial API and implementation
 *******************************************************************************/
package org.polarsys.esf.esflocalanalysis;

import org.eclipse.uml2.uml.Connector;

/**
 * <!-- begin-user-doc -->
 * A representation of the model object '<em><b>SPropagation Link</b></em>'.
 * <!-- end-user-doc -->
 *
 * <p>
 * The following features are supported:
 * </p>
 * <ul>
 * <li>{@link org.polarsys.esf.esflocalanalysis.ISPropagationLink#getElementTarget <em>Element Target</em>}</li>
 * <li>{@link org.polarsys.esf.esflocalanalysis.ISPropagationLink#getBase_Connector <em>Base Connector</em>}</li>
 * <li>{@link org.polarsys.esf.esflocalanalysis.ISPropagationLink#getSBlockLAnalysis <em>SBlock LAnalysis</em>}</li>
 * <li>{@link org.polarsys.esf.esflocalanalysis.ISPropagationLink#getElementSource <em>Element Source</em>}</li>
 * </ul>
 *
 * @see org.polarsys.esf.esflocalanalysis.IESFLocalAnalysisPackage#getSPropagationLink()
 * @model
 * @generated
 */
public interface ISPropagationLink
    extends IAbstractSLocalAnalysisElement {

    /**
     * Returns the value of the '<em><b>Element Target</b></em>' reference.
     * It is bidirectional and its opposite is
     * '{@link org.polarsys.esf.esflocalanalysis.IAbstractSPropagationElement#getInSPropagationLinksList <em>In
     * SPropagation Links List</em>}'.
     * <!-- begin-user-doc -->
     * <p>
     * If the meaning of the '<em>Element Target</em>' reference isn't clear,
     * there really should be more of a description here...
     * </p>
     * <!-- end-user-doc -->
     * 
     * @return the value of the '<em>Element Target</em>' reference.
     * @see #setElementTarget(IAbstractSPropagationElement)
     * @see org.polarsys.esf.esflocalanalysis.IESFLocalAnalysisPackage#getSPropagationLink_ElementTarget()
     * @see org.polarsys.esf.esflocalanalysis.IAbstractSPropagationElement#getInSPropagationLinksList
     * @model opposite="inSPropagationLinksList" required="true" ordered="false"
     * @generated
     */
    IAbstractSPropagationElement getElementTarget();

    /**
     * Sets the value of the '{@link org.polarsys.esf.esflocalanalysis.ISPropagationLink#getElementTarget <em>Element
     * Target</em>}' reference.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * 
     * @param value the new value of the '<em>Element Target</em>' reference.
     * @see #getElementTarget()
     * @generated
     */
    void setElementTarget(IAbstractSPropagationElement value);

    /**
     * Returns the value of the '<em><b>Base Connector</b></em>' reference.
     * <!-- begin-user-doc -->
     * <p>
     * If the meaning of the '<em>Base Connector</em>' reference isn't clear,
     * there really should be more of a description here...
     * </p>
     * <!-- end-user-doc -->
     * 
     * @return the value of the '<em>Base Connector</em>' reference.
     * @see #setBase_Connector(Connector)
     * @see org.polarsys.esf.esflocalanalysis.IESFLocalAnalysisPackage#getSPropagationLink_Base_Connector()
     * @model required="true" ordered="false"
     * @generated
     */
    Connector getBase_Connector();

    /**
     * Sets the value of the '{@link org.polarsys.esf.esflocalanalysis.ISPropagationLink#getBase_Connector <em>Base
     * Connector</em>}' reference.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * 
     * @param value the new value of the '<em>Base Connector</em>' reference.
     * @see #getBase_Connector()
     * @generated
     */
    void setBase_Connector(Connector value);

    /**
     * Returns the value of the '<em><b>SBlock LAnalysis</b></em>' container reference.
     * It is bidirectional and its opposite is
     * '{@link org.polarsys.esf.esflocalanalysis.ISBlockLAnalysis#getSPropagationLinksList <em>SPropagation Links
     * List</em>}'.
     * <!-- begin-user-doc -->
     * <p>
     * If the meaning of the '<em>SBlock LAnalysis</em>' container reference isn't clear,
     * there really should be more of a description here...
     * </p>
     * <!-- end-user-doc -->
     * 
     * @return the value of the '<em>SBlock LAnalysis</em>' container reference.
     * @see #setSBlockLAnalysis(ISBlockLAnalysis)
     * @see org.polarsys.esf.esflocalanalysis.IESFLocalAnalysisPackage#getSPropagationLink_SBlockLAnalysis()
     * @see org.polarsys.esf.esflocalanalysis.ISBlockLAnalysis#getSPropagationLinksList
     * @model opposite="sPropagationLinksList" required="true" transient="false" ordered="false"
     * @generated
     */
    ISBlockLAnalysis getSBlockLAnalysis();

    /**
     * Sets the value of the '{@link org.polarsys.esf.esflocalanalysis.ISPropagationLink#getSBlockLAnalysis <em>SBlock
     * LAnalysis</em>}' container reference.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * 
     * @param value the new value of the '<em>SBlock LAnalysis</em>' container reference.
     * @see #getSBlockLAnalysis()
     * @generated
     */
    void setSBlockLAnalysis(ISBlockLAnalysis value);

    /**
     * Returns the value of the '<em><b>Element Source</b></em>' reference.
     * It is bidirectional and its opposite is
     * '{@link org.polarsys.esf.esflocalanalysis.IAbstractSPropagationElement#getOutSPropagationLinksList <em>Out
     * SPropagation Links List</em>}'.
     * <!-- begin-user-doc -->
     * <p>
     * If the meaning of the '<em>Element Source</em>' reference isn't clear,
     * there really should be more of a description here...
     * </p>
     * <!-- end-user-doc -->
     * 
     * @return the value of the '<em>Element Source</em>' reference.
     * @see #setElementSource(IAbstractSPropagationElement)
     * @see org.polarsys.esf.esflocalanalysis.IESFLocalAnalysisPackage#getSPropagationLink_ElementSource()
     * @see org.polarsys.esf.esflocalanalysis.IAbstractSPropagationElement#getOutSPropagationLinksList
     * @model opposite="outSPropagationLinksList" required="true" ordered="false"
     * @generated
     */
    IAbstractSPropagationElement getElementSource();

    /**
     * Sets the value of the '{@link org.polarsys.esf.esflocalanalysis.ISPropagationLink#getElementSource <em>Element
     * Source</em>}' reference.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * 
     * @param value the new value of the '<em>Element Source</em>' reference.
     * @see #getElementSource()
     * @generated
     */
    void setElementSource(IAbstractSPropagationElement value);

} // ISPropagationLink
