/*******************************************************************************
 * Copyright (c) 2016 ALL4TEC & CEA LIST.
 * All rights reserved. This program and the accompanying materials
 * are made available under the terms of the Eclipse Public License v1.0
 * which accompanies this distribution, and is available at
 * http://www.eclipse.org/legal/epl-v10.html
 *   
 * Contributors:
 *      ALL4TEC & CEA LIST - initial API and implementation
 *******************************************************************************/
package org.polarsys.esf.esflocalanalysis.impl;

import org.eclipse.emf.common.notify.Notification;
import org.eclipse.emf.common.notify.NotificationChain;

import org.eclipse.emf.ecore.EClass;
import org.eclipse.emf.ecore.InternalEObject;

import org.eclipse.emf.ecore.impl.ENotificationImpl;

import org.eclipse.emf.ecore.util.EcoreUtil;

import org.polarsys.esf.esflocalanalysis.IAbstractSFailureEventLAnalysis;
import org.polarsys.esf.esflocalanalysis.IESFLocalAnalysisPackage;
import org.polarsys.esf.esflocalanalysis.ISBlockLAnalysis;

import org.polarsys.esf.esfsafetyconcepts.sdysfuctions.ISFailureEvent;

/**
 * <!-- begin-user-doc -->
 * An implementation of the model object '<em><b>Abstract SFailure Event LAnalysis</b></em>'.
 * <!-- end-user-doc -->
 * <p>
 * The following features are implemented:
 * </p>
 * <ul>
 * <li>{@link org.polarsys.esf.esflocalanalysis.impl.AbstractSFailureEventLAnalysis#getSFailure <em>SFailure</em>}</li>
 * <li>{@link org.polarsys.esf.esflocalanalysis.impl.AbstractSFailureEventLAnalysis#getSBlockLAnalysis <em>SBlock
 * LAnalysis</em>}</li>
 * </ul>
 *
 * @generated
 */
public abstract class AbstractSFailureEventLAnalysis
    extends AbstractSPropagationElement
    implements IAbstractSFailureEventLAnalysis {

    /**
     * The cached value of the '{@link #getSFailure() <em>SFailure</em>}' reference.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * 
     * @see #getSFailure()
     * @generated
     * @ordered
     */
    protected ISFailureEvent sFailure;

    /**
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * 
     * @generated
     */
    protected AbstractSFailureEventLAnalysis() {
        super();
    }

    /**
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * 
     * @generated
     */
    @Override
    protected EClass eStaticClass() {
        return IESFLocalAnalysisPackage.Literals.ABSTRACT_SFAILURE_EVENT_LANALYSIS;
    }

    /**
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * 
     * @generated
     */
    public ISFailureEvent getSFailure() {
        if (sFailure != null && sFailure.eIsProxy()) {
            InternalEObject oldSFailure = (InternalEObject) sFailure;
            sFailure = (ISFailureEvent) eResolveProxy(oldSFailure);
            if (sFailure != oldSFailure) {
                if (eNotificationRequired())
                    eNotify(
                        new ENotificationImpl(
                            this,
                            Notification.RESOLVE,
                            IESFLocalAnalysisPackage.ABSTRACT_SFAILURE_EVENT_LANALYSIS__SFAILURE,
                            oldSFailure,
                            sFailure));
            }
        }
        return sFailure;
    }

    /**
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * 
     * @generated
     */
    public ISFailureEvent basicGetSFailure() {
        return sFailure;
    }

    /**
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * 
     * @generated
     */
    public void setSFailure(ISFailureEvent newSFailure) {
        ISFailureEvent oldSFailure = sFailure;
        sFailure = newSFailure;
        if (eNotificationRequired())
            eNotify(
                new ENotificationImpl(
                    this,
                    Notification.SET,
                    IESFLocalAnalysisPackage.ABSTRACT_SFAILURE_EVENT_LANALYSIS__SFAILURE,
                    oldSFailure,
                    sFailure));
    }

    /**
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * 
     * @generated
     */
    public ISBlockLAnalysis getSBlockLAnalysis() {
        if (eContainerFeatureID() != IESFLocalAnalysisPackage.ABSTRACT_SFAILURE_EVENT_LANALYSIS__SBLOCK_LANALYSIS)
            return null;
        return (ISBlockLAnalysis) eInternalContainer();
    }

    /**
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * 
     * @generated
     */
    public NotificationChain basicSetSBlockLAnalysis(ISBlockLAnalysis newSBlockLAnalysis, NotificationChain msgs) {
        msgs = eBasicSetContainer(
            (InternalEObject) newSBlockLAnalysis,
            IESFLocalAnalysisPackage.ABSTRACT_SFAILURE_EVENT_LANALYSIS__SBLOCK_LANALYSIS,
            msgs);
        return msgs;
    }

    /**
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * 
     * @generated
     */
    public void setSBlockLAnalysis(ISBlockLAnalysis newSBlockLAnalysis) {
        if (newSBlockLAnalysis != eInternalContainer()
            || (eContainerFeatureID() != IESFLocalAnalysisPackage.ABSTRACT_SFAILURE_EVENT_LANALYSIS__SBLOCK_LANALYSIS
                && newSBlockLAnalysis != null)) {
            if (EcoreUtil.isAncestor(this, newSBlockLAnalysis))
                throw new IllegalArgumentException("Recursive containment not allowed for " + toString()); //$NON-NLS-1$
            NotificationChain msgs = null;
            if (eInternalContainer() != null)
                msgs = eBasicRemoveFromContainer(msgs);
            if (newSBlockLAnalysis != null)
                msgs = ((InternalEObject) newSBlockLAnalysis).eInverseAdd(
                    this,
                    IESFLocalAnalysisPackage.SBLOCK_LANALYSIS__SFAILURE_EVENTS_LANALYSIS_LIST,
                    ISBlockLAnalysis.class,
                    msgs);
            msgs = basicSetSBlockLAnalysis(newSBlockLAnalysis, msgs);
            if (msgs != null)
                msgs.dispatch();
        } else if (eNotificationRequired())
            eNotify(
                new ENotificationImpl(
                    this,
                    Notification.SET,
                    IESFLocalAnalysisPackage.ABSTRACT_SFAILURE_EVENT_LANALYSIS__SBLOCK_LANALYSIS,
                    newSBlockLAnalysis,
                    newSBlockLAnalysis));
    }

    /**
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * 
     * @generated
     */
    @Override
    public NotificationChain eInverseAdd(InternalEObject otherEnd, int featureID, NotificationChain msgs) {
        switch (featureID) {
            case IESFLocalAnalysisPackage.ABSTRACT_SFAILURE_EVENT_LANALYSIS__SBLOCK_LANALYSIS:
                if (eInternalContainer() != null)
                    msgs = eBasicRemoveFromContainer(msgs);
                return basicSetSBlockLAnalysis((ISBlockLAnalysis) otherEnd, msgs);
        }
        return super.eInverseAdd(otherEnd, featureID, msgs);
    }

    /**
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * 
     * @generated
     */
    @Override
    public NotificationChain eInverseRemove(InternalEObject otherEnd, int featureID, NotificationChain msgs) {
        switch (featureID) {
            case IESFLocalAnalysisPackage.ABSTRACT_SFAILURE_EVENT_LANALYSIS__SBLOCK_LANALYSIS:
                return basicSetSBlockLAnalysis(null, msgs);
        }
        return super.eInverseRemove(otherEnd, featureID, msgs);
    }

    /**
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * 
     * @generated
     */
    @Override
    public NotificationChain eBasicRemoveFromContainerFeature(NotificationChain msgs) {
        switch (eContainerFeatureID()) {
            case IESFLocalAnalysisPackage.ABSTRACT_SFAILURE_EVENT_LANALYSIS__SBLOCK_LANALYSIS:
                return eInternalContainer().eInverseRemove(
                    this,
                    IESFLocalAnalysisPackage.SBLOCK_LANALYSIS__SFAILURE_EVENTS_LANALYSIS_LIST,
                    ISBlockLAnalysis.class,
                    msgs);
        }
        return super.eBasicRemoveFromContainerFeature(msgs);
    }

    /**
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * 
     * @generated
     */
    @Override
    public Object eGet(int featureID, boolean resolve, boolean coreType) {
        switch (featureID) {
            case IESFLocalAnalysisPackage.ABSTRACT_SFAILURE_EVENT_LANALYSIS__SFAILURE:
                if (resolve)
                    return getSFailure();
                return basicGetSFailure();
            case IESFLocalAnalysisPackage.ABSTRACT_SFAILURE_EVENT_LANALYSIS__SBLOCK_LANALYSIS:
                return getSBlockLAnalysis();
        }
        return super.eGet(featureID, resolve, coreType);
    }

    /**
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * 
     * @generated
     */
    @Override
    public void eSet(int featureID, Object newValue) {
        switch (featureID) {
            case IESFLocalAnalysisPackage.ABSTRACT_SFAILURE_EVENT_LANALYSIS__SFAILURE:
                setSFailure((ISFailureEvent) newValue);
                return;
            case IESFLocalAnalysisPackage.ABSTRACT_SFAILURE_EVENT_LANALYSIS__SBLOCK_LANALYSIS:
                setSBlockLAnalysis((ISBlockLAnalysis) newValue);
                return;
        }
        super.eSet(featureID, newValue);
    }

    /**
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * 
     * @generated
     */
    @Override
    public void eUnset(int featureID) {
        switch (featureID) {
            case IESFLocalAnalysisPackage.ABSTRACT_SFAILURE_EVENT_LANALYSIS__SFAILURE:
                setSFailure((ISFailureEvent) null);
                return;
            case IESFLocalAnalysisPackage.ABSTRACT_SFAILURE_EVENT_LANALYSIS__SBLOCK_LANALYSIS:
                setSBlockLAnalysis((ISBlockLAnalysis) null);
                return;
        }
        super.eUnset(featureID);
    }

    /**
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * 
     * @generated
     */
    @Override
    public boolean eIsSet(int featureID) {
        switch (featureID) {
            case IESFLocalAnalysisPackage.ABSTRACT_SFAILURE_EVENT_LANALYSIS__SFAILURE:
                return sFailure != null;
            case IESFLocalAnalysisPackage.ABSTRACT_SFAILURE_EVENT_LANALYSIS__SBLOCK_LANALYSIS:
                return getSBlockLAnalysis() != null;
        }
        return super.eIsSet(featureID);
    }

} // AbstractSFailureEventLAnalysis
