/*******************************************************************************
 * Copyright (c) 2016 ALL4TEC & CEA LIST.
 * All rights reserved. This program and the accompanying materials
 * are made available under the terms of the Eclipse Public License v1.0
 * which accompanies this distribution, and is available at
 * http://www.eclipse.org/legal/epl-v10.html
 *   
 * Contributors:
 *      ALL4TEC & CEA LIST - initial API and implementation
 *******************************************************************************/
package org.polarsys.esf.esflocalanalysis.impl;

import org.eclipse.emf.common.notify.Notification;
import org.eclipse.emf.common.notify.NotificationChain;

import org.eclipse.emf.ecore.EClass;
import org.eclipse.emf.ecore.InternalEObject;

import org.eclipse.emf.ecore.impl.ENotificationImpl;

import org.eclipse.emf.ecore.util.EcoreUtil;

import org.polarsys.esf.esflocalanalysis.IAbstractSFailureModeLAnalysis;
import org.polarsys.esf.esflocalanalysis.IESFLocalAnalysisPackage;
import org.polarsys.esf.esflocalanalysis.ISBlockLAnalysis;

import org.polarsys.esf.esfsafetyconcepts.sdysfuctions.ISFailureMode;

/**
 * <!-- begin-user-doc -->
 * An implementation of the model object '<em><b>Abstract SFailure Mode LAnalysis</b></em>'.
 * <!-- end-user-doc -->
 * <p>
 * The following features are implemented:
 * </p>
 * <ul>
 * <li>{@link org.polarsys.esf.esflocalanalysis.impl.AbstractSFailureModeLAnalysis#getSBlockLAnalysis <em>SBlock
 * LAnalysis</em>}</li>
 * <li>{@link org.polarsys.esf.esflocalanalysis.impl.AbstractSFailureModeLAnalysis#getSFailureMode <em>SFailure
 * Mode</em>}</li>
 * </ul>
 *
 * @generated
 */
public abstract class AbstractSFailureModeLAnalysis
    extends AbstractSPropagationElement
    implements IAbstractSFailureModeLAnalysis {

    /**
     * The cached value of the '{@link #getSFailureMode() <em>SFailure Mode</em>}' reference.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * 
     * @see #getSFailureMode()
     * @generated
     * @ordered
     */
    protected ISFailureMode sFailureMode;

    /**
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * 
     * @generated
     */
    protected AbstractSFailureModeLAnalysis() {
        super();
    }

    /**
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * 
     * @generated
     */
    @Override
    protected EClass eStaticClass() {
        return IESFLocalAnalysisPackage.Literals.ABSTRACT_SFAILURE_MODE_LANALYSIS;
    }

    /**
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * 
     * @generated
     */
    public ISBlockLAnalysis getSBlockLAnalysis() {
        if (eContainerFeatureID() != IESFLocalAnalysisPackage.ABSTRACT_SFAILURE_MODE_LANALYSIS__SBLOCK_LANALYSIS)
            return null;
        return (ISBlockLAnalysis) eInternalContainer();
    }

    /**
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * 
     * @generated
     */
    public NotificationChain basicSetSBlockLAnalysis(ISBlockLAnalysis newSBlockLAnalysis, NotificationChain msgs) {
        msgs = eBasicSetContainer(
            (InternalEObject) newSBlockLAnalysis,
            IESFLocalAnalysisPackage.ABSTRACT_SFAILURE_MODE_LANALYSIS__SBLOCK_LANALYSIS,
            msgs);
        return msgs;
    }

    /**
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * 
     * @generated
     */
    public void setSBlockLAnalysis(ISBlockLAnalysis newSBlockLAnalysis) {
        if (newSBlockLAnalysis != eInternalContainer()
            || (eContainerFeatureID() != IESFLocalAnalysisPackage.ABSTRACT_SFAILURE_MODE_LANALYSIS__SBLOCK_LANALYSIS
                && newSBlockLAnalysis != null)) {
            if (EcoreUtil.isAncestor(this, newSBlockLAnalysis))
                throw new IllegalArgumentException("Recursive containment not allowed for " + toString()); //$NON-NLS-1$
            NotificationChain msgs = null;
            if (eInternalContainer() != null)
                msgs = eBasicRemoveFromContainer(msgs);
            if (newSBlockLAnalysis != null)
                msgs = ((InternalEObject) newSBlockLAnalysis).eInverseAdd(
                    this,
                    IESFLocalAnalysisPackage.SBLOCK_LANALYSIS__SFAILURE_MODES_LANALYSIS_LIST,
                    ISBlockLAnalysis.class,
                    msgs);
            msgs = basicSetSBlockLAnalysis(newSBlockLAnalysis, msgs);
            if (msgs != null)
                msgs.dispatch();
        } else if (eNotificationRequired())
            eNotify(
                new ENotificationImpl(
                    this,
                    Notification.SET,
                    IESFLocalAnalysisPackage.ABSTRACT_SFAILURE_MODE_LANALYSIS__SBLOCK_LANALYSIS,
                    newSBlockLAnalysis,
                    newSBlockLAnalysis));
    }

    /**
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * 
     * @generated
     */
    public ISFailureMode getSFailureMode() {
        if (sFailureMode != null && sFailureMode.eIsProxy()) {
            InternalEObject oldSFailureMode = (InternalEObject) sFailureMode;
            sFailureMode = (ISFailureMode) eResolveProxy(oldSFailureMode);
            if (sFailureMode != oldSFailureMode) {
                if (eNotificationRequired())
                    eNotify(
                        new ENotificationImpl(
                            this,
                            Notification.RESOLVE,
                            IESFLocalAnalysisPackage.ABSTRACT_SFAILURE_MODE_LANALYSIS__SFAILURE_MODE,
                            oldSFailureMode,
                            sFailureMode));
            }
        }
        return sFailureMode;
    }

    /**
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * 
     * @generated
     */
    public ISFailureMode basicGetSFailureMode() {
        return sFailureMode;
    }

    /**
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * 
     * @generated
     */
    public void setSFailureMode(ISFailureMode newSFailureMode) {
        ISFailureMode oldSFailureMode = sFailureMode;
        sFailureMode = newSFailureMode;
        if (eNotificationRequired())
            eNotify(
                new ENotificationImpl(
                    this,
                    Notification.SET,
                    IESFLocalAnalysisPackage.ABSTRACT_SFAILURE_MODE_LANALYSIS__SFAILURE_MODE,
                    oldSFailureMode,
                    sFailureMode));
    }

    /**
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * 
     * @generated
     */
    @Override
    public NotificationChain eInverseAdd(InternalEObject otherEnd, int featureID, NotificationChain msgs) {
        switch (featureID) {
            case IESFLocalAnalysisPackage.ABSTRACT_SFAILURE_MODE_LANALYSIS__SBLOCK_LANALYSIS:
                if (eInternalContainer() != null)
                    msgs = eBasicRemoveFromContainer(msgs);
                return basicSetSBlockLAnalysis((ISBlockLAnalysis) otherEnd, msgs);
        }
        return super.eInverseAdd(otherEnd, featureID, msgs);
    }

    /**
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * 
     * @generated
     */
    @Override
    public NotificationChain eInverseRemove(InternalEObject otherEnd, int featureID, NotificationChain msgs) {
        switch (featureID) {
            case IESFLocalAnalysisPackage.ABSTRACT_SFAILURE_MODE_LANALYSIS__SBLOCK_LANALYSIS:
                return basicSetSBlockLAnalysis(null, msgs);
        }
        return super.eInverseRemove(otherEnd, featureID, msgs);
    }

    /**
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * 
     * @generated
     */
    @Override
    public NotificationChain eBasicRemoveFromContainerFeature(NotificationChain msgs) {
        switch (eContainerFeatureID()) {
            case IESFLocalAnalysisPackage.ABSTRACT_SFAILURE_MODE_LANALYSIS__SBLOCK_LANALYSIS:
                return eInternalContainer().eInverseRemove(
                    this,
                    IESFLocalAnalysisPackage.SBLOCK_LANALYSIS__SFAILURE_MODES_LANALYSIS_LIST,
                    ISBlockLAnalysis.class,
                    msgs);
        }
        return super.eBasicRemoveFromContainerFeature(msgs);
    }

    /**
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * 
     * @generated
     */
    @Override
    public Object eGet(int featureID, boolean resolve, boolean coreType) {
        switch (featureID) {
            case IESFLocalAnalysisPackage.ABSTRACT_SFAILURE_MODE_LANALYSIS__SBLOCK_LANALYSIS:
                return getSBlockLAnalysis();
            case IESFLocalAnalysisPackage.ABSTRACT_SFAILURE_MODE_LANALYSIS__SFAILURE_MODE:
                if (resolve)
                    return getSFailureMode();
                return basicGetSFailureMode();
        }
        return super.eGet(featureID, resolve, coreType);
    }

    /**
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * 
     * @generated
     */
    @Override
    public void eSet(int featureID, Object newValue) {
        switch (featureID) {
            case IESFLocalAnalysisPackage.ABSTRACT_SFAILURE_MODE_LANALYSIS__SBLOCK_LANALYSIS:
                setSBlockLAnalysis((ISBlockLAnalysis) newValue);
                return;
            case IESFLocalAnalysisPackage.ABSTRACT_SFAILURE_MODE_LANALYSIS__SFAILURE_MODE:
                setSFailureMode((ISFailureMode) newValue);
                return;
        }
        super.eSet(featureID, newValue);
    }

    /**
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * 
     * @generated
     */
    @Override
    public void eUnset(int featureID) {
        switch (featureID) {
            case IESFLocalAnalysisPackage.ABSTRACT_SFAILURE_MODE_LANALYSIS__SBLOCK_LANALYSIS:
                setSBlockLAnalysis((ISBlockLAnalysis) null);
                return;
            case IESFLocalAnalysisPackage.ABSTRACT_SFAILURE_MODE_LANALYSIS__SFAILURE_MODE:
                setSFailureMode((ISFailureMode) null);
                return;
        }
        super.eUnset(featureID);
    }

    /**
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * 
     * @generated
     */
    @Override
    public boolean eIsSet(int featureID) {
        switch (featureID) {
            case IESFLocalAnalysisPackage.ABSTRACT_SFAILURE_MODE_LANALYSIS__SBLOCK_LANALYSIS:
                return getSBlockLAnalysis() != null;
            case IESFLocalAnalysisPackage.ABSTRACT_SFAILURE_MODE_LANALYSIS__SFAILURE_MODE:
                return sFailureMode != null;
        }
        return super.eIsSet(featureID);
    }

} // AbstractSFailureModeLAnalysis
