/*******************************************************************************
 * Copyright (c) 2016 ALL4TEC & CEA LIST.
 * All rights reserved. This program and the accompanying materials
 * are made available under the terms of the Eclipse Public License v1.0
 * which accompanies this distribution, and is available at
 * http://www.eclipse.org/legal/epl-v10.html
 *   
 * Contributors:
 *      ALL4TEC & CEA LIST - initial API and implementation
 *******************************************************************************/
package org.polarsys.esf.esflocalanalysis.impl;

import java.util.Collection;

import org.eclipse.emf.common.notify.Notification;
import org.eclipse.emf.common.notify.NotificationChain;

import org.eclipse.emf.common.util.EList;

import org.eclipse.emf.ecore.EClass;
import org.eclipse.emf.ecore.InternalEObject;

import org.eclipse.emf.ecore.impl.ENotificationImpl;

import org.eclipse.emf.ecore.util.EObjectWithInverseResolvingEList;
import org.eclipse.emf.ecore.util.InternalEList;

import org.polarsys.esf.esflocalanalysis.IAbstractSPropagationElement;
import org.polarsys.esf.esflocalanalysis.IESFLocalAnalysisPackage;
import org.polarsys.esf.esflocalanalysis.ISPropagationLink;

import org.polarsys.esf.esfproperties.ISOccurence;

/**
 * <!-- begin-user-doc -->
 * An implementation of the model object '<em><b>Abstract SPropagation Element</b></em>'.
 * <!-- end-user-doc -->
 * <p>
 * The following features are implemented:
 * </p>
 * <ul>
 * <li>{@link org.polarsys.esf.esflocalanalysis.impl.AbstractSPropagationElement#getSOccurency <em>SOccurency</em>}</li>
 * <li>{@link org.polarsys.esf.esflocalanalysis.impl.AbstractSPropagationElement#getOutSPropagationLinksList <em>Out
 * SPropagation Links List</em>}</li>
 * <li>{@link org.polarsys.esf.esflocalanalysis.impl.AbstractSPropagationElement#getInSPropagationLinksList <em>In
 * SPropagation Links List</em>}</li>
 * </ul>
 *
 * @generated
 */
public abstract class AbstractSPropagationElement
    extends AbstractSLocalAnalysisElement
    implements IAbstractSPropagationElement {

    /**
     * The cached value of the '{@link #getSOccurency() <em>SOccurency</em>}' reference.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * 
     * @see #getSOccurency()
     * @generated
     * @ordered
     */
    protected ISOccurence sOccurency;

    /**
     * The cached value of the '{@link #getOutSPropagationLinksList() <em>Out SPropagation Links List</em>}' reference
     * list.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * 
     * @see #getOutSPropagationLinksList()
     * @generated
     * @ordered
     */
    protected EList<ISPropagationLink> outSPropagationLinksList;

    /**
     * The cached value of the '{@link #getInSPropagationLinksList() <em>In SPropagation Links List</em>}' reference
     * list.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * 
     * @see #getInSPropagationLinksList()
     * @generated
     * @ordered
     */
    protected EList<ISPropagationLink> inSPropagationLinksList;

    /**
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * 
     * @generated
     */
    protected AbstractSPropagationElement() {
        super();
    }

    /**
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * 
     * @generated
     */
    @Override
    protected EClass eStaticClass() {
        return IESFLocalAnalysisPackage.Literals.ABSTRACT_SPROPAGATION_ELEMENT;
    }

    /**
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * 
     * @generated
     */
    public ISOccurence getSOccurency() {
        if (sOccurency != null && sOccurency.eIsProxy()) {
            InternalEObject oldSOccurency = (InternalEObject) sOccurency;
            sOccurency = (ISOccurence) eResolveProxy(oldSOccurency);
            if (sOccurency != oldSOccurency) {
                if (eNotificationRequired())
                    eNotify(
                        new ENotificationImpl(
                            this,
                            Notification.RESOLVE,
                            IESFLocalAnalysisPackage.ABSTRACT_SPROPAGATION_ELEMENT__SOCCURENCY,
                            oldSOccurency,
                            sOccurency));
            }
        }
        return sOccurency;
    }

    /**
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * 
     * @generated
     */
    public ISOccurence basicGetSOccurency() {
        return sOccurency;
    }

    /**
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * 
     * @generated
     */
    public void setSOccurency(ISOccurence newSOccurency) {
        ISOccurence oldSOccurency = sOccurency;
        sOccurency = newSOccurency;
        if (eNotificationRequired())
            eNotify(
                new ENotificationImpl(
                    this,
                    Notification.SET,
                    IESFLocalAnalysisPackage.ABSTRACT_SPROPAGATION_ELEMENT__SOCCURENCY,
                    oldSOccurency,
                    sOccurency));
    }

    /**
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * 
     * @generated
     */
    public EList<ISPropagationLink> getOutSPropagationLinksList() {
        if (outSPropagationLinksList == null) {
            outSPropagationLinksList = new EObjectWithInverseResolvingEList<ISPropagationLink>(
                ISPropagationLink.class,
                this,
                IESFLocalAnalysisPackage.ABSTRACT_SPROPAGATION_ELEMENT__OUT_SPROPAGATION_LINKS_LIST,
                IESFLocalAnalysisPackage.SPROPAGATION_LINK__ELEMENT_SOURCE);
        }
        return outSPropagationLinksList;
    }

    /**
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * 
     * @generated
     */
    public EList<ISPropagationLink> getInSPropagationLinksList() {
        if (inSPropagationLinksList == null) {
            inSPropagationLinksList = new EObjectWithInverseResolvingEList<ISPropagationLink>(
                ISPropagationLink.class,
                this,
                IESFLocalAnalysisPackage.ABSTRACT_SPROPAGATION_ELEMENT__IN_SPROPAGATION_LINKS_LIST,
                IESFLocalAnalysisPackage.SPROPAGATION_LINK__ELEMENT_TARGET);
        }
        return inSPropagationLinksList;
    }

    /**
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * 
     * @generated
     */
    @SuppressWarnings("unchecked")
    @Override
    public NotificationChain eInverseAdd(InternalEObject otherEnd, int featureID, NotificationChain msgs) {
        switch (featureID) {
            case IESFLocalAnalysisPackage.ABSTRACT_SPROPAGATION_ELEMENT__OUT_SPROPAGATION_LINKS_LIST:
                return ((InternalEList<InternalEObject>) (InternalEList<?>) getOutSPropagationLinksList())
                    .basicAdd(otherEnd, msgs);
            case IESFLocalAnalysisPackage.ABSTRACT_SPROPAGATION_ELEMENT__IN_SPROPAGATION_LINKS_LIST:
                return ((InternalEList<InternalEObject>) (InternalEList<?>) getInSPropagationLinksList())
                    .basicAdd(otherEnd, msgs);
        }
        return super.eInverseAdd(otherEnd, featureID, msgs);
    }

    /**
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * 
     * @generated
     */
    @Override
    public NotificationChain eInverseRemove(InternalEObject otherEnd, int featureID, NotificationChain msgs) {
        switch (featureID) {
            case IESFLocalAnalysisPackage.ABSTRACT_SPROPAGATION_ELEMENT__OUT_SPROPAGATION_LINKS_LIST:
                return ((InternalEList<?>) getOutSPropagationLinksList()).basicRemove(otherEnd, msgs);
            case IESFLocalAnalysisPackage.ABSTRACT_SPROPAGATION_ELEMENT__IN_SPROPAGATION_LINKS_LIST:
                return ((InternalEList<?>) getInSPropagationLinksList()).basicRemove(otherEnd, msgs);
        }
        return super.eInverseRemove(otherEnd, featureID, msgs);
    }

    /**
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * 
     * @generated
     */
    @Override
    public Object eGet(int featureID, boolean resolve, boolean coreType) {
        switch (featureID) {
            case IESFLocalAnalysisPackage.ABSTRACT_SPROPAGATION_ELEMENT__SOCCURENCY:
                if (resolve)
                    return getSOccurency();
                return basicGetSOccurency();
            case IESFLocalAnalysisPackage.ABSTRACT_SPROPAGATION_ELEMENT__OUT_SPROPAGATION_LINKS_LIST:
                return getOutSPropagationLinksList();
            case IESFLocalAnalysisPackage.ABSTRACT_SPROPAGATION_ELEMENT__IN_SPROPAGATION_LINKS_LIST:
                return getInSPropagationLinksList();
        }
        return super.eGet(featureID, resolve, coreType);
    }

    /**
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * 
     * @generated
     */
    @SuppressWarnings("unchecked")
    @Override
    public void eSet(int featureID, Object newValue) {
        switch (featureID) {
            case IESFLocalAnalysisPackage.ABSTRACT_SPROPAGATION_ELEMENT__SOCCURENCY:
                setSOccurency((ISOccurence) newValue);
                return;
            case IESFLocalAnalysisPackage.ABSTRACT_SPROPAGATION_ELEMENT__OUT_SPROPAGATION_LINKS_LIST:
                getOutSPropagationLinksList().clear();
                getOutSPropagationLinksList().addAll((Collection<? extends ISPropagationLink>) newValue);
                return;
            case IESFLocalAnalysisPackage.ABSTRACT_SPROPAGATION_ELEMENT__IN_SPROPAGATION_LINKS_LIST:
                getInSPropagationLinksList().clear();
                getInSPropagationLinksList().addAll((Collection<? extends ISPropagationLink>) newValue);
                return;
        }
        super.eSet(featureID, newValue);
    }

    /**
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * 
     * @generated
     */
    @Override
    public void eUnset(int featureID) {
        switch (featureID) {
            case IESFLocalAnalysisPackage.ABSTRACT_SPROPAGATION_ELEMENT__SOCCURENCY:
                setSOccurency((ISOccurence) null);
                return;
            case IESFLocalAnalysisPackage.ABSTRACT_SPROPAGATION_ELEMENT__OUT_SPROPAGATION_LINKS_LIST:
                getOutSPropagationLinksList().clear();
                return;
            case IESFLocalAnalysisPackage.ABSTRACT_SPROPAGATION_ELEMENT__IN_SPROPAGATION_LINKS_LIST:
                getInSPropagationLinksList().clear();
                return;
        }
        super.eUnset(featureID);
    }

    /**
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * 
     * @generated
     */
    @Override
    public boolean eIsSet(int featureID) {
        switch (featureID) {
            case IESFLocalAnalysisPackage.ABSTRACT_SPROPAGATION_ELEMENT__SOCCURENCY:
                return sOccurency != null;
            case IESFLocalAnalysisPackage.ABSTRACT_SPROPAGATION_ELEMENT__OUT_SPROPAGATION_LINKS_LIST:
                return outSPropagationLinksList != null && !outSPropagationLinksList.isEmpty();
            case IESFLocalAnalysisPackage.ABSTRACT_SPROPAGATION_ELEMENT__IN_SPROPAGATION_LINKS_LIST:
                return inSPropagationLinksList != null && !inSPropagationLinksList.isEmpty();
        }
        return super.eIsSet(featureID);
    }

} // AbstractSPropagationElement
