/*******************************************************************************
 * Copyright (c) 2016 ALL4TEC & CEA LIST.
 * All rights reserved. This program and the accompanying materials
 * are made available under the terms of the Eclipse Public License v1.0
 * which accompanies this distribution, and is available at
 * http://www.eclipse.org/legal/epl-v10.html
 *   
 * Contributors:
 *      ALL4TEC & CEA LIST - initial API and implementation
 *******************************************************************************/
package org.polarsys.esf.esflocalanalysis.impl;

import org.eclipse.emf.ecore.EClass;
import org.eclipse.emf.ecore.EDataType;
import org.eclipse.emf.ecore.EObject;
import org.eclipse.emf.ecore.EPackage;

import org.eclipse.emf.ecore.impl.EFactoryImpl;

import org.eclipse.emf.ecore.plugin.EcorePlugin;

import org.polarsys.esf.esflocalanalysis.*;

/**
 * <!-- begin-user-doc -->
 * An implementation of the model <b>Factory</b>.
 * <!-- end-user-doc -->
 * 
 * @generated
 */
public class ESFLocalAnalysisFactory
    extends EFactoryImpl
    implements IESFLocalAnalysisFactory {

    /**
     * Creates the default factory implementation.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * 
     * @generated
     */
    public static IESFLocalAnalysisFactory init() {
        try {
            IESFLocalAnalysisFactory theESFLocalAnalysisFactory =
                (IESFLocalAnalysisFactory) EPackage.Registry.INSTANCE.getEFactory(IESFLocalAnalysisPackage.eNS_URI);
            if (theESFLocalAnalysisFactory != null) {
                return theESFLocalAnalysisFactory;
            }
        } catch (Exception exception) {
            EcorePlugin.INSTANCE.log(exception);
        }
        return new ESFLocalAnalysisFactory();
    }

    /**
     * Creates an instance of the factory.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * 
     * @generated
     */
    public ESFLocalAnalysisFactory() {
        super();
    }

    /**
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * 
     * @generated
     */
    @Override
    public EObject create(EClass eClass) {
        switch (eClass.getClassifierID()) {
            case IESFLocalAnalysisPackage.SPORT_LANALYSIS:
                return createSPortLAnalysis();
            case IESFLocalAnalysisPackage.SPROPAGATION_LINK:
                return createSPropagationLink();
            case IESFLocalAnalysisPackage.SBLOCK_LANALYSIS:
                return createSBlockLAnalysis();
            case IESFLocalAnalysisPackage.SBARRIER_LANALYSIS:
                return createSBarrierLAnalysis();
            case IESFLocalAnalysisPackage.SLOCAL_ANALYSIS:
                return createSLocalAnalysis();
            case IESFLocalAnalysisPackage.SSYSTEM_EVENTS_LIBRARY:
                return createSSystemEventsLibrary();
            case IESFLocalAnalysisPackage.SSYSTEM_EVENT_TYPE:
                return createSSystemEventType();
            case IESFLocalAnalysisPackage.SSYSTEM_EVENT:
                return createSSystemEvent();
            case IESFLocalAnalysisPackage.SDYSFUNCTIONAL_ASSOCIATION:
                return createSDysfunctionalAssociation();
            case IESFLocalAnalysisPackage.SAND_GATE_LANALYSIS:
                return createSAndGateLAnalysis();
            case IESFLocalAnalysisPackage.SOR_GATE_LANALYSIS:
                return createSOrGateLAnalysis();
            case IESFLocalAnalysisPackage.SULTIMELY_FAILURE_MODE:
                return createSUltimelyFailureMode();
            case IESFLocalAnalysisPackage.SABSENT_FAILURE_MODE:
                return createSAbsentFailureMode();
            case IESFLocalAnalysisPackage.SERRONEOUS_FAILURE_MODE:
                return createSErroneousFailureMode();
            case IESFLocalAnalysisPackage.SLOCAL_EVENT:
                return createSLocalEvent();
            default:
                throw new IllegalArgumentException("The class '" + eClass.getName() + "' is not a valid classifier"); //$NON-NLS-1$ //$NON-NLS-2$
        }
    }

    /**
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * 
     * @generated
     */
    @Override
    public Object createFromString(EDataType eDataType, String initialValue) {
        switch (eDataType.getClassifierID()) {
            case IESFLocalAnalysisPackage.SDIRECTION_LANALYSIS:
                return createSDirectionLAnalysisFromString(eDataType, initialValue);
            default:
                throw new IllegalArgumentException(
                    "The datatype '" + eDataType.getName() + "' is not a valid classifier"); //$NON-NLS-1$ //$NON-NLS-2$
        }
    }

    /**
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * 
     * @generated
     */
    @Override
    public String convertToString(EDataType eDataType, Object instanceValue) {
        switch (eDataType.getClassifierID()) {
            case IESFLocalAnalysisPackage.SDIRECTION_LANALYSIS:
                return convertSDirectionLAnalysisToString(eDataType, instanceValue);
            default:
                throw new IllegalArgumentException(
                    "The datatype '" + eDataType.getName() + "' is not a valid classifier"); //$NON-NLS-1$ //$NON-NLS-2$
        }
    }

    /**
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * 
     * @generated
     */
    public ISPortLAnalysis createSPortLAnalysis() {
        SPortLAnalysis sPortLAnalysis = new SPortLAnalysis();
        return sPortLAnalysis;
    }

    /**
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * 
     * @generated
     */
    public ISPropagationLink createSPropagationLink() {
        SPropagationLink sPropagationLink = new SPropagationLink();
        return sPropagationLink;
    }

    /**
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * 
     * @generated
     */
    public ISLocalAnalysis createSLocalAnalysis() {
        SLocalAnalysis sLocalAnalysis = new SLocalAnalysis();
        return sLocalAnalysis;
    }

    /**
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * 
     * @generated
     */
    public ISSystemEventsLibrary createSSystemEventsLibrary() {
        SSystemEventsLibrary sSystemEventsLibrary = new SSystemEventsLibrary();
        return sSystemEventsLibrary;
    }

    /**
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * 
     * @generated
     */
    public ISSystemEventType createSSystemEventType() {
        SSystemEventType sSystemEventType = new SSystemEventType();
        return sSystemEventType;
    }

    /**
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * 
     * @generated
     */
    public ISSystemEvent createSSystemEvent() {
        SSystemEvent sSystemEvent = new SSystemEvent();
        return sSystemEvent;
    }

    /**
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * 
     * @generated
     */
    public ISBlockLAnalysis createSBlockLAnalysis() {
        SBlockLAnalysis sBlockLAnalysis = new SBlockLAnalysis();
        return sBlockLAnalysis;
    }

    /**
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * 
     * @generated
     */
    public ISBarrierLAnalysis createSBarrierLAnalysis() {
        SBarrierLAnalysis sBarrierLAnalysis = new SBarrierLAnalysis();
        return sBarrierLAnalysis;
    }

    /**
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * 
     * @generated
     */
    public ISDysfunctionalAssociation createSDysfunctionalAssociation() {
        SDysfunctionalAssociation sDysfunctionalAssociation = new SDysfunctionalAssociation();
        return sDysfunctionalAssociation;
    }

    /**
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * 
     * @generated
     */
    public ISAndGateLAnalysis createSAndGateLAnalysis() {
        SAndGateLAnalysis sAndGateLAnalysis = new SAndGateLAnalysis();
        return sAndGateLAnalysis;
    }

    /**
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * 
     * @generated
     */
    public ISOrGateLAnalysis createSOrGateLAnalysis() {
        SOrGateLAnalysis sOrGateLAnalysis = new SOrGateLAnalysis();
        return sOrGateLAnalysis;
    }

    /**
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * 
     * @generated
     */
    public ISUltimelyFailureMode createSUltimelyFailureMode() {
        SUltimelyFailureMode sUltimelyFailureMode = new SUltimelyFailureMode();
        return sUltimelyFailureMode;
    }

    /**
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * 
     * @generated
     */
    public ISAbsentFailureMode createSAbsentFailureMode() {
        SAbsentFailureMode sAbsentFailureMode = new SAbsentFailureMode();
        return sAbsentFailureMode;
    }

    /**
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * 
     * @generated
     */
    public ISErroneousFailureMode createSErroneousFailureMode() {
        SErroneousFailureMode sErroneousFailureMode = new SErroneousFailureMode();
        return sErroneousFailureMode;
    }

    /**
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * 
     * @generated
     */
    public ISLocalEvent createSLocalEvent() {
        SLocalEvent sLocalEvent = new SLocalEvent();
        return sLocalEvent;
    }

    /**
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * 
     * @generated
     */
    public SDirectionLAnalysis createSDirectionLAnalysisFromString(EDataType eDataType, String initialValue) {
        SDirectionLAnalysis result = SDirectionLAnalysis.get(initialValue);
        if (result == null)
            throw new IllegalArgumentException(
                "The value '" + initialValue + "' is not a valid enumerator of '" + eDataType.getName() + "'"); //$NON-NLS-1$ //$NON-NLS-2$ //$NON-NLS-3$
        return result;
    }

    /**
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * 
     * @generated
     */
    public String convertSDirectionLAnalysisToString(EDataType eDataType, Object instanceValue) {
        return instanceValue == null ? null : instanceValue.toString();
    }

    /**
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * 
     * @generated
     */
    public IESFLocalAnalysisPackage getESFLocalAnalysisPackage() {
        return (IESFLocalAnalysisPackage) getEPackage();
    }

    /**
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * 
     * @deprecated
     * @generated
     */
    @Deprecated
    public static IESFLocalAnalysisPackage getPackage() {
        return IESFLocalAnalysisPackage.eINSTANCE;
    }

} // ESFLocalAnalysisFactory
