/*******************************************************************************
 * Copyright (c) 2016 ALL4TEC & CEA LIST.
 * All rights reserved. This program and the accompanying materials
 * are made available under the terms of the Eclipse Public License v1.0
 * which accompanies this distribution, and is available at
 * http://www.eclipse.org/legal/epl-v10.html
 *   
 * Contributors:
 *      ALL4TEC & CEA LIST - initial API and implementation
 *******************************************************************************/
package org.polarsys.esf.esflocalanalysis.impl;

import org.eclipse.emf.ecore.EAttribute;
import org.eclipse.emf.ecore.EClass;
import org.eclipse.emf.ecore.EEnum;
import org.eclipse.emf.ecore.EGenericType;
import org.eclipse.emf.ecore.EOperation;
import org.eclipse.emf.ecore.EPackage;
import org.eclipse.emf.ecore.EReference;
import org.eclipse.emf.ecore.EValidator;

import org.eclipse.emf.ecore.impl.EPackageImpl;

import org.eclipse.uml2.uml.UMLPackage;

import org.polarsys.esf.esfarchitectureconcepts.IESFArchitectureConceptsPackage;

import org.polarsys.esf.esfcore.IESFCorePackage;

import org.polarsys.esf.esflocalanalysis.IAbstractSFailureEventLAnalysis;
import org.polarsys.esf.esflocalanalysis.IAbstractSFailureModeLAnalysis;
import org.polarsys.esf.esflocalanalysis.IAbstractSLocalAnalysisElement;
import org.polarsys.esf.esflocalanalysis.IAbstractSLogicalGateLAnalysis;
import org.polarsys.esf.esflocalanalysis.IAbstractSPropagationElement;
import org.polarsys.esf.esflocalanalysis.IESFLocalAnalysisFactory;
import org.polarsys.esf.esflocalanalysis.IESFLocalAnalysisPackage;
import org.polarsys.esf.esflocalanalysis.ISAbsentFailureMode;
import org.polarsys.esf.esflocalanalysis.ISAndGateLAnalysis;
import org.polarsys.esf.esflocalanalysis.ISBarrierLAnalysis;
import org.polarsys.esf.esflocalanalysis.ISBlockLAnalysis;
import org.polarsys.esf.esflocalanalysis.ISDysfunctionalAssociation;
import org.polarsys.esf.esflocalanalysis.ISErroneousFailureMode;
import org.polarsys.esf.esflocalanalysis.ISLocalAnalysis;
import org.polarsys.esf.esflocalanalysis.ISLocalEvent;
import org.polarsys.esf.esflocalanalysis.ISOrGateLAnalysis;
import org.polarsys.esf.esflocalanalysis.ISPortLAnalysis;
import org.polarsys.esf.esflocalanalysis.ISPropagationLink;
import org.polarsys.esf.esflocalanalysis.ISSystemEvent;
import org.polarsys.esf.esflocalanalysis.ISSystemEventType;
import org.polarsys.esf.esflocalanalysis.ISSystemEventsLibrary;
import org.polarsys.esf.esflocalanalysis.ISUltimelyFailureMode;
import org.polarsys.esf.esflocalanalysis.SDirectionLAnalysis;

import org.polarsys.esf.esflocalanalysis.util.ESFLocalAnalysisValidator;

import org.polarsys.esf.esfproperties.IESFPropertiesPackage;

import org.polarsys.esf.esfsafetyconcepts.IESFSafetyConceptsPackage;

import org.polarsys.esf.esfsafetyconcepts.sdysfuctions.ISDysfunctionsPackage;

import org.polarsys.esf.esfsafetyconcepts.srecommendations.ISRecommendationsPackage;

/**
 * <!-- begin-user-doc -->
 * An implementation of the model <b>Package</b>.
 * <!-- end-user-doc -->
 * 
 * @generated
 */
public class ESFLocalAnalysisPackage
    extends EPackageImpl
    implements IESFLocalAnalysisPackage {

    /**
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * 
     * @generated
     */
    private EClass abstractSLocalAnalysisElementEClass = null;

    /**
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * 
     * @generated
     */
    private EClass sPortLAnalysisEClass = null;

    /**
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * 
     * @generated
     */
    private EClass abstractSFailureModeLAnalysisEClass = null;

    /**
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * 
     * @generated
     */
    private EClass abstractSPropagationElementEClass = null;

    /**
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * 
     * @generated
     */
    private EClass sPropagationLinkEClass = null;

    /**
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * 
     * @generated
     */
    private EClass sLocalAnalysisEClass = null;

    /**
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * 
     * @generated
     */
    private EClass sSystemEventsLibraryEClass = null;

    /**
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * 
     * @generated
     */
    private EClass sSystemEventTypeEClass = null;

    /**
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * 
     * @generated
     */
    private EClass sSystemEventEClass = null;

    /**
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * 
     * @generated
     */
    private EClass sBlockLAnalysisEClass = null;

    /**
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * 
     * @generated
     */
    private EClass abstractSFailureEventLAnalysisEClass = null;

    /**
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * 
     * @generated
     */
    private EClass abstractSLogicalGateLAnalysisEClass = null;

    /**
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * 
     * @generated
     */
    private EClass sBarrierLAnalysisEClass = null;

    /**
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * 
     * @generated
     */
    private EClass sDysfunctionalAssociationEClass = null;

    /**
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * 
     * @generated
     */
    private EClass sAndGateLAnalysisEClass = null;

    /**
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * 
     * @generated
     */
    private EClass sOrGateLAnalysisEClass = null;

    /**
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * 
     * @generated
     */
    private EClass sUltimelyFailureModeEClass = null;

    /**
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * 
     * @generated
     */
    private EClass sAbsentFailureModeEClass = null;

    /**
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * 
     * @generated
     */
    private EClass sErroneousFailureModeEClass = null;

    /**
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * 
     * @generated
     */
    private EClass sLocalEventEClass = null;

    /**
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * 
     * @generated
     */
    private EEnum sDirectionLAnalysisEEnum = null;

    /**
     * Creates an instance of the model <b>Package</b>, registered with
     * {@link org.eclipse.emf.ecore.EPackage.Registry EPackage.Registry} by the package
     * package URI value.
     * <p>
     * Note: the correct way to create the package is via the static
     * factory method {@link #init init()}, which also performs
     * initialization of the package, or returns the registered package,
     * if one already exists.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * 
     * @see org.eclipse.emf.ecore.EPackage.Registry
     * @see org.polarsys.esf.esflocalanalysis.IESFLocalAnalysisPackage#eNS_URI
     * @see #init()
     * @generated
     */
    private ESFLocalAnalysisPackage() {
        super(eNS_URI, IESFLocalAnalysisFactory.eINSTANCE);
    }

    /**
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * 
     * @generated
     */
    private static boolean isInited = false;

    /**
     * Creates, registers, and initializes the <b>Package</b> for this model, and for any others upon which it depends.
     * 
     * <p>
     * This method is used to initialize {@link IESFLocalAnalysisPackage#eINSTANCE} when that field is accessed.
     * Clients should not invoke it directly. Instead, they should simply access that field to obtain the package.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * 
     * @see #eNS_URI
     * @see #createPackageContents()
     * @see #initializePackageContents()
     * @generated
     */
    public static IESFLocalAnalysisPackage init() {
        if (isInited)
            return (IESFLocalAnalysisPackage) EPackage.Registry.INSTANCE.getEPackage(IESFLocalAnalysisPackage.eNS_URI);

        // Obtain or create and register package
        ESFLocalAnalysisPackage theESFLocalAnalysisPackage =
            (ESFLocalAnalysisPackage) (EPackage.Registry.INSTANCE.get(eNS_URI) instanceof ESFLocalAnalysisPackage
                ? EPackage.Registry.INSTANCE.get(eNS_URI)
                : new ESFLocalAnalysisPackage());

        isInited = true;

        // Initialize simple dependencies
        IESFArchitectureConceptsPackage.eINSTANCE.eClass();
        IESFSafetyConceptsPackage.eINSTANCE.eClass();

        // Create package meta-data objects
        theESFLocalAnalysisPackage.createPackageContents();

        // Initialize created meta-data
        theESFLocalAnalysisPackage.initializePackageContents();

        // Register package validator
        EValidator.Registry.INSTANCE.put(theESFLocalAnalysisPackage, new EValidator.Descriptor() {

            public EValidator getEValidator() {
                return ESFLocalAnalysisValidator.INSTANCE;
            }
        });

        // Mark meta-data to indicate it can't be changed
        theESFLocalAnalysisPackage.freeze();

        // Update the registry and return the package
        EPackage.Registry.INSTANCE.put(IESFLocalAnalysisPackage.eNS_URI, theESFLocalAnalysisPackage);
        return theESFLocalAnalysisPackage;
    }

    /**
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * 
     * @generated
     */
    public EClass getAbstractSLocalAnalysisElement() {
        return abstractSLocalAnalysisElementEClass;
    }

    /**
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * 
     * @generated
     */
    public EClass getSPortLAnalysis() {
        return sPortLAnalysisEClass;
    }

    /**
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * 
     * @generated
     */
    public EReference getSPortLAnalysis_SFailureModesLAnalysisList() {
        return (EReference) sPortLAnalysisEClass.getEStructuralFeatures().get(0);
    }

    /**
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * 
     * @generated
     */
    public EReference getSPortLAnalysis_SBlockLAnalysis() {
        return (EReference) sPortLAnalysisEClass.getEStructuralFeatures().get(1);
    }

    /**
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * 
     * @generated
     */
    public EReference getSPortLAnalysis_SPort() {
        return (EReference) sPortLAnalysisEClass.getEStructuralFeatures().get(2);
    }

    /**
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * 
     * @generated
     */
    public EReference getSPortLAnalysis_Base_Port() {
        return (EReference) sPortLAnalysisEClass.getEStructuralFeatures().get(3);
    }

    /**
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * 
     * @generated
     */
    public EAttribute getSPortLAnalysis_SDirectionLAnalysis() {
        return (EAttribute) sPortLAnalysisEClass.getEStructuralFeatures().get(4);
    }

    /**
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * 
     * @generated
     */
    public EClass getAbstractSFailureModeLAnalysis() {
        return abstractSFailureModeLAnalysisEClass;
    }

    /**
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * 
     * @generated
     */
    public EReference getAbstractSFailureModeLAnalysis_SBlockLAnalysis() {
        return (EReference) abstractSFailureModeLAnalysisEClass.getEStructuralFeatures().get(0);
    }

    /**
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * 
     * @generated
     */
    public EReference getAbstractSFailureModeLAnalysis_SFailureMode() {
        return (EReference) abstractSFailureModeLAnalysisEClass.getEStructuralFeatures().get(1);
    }

    /**
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * 
     * @generated
     */
    public EClass getAbstractSPropagationElement() {
        return abstractSPropagationElementEClass;
    }

    /**
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * 
     * @generated
     */
    public EReference getAbstractSPropagationElement_SOccurency() {
        return (EReference) abstractSPropagationElementEClass.getEStructuralFeatures().get(0);
    }

    /**
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * 
     * @generated
     */
    public EReference getAbstractSPropagationElement_OutSPropagationLinksList() {
        return (EReference) abstractSPropagationElementEClass.getEStructuralFeatures().get(1);
    }

    /**
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * 
     * @generated
     */
    public EReference getAbstractSPropagationElement_InSPropagationLinksList() {
        return (EReference) abstractSPropagationElementEClass.getEStructuralFeatures().get(2);
    }

    /**
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * 
     * @generated
     */
    public EClass getSPropagationLink() {
        return sPropagationLinkEClass;
    }

    /**
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * 
     * @generated
     */
    public EReference getSPropagationLink_ElementTarget() {
        return (EReference) sPropagationLinkEClass.getEStructuralFeatures().get(0);
    }

    /**
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * 
     * @generated
     */
    public EReference getSPropagationLink_Base_Connector() {
        return (EReference) sPropagationLinkEClass.getEStructuralFeatures().get(1);
    }

    /**
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * 
     * @generated
     */
    public EReference getSPropagationLink_SBlockLAnalysis() {
        return (EReference) sPropagationLinkEClass.getEStructuralFeatures().get(2);
    }

    /**
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * 
     * @generated
     */
    public EReference getSPropagationLink_ElementSource() {
        return (EReference) sPropagationLinkEClass.getEStructuralFeatures().get(3);
    }

    /**
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * 
     * @generated
     */
    public EClass getSLocalAnalysis() {
        return sLocalAnalysisEClass;
    }

    /**
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * 
     * @generated
     */
    public EReference getSLocalAnalysis_SBlocksLAnalysisList() {
        return (EReference) sLocalAnalysisEClass.getEStructuralFeatures().get(0);
    }

    /**
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * 
     * @generated
     */
    public EReference getSLocalAnalysis_Base_Package() {
        return (EReference) sLocalAnalysisEClass.getEStructuralFeatures().get(1);
    }

    /**
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * 
     * @generated
     */
    public EReference getSLocalAnalysis_SSystemEventsLibrary() {
        return (EReference) sLocalAnalysisEClass.getEStructuralFeatures().get(2);
    }

    /**
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * 
     * @generated
     */
    public EClass getSSystemEventsLibrary() {
        return sSystemEventsLibraryEClass;
    }

    /**
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * 
     * @generated
     */
    public EReference getSSystemEventsLibrary_Base_Package() {
        return (EReference) sSystemEventsLibraryEClass.getEStructuralFeatures().get(0);
    }

    /**
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * 
     * @generated
     */
    public EReference getSSystemEventsLibrary_SSystemEventTypesList() {
        return (EReference) sSystemEventsLibraryEClass.getEStructuralFeatures().get(1);
    }

    /**
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * 
     * @generated
     */
    public EClass getSSystemEventType() {
        return sSystemEventTypeEClass;
    }

    /**
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * 
     * @generated
     */
    public EReference getSSystemEventType_Base_Class() {
        return (EReference) sSystemEventTypeEClass.getEStructuralFeatures().get(0);
    }

    /**
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * 
     * @generated
     */
    public EReference getSSystemEventType_SFailureEvent() {
        return (EReference) sSystemEventTypeEClass.getEStructuralFeatures().get(1);
    }

    /**
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * 
     * @generated
     */
    public EReference getSSystemEventType_InstancesList() {
        return (EReference) sSystemEventTypeEClass.getEStructuralFeatures().get(2);
    }

    /**
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * 
     * @generated
     */
    public EClass getSSystemEvent() {
        return sSystemEventEClass;
    }

    /**
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * 
     * @generated
     */
    public EReference getSSystemEvent_Base_Property() {
        return (EReference) sSystemEventEClass.getEStructuralFeatures().get(0);
    }

    /**
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * 
     * @generated
     */
    public EReference getSSystemEvent_Type() {
        return (EReference) sSystemEventEClass.getEStructuralFeatures().get(1);
    }

    /**
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * 
     * @generated
     */
    public EClass getSBlockLAnalysis() {
        return sBlockLAnalysisEClass;
    }

    /**
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * 
     * @generated
     */
    public EReference getSBlockLAnalysis_SBlock() {
        return (EReference) sBlockLAnalysisEClass.getEStructuralFeatures().get(0);
    }

    /**
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * 
     * @generated
     */
    public EReference getSBlockLAnalysis_SFailureEventsLAnalysisList() {
        return (EReference) sBlockLAnalysisEClass.getEStructuralFeatures().get(1);
    }

    /**
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * 
     * @generated
     */
    public EReference getSBlockLAnalysis_SPropagationLinksList() {
        return (EReference) sBlockLAnalysisEClass.getEStructuralFeatures().get(7);
    }

    /**
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * 
     * @generated
     */
    public EClass getAbstractSFailureEventLAnalysis() {
        return abstractSFailureEventLAnalysisEClass;
    }

    /**
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * 
     * @generated
     */
    public EReference getAbstractSFailureEventLAnalysis_SFailure() {
        return (EReference) abstractSFailureEventLAnalysisEClass.getEStructuralFeatures().get(0);
    }

    /**
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * 
     * @generated
     */
    public EReference getAbstractSFailureEventLAnalysis_SBlockLAnalysis() {
        return (EReference) abstractSFailureEventLAnalysisEClass.getEStructuralFeatures().get(1);
    }

    /**
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * 
     * @generated
     */
    public EReference getSBlockLAnalysis_SPortLAnalysis() {
        return (EReference) sBlockLAnalysisEClass.getEStructuralFeatures().get(2);
    }

    /**
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * 
     * @generated
     */
    public EReference getSBlockLAnalysis_Base_Class() {
        return (EReference) sBlockLAnalysisEClass.getEStructuralFeatures().get(3);
    }

    /**
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * 
     * @generated
     */
    public EReference getSBlockLAnalysis_SLogicalGatesLAnalysisList() {
        return (EReference) sBlockLAnalysisEClass.getEStructuralFeatures().get(4);
    }

    /**
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * 
     * @generated
     */
    public EReference getSBlockLAnalysis_SFailureModesLAnalysisList() {
        return (EReference) sBlockLAnalysisEClass.getEStructuralFeatures().get(5);
    }

    /**
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * 
     * @generated
     */
    public EReference getSBlockLAnalysis_SBarriersLAnalysisList() {
        return (EReference) sBlockLAnalysisEClass.getEStructuralFeatures().get(6);
    }

    /**
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * 
     * @generated
     */
    public EClass getAbstractSLogicalGateLAnalysis() {
        return abstractSLogicalGateLAnalysisEClass;
    }

    /**
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * 
     * @generated
     */
    public EReference getAbstractSLogicalGateLAnalysis_SBlockLAnalysis() {
        return (EReference) abstractSLogicalGateLAnalysisEClass.getEStructuralFeatures().get(0);
    }

    /**
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * 
     * @generated
     */
    public EClass getSBarrierLAnalysis() {
        return sBarrierLAnalysisEClass;
    }

    /**
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * 
     * @generated
     */
    public EReference getSBarrierLAnalysis_SBarrier() {
        return (EReference) sBarrierLAnalysisEClass.getEStructuralFeatures().get(0);
    }

    /**
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * 
     * @generated
     */
    public EReference getSBarrierLAnalysis_SFailureModesLAnalysisList() {
        return (EReference) sBarrierLAnalysisEClass.getEStructuralFeatures().get(1);
    }

    /**
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * 
     * @generated
     */
    public EReference getSBarrierLAnalysis_Base_Property() {
        return (EReference) sBarrierLAnalysisEClass.getEStructuralFeatures().get(2);
    }

    /**
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * 
     * @generated
     */
    public EReference getSBarrierLAnalysis_SBlockLAnalysis() {
        return (EReference) sBarrierLAnalysisEClass.getEStructuralFeatures().get(3);
    }

    /**
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * 
     * @generated
     */
    public EClass getSDysfunctionalAssociation() {
        return sDysfunctionalAssociationEClass;
    }

    /**
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * 
     * @generated
     */
    public EReference getSDysfunctionalAssociation_SPortLAnalysis() {
        return (EReference) sDysfunctionalAssociationEClass.getEStructuralFeatures().get(0);
    }

    /**
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * 
     * @generated
     */
    public EReference getSDysfunctionalAssociation_SBarrierLAnalysis() {
        return (EReference) sDysfunctionalAssociationEClass.getEStructuralFeatures().get(1);
    }

    /**
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * 
     * @generated
     */
    public EReference getSDysfunctionalAssociation_SFailureModeLAnalysis() {
        return (EReference) sDysfunctionalAssociationEClass.getEStructuralFeatures().get(2);
    }

    /**
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * 
     * @generated
     */
    public EReference getSDysfunctionalAssociation_Base_Connector() {
        return (EReference) sDysfunctionalAssociationEClass.getEStructuralFeatures().get(3);
    }

    /**
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * 
     * @generated
     */
    public EOperation getSDysfunctionalAssociation__Constraint1__DiagnosticChain_Map() {
        return sDysfunctionalAssociationEClass.getEOperations().get(0);
    }

    /**
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * 
     * @generated
     */
    public EClass getSAndGateLAnalysis() {
        return sAndGateLAnalysisEClass;
    }

    /**
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * 
     * @generated
     */
    public EReference getSAndGateLAnalysis_Base_Property() {
        return (EReference) sAndGateLAnalysisEClass.getEStructuralFeatures().get(0);
    }

    /**
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * 
     * @generated
     */
    public EClass getSOrGateLAnalysis() {
        return sOrGateLAnalysisEClass;
    }

    /**
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * 
     * @generated
     */
    public EReference getSOrGateLAnalysis_Base_Property() {
        return (EReference) sOrGateLAnalysisEClass.getEStructuralFeatures().get(0);
    }

    /**
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * 
     * @generated
     */
    public EClass getSUltimelyFailureMode() {
        return sUltimelyFailureModeEClass;
    }

    /**
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * 
     * @generated
     */
    public EReference getSUltimelyFailureMode_Base_Property() {
        return (EReference) sUltimelyFailureModeEClass.getEStructuralFeatures().get(0);
    }

    /**
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * 
     * @generated
     */
    public EClass getSAbsentFailureMode() {
        return sAbsentFailureModeEClass;
    }

    /**
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * 
     * @generated
     */
    public EReference getSAbsentFailureMode_Base_Property() {
        return (EReference) sAbsentFailureModeEClass.getEStructuralFeatures().get(0);
    }

    /**
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * 
     * @generated
     */
    public EClass getSErroneousFailureMode() {
        return sErroneousFailureModeEClass;
    }

    /**
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * 
     * @generated
     */
    public EReference getSErroneousFailureMode_Base_Property() {
        return (EReference) sErroneousFailureModeEClass.getEStructuralFeatures().get(0);
    }

    /**
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * 
     * @generated
     */
    public EClass getSLocalEvent() {
        return sLocalEventEClass;
    }

    /**
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * 
     * @generated
     */
    public EReference getSLocalEvent_Base_Property() {
        return (EReference) sLocalEventEClass.getEStructuralFeatures().get(0);
    }

    /**
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * 
     * @generated
     */
    public EEnum getSDirectionLAnalysis() {
        return sDirectionLAnalysisEEnum;
    }

    /**
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * 
     * @generated
     */
    public IESFLocalAnalysisFactory getESFLocalAnalysisFactory() {
        return (IESFLocalAnalysisFactory) getEFactoryInstance();
    }

    /**
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * 
     * @generated
     */
    private boolean isCreated = false;

    /**
     * Creates the meta-model objects for the package. This method is
     * guarded to have no affect on any invocation but its first.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * 
     * @generated
     */
    public void createPackageContents() {
        if (isCreated)
            return;
        isCreated = true;

        // Create classes and their features
        abstractSLocalAnalysisElementEClass = createEClass(ABSTRACT_SLOCAL_ANALYSIS_ELEMENT);

        sPortLAnalysisEClass = createEClass(SPORT_LANALYSIS);
        createEReference(sPortLAnalysisEClass, SPORT_LANALYSIS__SFAILURE_MODES_LANALYSIS_LIST);
        createEReference(sPortLAnalysisEClass, SPORT_LANALYSIS__SBLOCK_LANALYSIS);
        createEReference(sPortLAnalysisEClass, SPORT_LANALYSIS__SPORT);
        createEReference(sPortLAnalysisEClass, SPORT_LANALYSIS__BASE_PORT);
        createEAttribute(sPortLAnalysisEClass, SPORT_LANALYSIS__SDIRECTION_LANALYSIS);

        abstractSFailureModeLAnalysisEClass = createEClass(ABSTRACT_SFAILURE_MODE_LANALYSIS);
        createEReference(abstractSFailureModeLAnalysisEClass, ABSTRACT_SFAILURE_MODE_LANALYSIS__SBLOCK_LANALYSIS);
        createEReference(abstractSFailureModeLAnalysisEClass, ABSTRACT_SFAILURE_MODE_LANALYSIS__SFAILURE_MODE);

        abstractSPropagationElementEClass = createEClass(ABSTRACT_SPROPAGATION_ELEMENT);
        createEReference(abstractSPropagationElementEClass, ABSTRACT_SPROPAGATION_ELEMENT__SOCCURENCY);
        createEReference(abstractSPropagationElementEClass, ABSTRACT_SPROPAGATION_ELEMENT__OUT_SPROPAGATION_LINKS_LIST);
        createEReference(abstractSPropagationElementEClass, ABSTRACT_SPROPAGATION_ELEMENT__IN_SPROPAGATION_LINKS_LIST);

        sPropagationLinkEClass = createEClass(SPROPAGATION_LINK);
        createEReference(sPropagationLinkEClass, SPROPAGATION_LINK__ELEMENT_TARGET);
        createEReference(sPropagationLinkEClass, SPROPAGATION_LINK__BASE_CONNECTOR);
        createEReference(sPropagationLinkEClass, SPROPAGATION_LINK__SBLOCK_LANALYSIS);
        createEReference(sPropagationLinkEClass, SPROPAGATION_LINK__ELEMENT_SOURCE);

        sBlockLAnalysisEClass = createEClass(SBLOCK_LANALYSIS);
        createEReference(sBlockLAnalysisEClass, SBLOCK_LANALYSIS__SBLOCK);
        createEReference(sBlockLAnalysisEClass, SBLOCK_LANALYSIS__SFAILURE_EVENTS_LANALYSIS_LIST);
        createEReference(sBlockLAnalysisEClass, SBLOCK_LANALYSIS__SPORT_LANALYSIS);
        createEReference(sBlockLAnalysisEClass, SBLOCK_LANALYSIS__BASE_CLASS);
        createEReference(sBlockLAnalysisEClass, SBLOCK_LANALYSIS__SLOGICAL_GATES_LANALYSIS_LIST);
        createEReference(sBlockLAnalysisEClass, SBLOCK_LANALYSIS__SFAILURE_MODES_LANALYSIS_LIST);
        createEReference(sBlockLAnalysisEClass, SBLOCK_LANALYSIS__SBARRIERS_LANALYSIS_LIST);
        createEReference(sBlockLAnalysisEClass, SBLOCK_LANALYSIS__SPROPAGATION_LINKS_LIST);

        abstractSFailureEventLAnalysisEClass = createEClass(ABSTRACT_SFAILURE_EVENT_LANALYSIS);
        createEReference(abstractSFailureEventLAnalysisEClass, ABSTRACT_SFAILURE_EVENT_LANALYSIS__SFAILURE);
        createEReference(abstractSFailureEventLAnalysisEClass, ABSTRACT_SFAILURE_EVENT_LANALYSIS__SBLOCK_LANALYSIS);

        abstractSLogicalGateLAnalysisEClass = createEClass(ABSTRACT_SLOGICAL_GATE_LANALYSIS);
        createEReference(abstractSLogicalGateLAnalysisEClass, ABSTRACT_SLOGICAL_GATE_LANALYSIS__SBLOCK_LANALYSIS);

        sBarrierLAnalysisEClass = createEClass(SBARRIER_LANALYSIS);
        createEReference(sBarrierLAnalysisEClass, SBARRIER_LANALYSIS__SBARRIER);
        createEReference(sBarrierLAnalysisEClass, SBARRIER_LANALYSIS__SFAILURE_MODES_LANALYSIS_LIST);
        createEReference(sBarrierLAnalysisEClass, SBARRIER_LANALYSIS__BASE_PROPERTY);
        createEReference(sBarrierLAnalysisEClass, SBARRIER_LANALYSIS__SBLOCK_LANALYSIS);

        sLocalAnalysisEClass = createEClass(SLOCAL_ANALYSIS);
        createEReference(sLocalAnalysisEClass, SLOCAL_ANALYSIS__SBLOCKS_LANALYSIS_LIST);
        createEReference(sLocalAnalysisEClass, SLOCAL_ANALYSIS__BASE_PACKAGE);
        createEReference(sLocalAnalysisEClass, SLOCAL_ANALYSIS__SSYSTEM_EVENTS_LIBRARY);

        sSystemEventsLibraryEClass = createEClass(SSYSTEM_EVENTS_LIBRARY);
        createEReference(sSystemEventsLibraryEClass, SSYSTEM_EVENTS_LIBRARY__BASE_PACKAGE);
        createEReference(sSystemEventsLibraryEClass, SSYSTEM_EVENTS_LIBRARY__SSYSTEM_EVENT_TYPES_LIST);

        sSystemEventTypeEClass = createEClass(SSYSTEM_EVENT_TYPE);
        createEReference(sSystemEventTypeEClass, SSYSTEM_EVENT_TYPE__BASE_CLASS);
        createEReference(sSystemEventTypeEClass, SSYSTEM_EVENT_TYPE__SFAILURE_EVENT);
        createEReference(sSystemEventTypeEClass, SSYSTEM_EVENT_TYPE__INSTANCES_LIST);

        sSystemEventEClass = createEClass(SSYSTEM_EVENT);
        createEReference(sSystemEventEClass, SSYSTEM_EVENT__BASE_PROPERTY);
        createEReference(sSystemEventEClass, SSYSTEM_EVENT__TYPE);

        sDysfunctionalAssociationEClass = createEClass(SDYSFUNCTIONAL_ASSOCIATION);
        createEReference(sDysfunctionalAssociationEClass, SDYSFUNCTIONAL_ASSOCIATION__SPORT_LANALYSIS);
        createEReference(sDysfunctionalAssociationEClass, SDYSFUNCTIONAL_ASSOCIATION__SBARRIER_LANALYSIS);
        createEReference(sDysfunctionalAssociationEClass, SDYSFUNCTIONAL_ASSOCIATION__SFAILURE_MODE_LANALYSIS);
        createEReference(sDysfunctionalAssociationEClass, SDYSFUNCTIONAL_ASSOCIATION__BASE_CONNECTOR);
        createEOperation(
            sDysfunctionalAssociationEClass,
            SDYSFUNCTIONAL_ASSOCIATION___CONSTRAINT1__DIAGNOSTICCHAIN_MAP);

        sAndGateLAnalysisEClass = createEClass(SAND_GATE_LANALYSIS);
        createEReference(sAndGateLAnalysisEClass, SAND_GATE_LANALYSIS__BASE_PROPERTY);

        sOrGateLAnalysisEClass = createEClass(SOR_GATE_LANALYSIS);
        createEReference(sOrGateLAnalysisEClass, SOR_GATE_LANALYSIS__BASE_PROPERTY);

        sUltimelyFailureModeEClass = createEClass(SULTIMELY_FAILURE_MODE);
        createEReference(sUltimelyFailureModeEClass, SULTIMELY_FAILURE_MODE__BASE_PROPERTY);

        sAbsentFailureModeEClass = createEClass(SABSENT_FAILURE_MODE);
        createEReference(sAbsentFailureModeEClass, SABSENT_FAILURE_MODE__BASE_PROPERTY);

        sErroneousFailureModeEClass = createEClass(SERRONEOUS_FAILURE_MODE);
        createEReference(sErroneousFailureModeEClass, SERRONEOUS_FAILURE_MODE__BASE_PROPERTY);

        sLocalEventEClass = createEClass(SLOCAL_EVENT);
        createEReference(sLocalEventEClass, SLOCAL_EVENT__BASE_PROPERTY);

        // Create enums
        sDirectionLAnalysisEEnum = createEEnum(SDIRECTION_LANALYSIS);
    }

    /**
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * 
     * @generated
     */
    private boolean isInitialized = false;

    /**
     * Complete the initialization of the package and its meta-model. This
     * method is guarded to have no affect on any invocation but its first.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * 
     * @generated
     */
    public void initializePackageContents() {
        if (isInitialized)
            return;
        isInitialized = true;

        // Initialize package
        setName(eNAME);
        setNsPrefix(eNS_PREFIX);
        setNsURI(eNS_URI);

        // Obtain other dependent packages
        IESFCorePackage theESFCorePackage =
            (IESFCorePackage) EPackage.Registry.INSTANCE.getEPackage(IESFCorePackage.eNS_URI);
        IESFArchitectureConceptsPackage theESFArchitectureConceptsPackage =
            (IESFArchitectureConceptsPackage) EPackage.Registry.INSTANCE
                .getEPackage(IESFArchitectureConceptsPackage.eNS_URI);
        UMLPackage theUMLPackage = (UMLPackage) EPackage.Registry.INSTANCE.getEPackage(UMLPackage.eNS_URI);
        ISDysfunctionsPackage theSDysfunctionsPackage =
            (ISDysfunctionsPackage) EPackage.Registry.INSTANCE.getEPackage(ISDysfunctionsPackage.eNS_URI);
        IESFPropertiesPackage theESFPropertiesPackage =
            (IESFPropertiesPackage) EPackage.Registry.INSTANCE.getEPackage(IESFPropertiesPackage.eNS_URI);
        ISRecommendationsPackage theSRecommendationsPackage =
            (ISRecommendationsPackage) EPackage.Registry.INSTANCE.getEPackage(ISRecommendationsPackage.eNS_URI);

        // Create type parameters

        // Set bounds for type parameters

        // Add supertypes to classes
        abstractSLocalAnalysisElementEClass.getESuperTypes().add(theESFCorePackage.getAbstractSSafetyConcept());
        sPortLAnalysisEClass.getESuperTypes().add(this.getAbstractSLocalAnalysisElement());
        abstractSFailureModeLAnalysisEClass.getESuperTypes().add(this.getAbstractSPropagationElement());
        abstractSPropagationElementEClass.getESuperTypes().add(this.getAbstractSLocalAnalysisElement());
        sPropagationLinkEClass.getESuperTypes().add(this.getAbstractSLocalAnalysisElement());
        sBlockLAnalysisEClass.getESuperTypes().add(this.getAbstractSLocalAnalysisElement());
        abstractSFailureEventLAnalysisEClass.getESuperTypes().add(this.getAbstractSPropagationElement());
        abstractSLogicalGateLAnalysisEClass.getESuperTypes().add(this.getAbstractSPropagationElement());
        sBarrierLAnalysisEClass.getESuperTypes().add(this.getAbstractSLocalAnalysisElement());
        sLocalAnalysisEClass.getESuperTypes().add(theESFCorePackage.getAbstractSSafetyAnalysis());
        sSystemEventsLibraryEClass.getESuperTypes().add(this.getAbstractSLocalAnalysisElement());
        sSystemEventEClass.getESuperTypes().add(this.getAbstractSFailureEventLAnalysis());
        sDysfunctionalAssociationEClass.getESuperTypes().add(this.getAbstractSLocalAnalysisElement());
        sAndGateLAnalysisEClass.getESuperTypes().add(this.getAbstractSLogicalGateLAnalysis());
        sOrGateLAnalysisEClass.getESuperTypes().add(this.getAbstractSLogicalGateLAnalysis());
        sUltimelyFailureModeEClass.getESuperTypes().add(this.getAbstractSFailureModeLAnalysis());
        sAbsentFailureModeEClass.getESuperTypes().add(this.getAbstractSFailureModeLAnalysis());
        sErroneousFailureModeEClass.getESuperTypes().add(this.getAbstractSFailureModeLAnalysis());
        sLocalEventEClass.getESuperTypes().add(this.getAbstractSFailureEventLAnalysis());

        // Initialize classes, features, and operations; add parameters
        initEClass(
            abstractSLocalAnalysisElementEClass,
            IAbstractSLocalAnalysisElement.class,
            "AbstractSLocalAnalysisElement", //$NON-NLS-1$
            IS_ABSTRACT,
            !IS_INTERFACE,
            IS_GENERATED_INSTANCE_CLASS);

        initEClass(
            sPortLAnalysisEClass,
            ISPortLAnalysis.class,
            "SPortLAnalysis", //$NON-NLS-1$
            !IS_ABSTRACT,
            !IS_INTERFACE,
            IS_GENERATED_INSTANCE_CLASS);
        initEReference(
            getSPortLAnalysis_SFailureModesLAnalysisList(),
            this.getAbstractSFailureModeLAnalysis(),
            null,
            "sFailureModesLAnalysisList", //$NON-NLS-1$
            null,
            0,
            -1,
            ISPortLAnalysis.class,
            !IS_TRANSIENT,
            !IS_VOLATILE,
            IS_CHANGEABLE,
            !IS_COMPOSITE,
            IS_RESOLVE_PROXIES,
            !IS_UNSETTABLE,
            IS_UNIQUE,
            !IS_DERIVED,
            !IS_ORDERED);
        initEReference(
            getSPortLAnalysis_SBlockLAnalysis(),
            this.getSBlockLAnalysis(),
            this.getSBlockLAnalysis_SPortLAnalysis(),
            "sBlockLAnalysis", //$NON-NLS-1$
            null,
            1,
            1,
            ISPortLAnalysis.class,
            !IS_TRANSIENT,
            !IS_VOLATILE,
            IS_CHANGEABLE,
            !IS_COMPOSITE,
            !IS_RESOLVE_PROXIES,
            !IS_UNSETTABLE,
            IS_UNIQUE,
            !IS_DERIVED,
            !IS_ORDERED);
        initEReference(
            getSPortLAnalysis_SPort(),
            theESFArchitectureConceptsPackage.getSPort(),
            null,
            "sPort", //$NON-NLS-1$
            null,
            1,
            1,
            ISPortLAnalysis.class,
            !IS_TRANSIENT,
            !IS_VOLATILE,
            IS_CHANGEABLE,
            !IS_COMPOSITE,
            IS_RESOLVE_PROXIES,
            !IS_UNSETTABLE,
            IS_UNIQUE,
            !IS_DERIVED,
            !IS_ORDERED);
        initEReference(
            getSPortLAnalysis_Base_Port(),
            theUMLPackage.getPort(),
            null,
            "base_Port", //$NON-NLS-1$
            null,
            1,
            1,
            ISPortLAnalysis.class,
            !IS_TRANSIENT,
            !IS_VOLATILE,
            IS_CHANGEABLE,
            !IS_COMPOSITE,
            IS_RESOLVE_PROXIES,
            !IS_UNSETTABLE,
            IS_UNIQUE,
            !IS_DERIVED,
            !IS_ORDERED);
        initEAttribute(
            getSPortLAnalysis_SDirectionLAnalysis(),
            this.getSDirectionLAnalysis(),
            "sDirectionLAnalysis", //$NON-NLS-1$
            null,
            1,
            1,
            ISPortLAnalysis.class,
            !IS_TRANSIENT,
            !IS_VOLATILE,
            IS_CHANGEABLE,
            !IS_UNSETTABLE,
            !IS_ID,
            IS_UNIQUE,
            !IS_DERIVED,
            !IS_ORDERED);

        initEClass(
            abstractSFailureModeLAnalysisEClass,
            IAbstractSFailureModeLAnalysis.class,
            "AbstractSFailureModeLAnalysis", //$NON-NLS-1$
            IS_ABSTRACT,
            !IS_INTERFACE,
            IS_GENERATED_INSTANCE_CLASS);
        initEReference(
            getAbstractSFailureModeLAnalysis_SBlockLAnalysis(),
            this.getSBlockLAnalysis(),
            this.getSBlockLAnalysis_SFailureModesLAnalysisList(),
            "sBlockLAnalysis", //$NON-NLS-1$
            null,
            1,
            1,
            IAbstractSFailureModeLAnalysis.class,
            !IS_TRANSIENT,
            !IS_VOLATILE,
            IS_CHANGEABLE,
            !IS_COMPOSITE,
            !IS_RESOLVE_PROXIES,
            !IS_UNSETTABLE,
            IS_UNIQUE,
            !IS_DERIVED,
            !IS_ORDERED);
        initEReference(
            getAbstractSFailureModeLAnalysis_SFailureMode(),
            theSDysfunctionsPackage.getSFailureMode(),
            null,
            "sFailureMode", //$NON-NLS-1$
            null,
            0,
            1,
            IAbstractSFailureModeLAnalysis.class,
            !IS_TRANSIENT,
            !IS_VOLATILE,
            IS_CHANGEABLE,
            !IS_COMPOSITE,
            IS_RESOLVE_PROXIES,
            !IS_UNSETTABLE,
            IS_UNIQUE,
            !IS_DERIVED,
            !IS_ORDERED);

        initEClass(
            abstractSPropagationElementEClass,
            IAbstractSPropagationElement.class,
            "AbstractSPropagationElement", //$NON-NLS-1$
            IS_ABSTRACT,
            !IS_INTERFACE,
            IS_GENERATED_INSTANCE_CLASS);
        initEReference(
            getAbstractSPropagationElement_SOccurency(),
            theESFPropertiesPackage.getSOccurence(),
            null,
            "sOccurency", //$NON-NLS-1$
            null,
            0,
            1,
            IAbstractSPropagationElement.class,
            !IS_TRANSIENT,
            !IS_VOLATILE,
            IS_CHANGEABLE,
            !IS_COMPOSITE,
            IS_RESOLVE_PROXIES,
            !IS_UNSETTABLE,
            IS_UNIQUE,
            !IS_DERIVED,
            !IS_ORDERED);
        initEReference(
            getAbstractSPropagationElement_OutSPropagationLinksList(),
            this.getSPropagationLink(),
            this.getSPropagationLink_ElementSource(),
            "outSPropagationLinksList", //$NON-NLS-1$
            null,
            0,
            -1,
            IAbstractSPropagationElement.class,
            !IS_TRANSIENT,
            !IS_VOLATILE,
            IS_CHANGEABLE,
            !IS_COMPOSITE,
            IS_RESOLVE_PROXIES,
            !IS_UNSETTABLE,
            IS_UNIQUE,
            !IS_DERIVED,
            !IS_ORDERED);
        initEReference(
            getAbstractSPropagationElement_InSPropagationLinksList(),
            this.getSPropagationLink(),
            this.getSPropagationLink_ElementTarget(),
            "inSPropagationLinksList", //$NON-NLS-1$
            null,
            0,
            -1,
            IAbstractSPropagationElement.class,
            !IS_TRANSIENT,
            !IS_VOLATILE,
            IS_CHANGEABLE,
            !IS_COMPOSITE,
            IS_RESOLVE_PROXIES,
            !IS_UNSETTABLE,
            IS_UNIQUE,
            !IS_DERIVED,
            !IS_ORDERED);

        initEClass(
            sPropagationLinkEClass,
            ISPropagationLink.class,
            "SPropagationLink", //$NON-NLS-1$
            !IS_ABSTRACT,
            !IS_INTERFACE,
            IS_GENERATED_INSTANCE_CLASS);
        initEReference(
            getSPropagationLink_ElementTarget(),
            this.getAbstractSPropagationElement(),
            this.getAbstractSPropagationElement_InSPropagationLinksList(),
            "elementTarget", //$NON-NLS-1$
            null,
            1,
            1,
            ISPropagationLink.class,
            !IS_TRANSIENT,
            !IS_VOLATILE,
            IS_CHANGEABLE,
            !IS_COMPOSITE,
            IS_RESOLVE_PROXIES,
            !IS_UNSETTABLE,
            IS_UNIQUE,
            !IS_DERIVED,
            !IS_ORDERED);
        initEReference(
            getSPropagationLink_Base_Connector(),
            theUMLPackage.getConnector(),
            null,
            "base_Connector", //$NON-NLS-1$
            null,
            1,
            1,
            ISPropagationLink.class,
            !IS_TRANSIENT,
            !IS_VOLATILE,
            IS_CHANGEABLE,
            !IS_COMPOSITE,
            IS_RESOLVE_PROXIES,
            !IS_UNSETTABLE,
            IS_UNIQUE,
            !IS_DERIVED,
            !IS_ORDERED);
        initEReference(
            getSPropagationLink_SBlockLAnalysis(),
            this.getSBlockLAnalysis(),
            this.getSBlockLAnalysis_SPropagationLinksList(),
            "sBlockLAnalysis", //$NON-NLS-1$
            null,
            1,
            1,
            ISPropagationLink.class,
            !IS_TRANSIENT,
            !IS_VOLATILE,
            IS_CHANGEABLE,
            !IS_COMPOSITE,
            !IS_RESOLVE_PROXIES,
            !IS_UNSETTABLE,
            IS_UNIQUE,
            !IS_DERIVED,
            !IS_ORDERED);
        initEReference(
            getSPropagationLink_ElementSource(),
            this.getAbstractSPropagationElement(),
            this.getAbstractSPropagationElement_OutSPropagationLinksList(),
            "elementSource", //$NON-NLS-1$
            null,
            1,
            1,
            ISPropagationLink.class,
            !IS_TRANSIENT,
            !IS_VOLATILE,
            IS_CHANGEABLE,
            !IS_COMPOSITE,
            IS_RESOLVE_PROXIES,
            !IS_UNSETTABLE,
            IS_UNIQUE,
            !IS_DERIVED,
            !IS_ORDERED);

        initEClass(
            sBlockLAnalysisEClass,
            ISBlockLAnalysis.class,
            "SBlockLAnalysis", //$NON-NLS-1$
            !IS_ABSTRACT,
            !IS_INTERFACE,
            IS_GENERATED_INSTANCE_CLASS);
        initEReference(
            getSBlockLAnalysis_SBlock(),
            theESFArchitectureConceptsPackage.getSBlock(),
            null,
            "sBlock", //$NON-NLS-1$
            null,
            1,
            1,
            ISBlockLAnalysis.class,
            !IS_TRANSIENT,
            !IS_VOLATILE,
            IS_CHANGEABLE,
            !IS_COMPOSITE,
            IS_RESOLVE_PROXIES,
            !IS_UNSETTABLE,
            IS_UNIQUE,
            !IS_DERIVED,
            !IS_ORDERED);
        initEReference(
            getSBlockLAnalysis_SFailureEventsLAnalysisList(),
            this.getAbstractSFailureEventLAnalysis(),
            this.getAbstractSFailureEventLAnalysis_SBlockLAnalysis(),
            "sFailureEventsLAnalysisList", //$NON-NLS-1$
            null,
            0,
            -1,
            ISBlockLAnalysis.class,
            !IS_TRANSIENT,
            !IS_VOLATILE,
            IS_CHANGEABLE,
            IS_COMPOSITE,
            !IS_RESOLVE_PROXIES,
            !IS_UNSETTABLE,
            IS_UNIQUE,
            !IS_DERIVED,
            !IS_ORDERED);
        initEReference(
            getSBlockLAnalysis_SPortLAnalysis(),
            this.getSPortLAnalysis(),
            this.getSPortLAnalysis_SBlockLAnalysis(),
            "sPortLAnalysis", //$NON-NLS-1$
            null,
            1,
            1,
            ISBlockLAnalysis.class,
            !IS_TRANSIENT,
            !IS_VOLATILE,
            IS_CHANGEABLE,
            IS_COMPOSITE,
            !IS_RESOLVE_PROXIES,
            !IS_UNSETTABLE,
            IS_UNIQUE,
            !IS_DERIVED,
            !IS_ORDERED);
        initEReference(
            getSBlockLAnalysis_Base_Class(),
            theUMLPackage.getClass_(),
            null,
            "base_Class", //$NON-NLS-1$
            null,
            1,
            1,
            ISBlockLAnalysis.class,
            !IS_TRANSIENT,
            !IS_VOLATILE,
            IS_CHANGEABLE,
            !IS_COMPOSITE,
            IS_RESOLVE_PROXIES,
            !IS_UNSETTABLE,
            IS_UNIQUE,
            !IS_DERIVED,
            !IS_ORDERED);
        initEReference(
            getSBlockLAnalysis_SLogicalGatesLAnalysisList(),
            this.getAbstractSLogicalGateLAnalysis(),
            this.getAbstractSLogicalGateLAnalysis_SBlockLAnalysis(),
            "sLogicalGatesLAnalysisList", //$NON-NLS-1$
            null,
            0,
            -1,
            ISBlockLAnalysis.class,
            !IS_TRANSIENT,
            !IS_VOLATILE,
            IS_CHANGEABLE,
            IS_COMPOSITE,
            !IS_RESOLVE_PROXIES,
            !IS_UNSETTABLE,
            IS_UNIQUE,
            !IS_DERIVED,
            !IS_ORDERED);
        initEReference(
            getSBlockLAnalysis_SFailureModesLAnalysisList(),
            this.getAbstractSFailureModeLAnalysis(),
            this.getAbstractSFailureModeLAnalysis_SBlockLAnalysis(),
            "sFailureModesLAnalysisList", //$NON-NLS-1$
            null,
            0,
            -1,
            ISBlockLAnalysis.class,
            !IS_TRANSIENT,
            !IS_VOLATILE,
            IS_CHANGEABLE,
            IS_COMPOSITE,
            !IS_RESOLVE_PROXIES,
            !IS_UNSETTABLE,
            IS_UNIQUE,
            !IS_DERIVED,
            !IS_ORDERED);
        initEReference(
            getSBlockLAnalysis_SBarriersLAnalysisList(),
            this.getSBarrierLAnalysis(),
            this.getSBarrierLAnalysis_SBlockLAnalysis(),
            "sBarriersLAnalysisList", //$NON-NLS-1$
            null,
            0,
            -1,
            ISBlockLAnalysis.class,
            !IS_TRANSIENT,
            !IS_VOLATILE,
            IS_CHANGEABLE,
            IS_COMPOSITE,
            !IS_RESOLVE_PROXIES,
            !IS_UNSETTABLE,
            IS_UNIQUE,
            !IS_DERIVED,
            !IS_ORDERED);
        initEReference(
            getSBlockLAnalysis_SPropagationLinksList(),
            this.getSPropagationLink(),
            this.getSPropagationLink_SBlockLAnalysis(),
            "sPropagationLinksList", //$NON-NLS-1$
            null,
            0,
            -1,
            ISBlockLAnalysis.class,
            !IS_TRANSIENT,
            !IS_VOLATILE,
            IS_CHANGEABLE,
            IS_COMPOSITE,
            !IS_RESOLVE_PROXIES,
            !IS_UNSETTABLE,
            IS_UNIQUE,
            !IS_DERIVED,
            !IS_ORDERED);

        initEClass(
            abstractSFailureEventLAnalysisEClass,
            IAbstractSFailureEventLAnalysis.class,
            "AbstractSFailureEventLAnalysis", //$NON-NLS-1$
            IS_ABSTRACT,
            !IS_INTERFACE,
            IS_GENERATED_INSTANCE_CLASS);
        initEReference(
            getAbstractSFailureEventLAnalysis_SFailure(),
            theSDysfunctionsPackage.getSFailureEvent(),
            null,
            "sFailure", //$NON-NLS-1$
            null,
            0,
            1,
            IAbstractSFailureEventLAnalysis.class,
            !IS_TRANSIENT,
            !IS_VOLATILE,
            IS_CHANGEABLE,
            !IS_COMPOSITE,
            IS_RESOLVE_PROXIES,
            !IS_UNSETTABLE,
            IS_UNIQUE,
            !IS_DERIVED,
            !IS_ORDERED);
        initEReference(
            getAbstractSFailureEventLAnalysis_SBlockLAnalysis(),
            this.getSBlockLAnalysis(),
            this.getSBlockLAnalysis_SFailureEventsLAnalysisList(),
            "sBlockLAnalysis", //$NON-NLS-1$
            null,
            1,
            1,
            IAbstractSFailureEventLAnalysis.class,
            !IS_TRANSIENT,
            !IS_VOLATILE,
            IS_CHANGEABLE,
            !IS_COMPOSITE,
            !IS_RESOLVE_PROXIES,
            !IS_UNSETTABLE,
            IS_UNIQUE,
            !IS_DERIVED,
            !IS_ORDERED);

        initEClass(
            abstractSLogicalGateLAnalysisEClass,
            IAbstractSLogicalGateLAnalysis.class,
            "AbstractSLogicalGateLAnalysis", //$NON-NLS-1$
            IS_ABSTRACT,
            !IS_INTERFACE,
            IS_GENERATED_INSTANCE_CLASS);
        initEReference(
            getAbstractSLogicalGateLAnalysis_SBlockLAnalysis(),
            this.getSBlockLAnalysis(),
            this.getSBlockLAnalysis_SLogicalGatesLAnalysisList(),
            "sBlockLAnalysis", //$NON-NLS-1$
            null,
            1,
            1,
            IAbstractSLogicalGateLAnalysis.class,
            !IS_TRANSIENT,
            !IS_VOLATILE,
            IS_CHANGEABLE,
            !IS_COMPOSITE,
            !IS_RESOLVE_PROXIES,
            !IS_UNSETTABLE,
            IS_UNIQUE,
            !IS_DERIVED,
            !IS_ORDERED);

        initEClass(
            sBarrierLAnalysisEClass,
            ISBarrierLAnalysis.class,
            "SBarrierLAnalysis", //$NON-NLS-1$
            !IS_ABSTRACT,
            !IS_INTERFACE,
            IS_GENERATED_INSTANCE_CLASS);
        initEReference(
            getSBarrierLAnalysis_SBarrier(),
            theSRecommendationsPackage.getSBarrier(),
            null,
            "sBarrier", //$NON-NLS-1$
            null,
            0,
            1,
            ISBarrierLAnalysis.class,
            !IS_TRANSIENT,
            !IS_VOLATILE,
            IS_CHANGEABLE,
            !IS_COMPOSITE,
            IS_RESOLVE_PROXIES,
            !IS_UNSETTABLE,
            IS_UNIQUE,
            !IS_DERIVED,
            !IS_ORDERED);
        initEReference(
            getSBarrierLAnalysis_SFailureModesLAnalysisList(),
            this.getAbstractSFailureModeLAnalysis(),
            null,
            "sFailureModesLAnalysisList", //$NON-NLS-1$
            null,
            0,
            -1,
            ISBarrierLAnalysis.class,
            !IS_TRANSIENT,
            !IS_VOLATILE,
            IS_CHANGEABLE,
            !IS_COMPOSITE,
            IS_RESOLVE_PROXIES,
            !IS_UNSETTABLE,
            IS_UNIQUE,
            !IS_DERIVED,
            !IS_ORDERED);
        initEReference(
            getSBarrierLAnalysis_Base_Property(),
            theUMLPackage.getProperty(),
            null,
            "base_Property", //$NON-NLS-1$
            null,
            1,
            1,
            ISBarrierLAnalysis.class,
            !IS_TRANSIENT,
            !IS_VOLATILE,
            IS_CHANGEABLE,
            !IS_COMPOSITE,
            IS_RESOLVE_PROXIES,
            !IS_UNSETTABLE,
            IS_UNIQUE,
            !IS_DERIVED,
            !IS_ORDERED);
        initEReference(
            getSBarrierLAnalysis_SBlockLAnalysis(),
            this.getSBlockLAnalysis(),
            this.getSBlockLAnalysis_SBarriersLAnalysisList(),
            "sBlockLAnalysis", //$NON-NLS-1$
            null,
            1,
            1,
            ISBarrierLAnalysis.class,
            !IS_TRANSIENT,
            !IS_VOLATILE,
            IS_CHANGEABLE,
            !IS_COMPOSITE,
            !IS_RESOLVE_PROXIES,
            !IS_UNSETTABLE,
            IS_UNIQUE,
            !IS_DERIVED,
            !IS_ORDERED);

        initEClass(
            sLocalAnalysisEClass,
            ISLocalAnalysis.class,
            "SLocalAnalysis", //$NON-NLS-1$
            !IS_ABSTRACT,
            !IS_INTERFACE,
            IS_GENERATED_INSTANCE_CLASS);
        initEReference(
            getSLocalAnalysis_SBlocksLAnalysisList(),
            this.getSBlockLAnalysis(),
            null,
            "sBlocksLAnalysisList", //$NON-NLS-1$
            null,
            0,
            -1,
            ISLocalAnalysis.class,
            IS_TRANSIENT,
            IS_VOLATILE,
            IS_CHANGEABLE,
            !IS_COMPOSITE,
            IS_RESOLVE_PROXIES,
            !IS_UNSETTABLE,
            IS_UNIQUE,
            IS_DERIVED,
            !IS_ORDERED);
        initEReference(
            getSLocalAnalysis_Base_Package(),
            theUMLPackage.getPackage(),
            null,
            "base_Package", //$NON-NLS-1$
            null,
            1,
            1,
            ISLocalAnalysis.class,
            !IS_TRANSIENT,
            !IS_VOLATILE,
            IS_CHANGEABLE,
            !IS_COMPOSITE,
            IS_RESOLVE_PROXIES,
            !IS_UNSETTABLE,
            IS_UNIQUE,
            !IS_DERIVED,
            !IS_ORDERED);
        initEReference(
            getSLocalAnalysis_SSystemEventsLibrary(),
            this.getSSystemEventsLibrary(),
            null,
            "sSystemEventsLibrary", //$NON-NLS-1$
            null,
            0,
            1,
            ISLocalAnalysis.class,
            !IS_TRANSIENT,
            !IS_VOLATILE,
            IS_CHANGEABLE,
            IS_COMPOSITE,
            !IS_RESOLVE_PROXIES,
            !IS_UNSETTABLE,
            IS_UNIQUE,
            !IS_DERIVED,
            !IS_ORDERED);

        initEClass(
            sSystemEventsLibraryEClass,
            ISSystemEventsLibrary.class,
            "SSystemEventsLibrary", //$NON-NLS-1$
            !IS_ABSTRACT,
            !IS_INTERFACE,
            IS_GENERATED_INSTANCE_CLASS);
        initEReference(
            getSSystemEventsLibrary_Base_Package(),
            theUMLPackage.getPackage(),
            null,
            "base_Package", //$NON-NLS-1$
            null,
            1,
            1,
            ISSystemEventsLibrary.class,
            !IS_TRANSIENT,
            !IS_VOLATILE,
            IS_CHANGEABLE,
            !IS_COMPOSITE,
            IS_RESOLVE_PROXIES,
            !IS_UNSETTABLE,
            IS_UNIQUE,
            !IS_DERIVED,
            !IS_ORDERED);
        initEReference(
            getSSystemEventsLibrary_SSystemEventTypesList(),
            this.getSSystemEventType(),
            null,
            "sSystemEventTypesList", //$NON-NLS-1$
            null,
            0,
            -1,
            ISSystemEventsLibrary.class,
            !IS_TRANSIENT,
            !IS_VOLATILE,
            IS_CHANGEABLE,
            IS_COMPOSITE,
            !IS_RESOLVE_PROXIES,
            !IS_UNSETTABLE,
            IS_UNIQUE,
            !IS_DERIVED,
            !IS_ORDERED);

        initEClass(
            sSystemEventTypeEClass,
            ISSystemEventType.class,
            "SSystemEventType", //$NON-NLS-1$
            !IS_ABSTRACT,
            !IS_INTERFACE,
            IS_GENERATED_INSTANCE_CLASS);
        initEReference(
            getSSystemEventType_Base_Class(),
            theUMLPackage.getClass_(),
            null,
            "base_Class", //$NON-NLS-1$
            null,
            1,
            1,
            ISSystemEventType.class,
            !IS_TRANSIENT,
            !IS_VOLATILE,
            IS_CHANGEABLE,
            !IS_COMPOSITE,
            IS_RESOLVE_PROXIES,
            !IS_UNSETTABLE,
            IS_UNIQUE,
            !IS_DERIVED,
            !IS_ORDERED);
        initEReference(
            getSSystemEventType_SFailureEvent(),
            theSDysfunctionsPackage.getSFailureEvent(),
            null,
            "sFailureEvent", //$NON-NLS-1$
            null,
            1,
            1,
            ISSystemEventType.class,
            !IS_TRANSIENT,
            !IS_VOLATILE,
            IS_CHANGEABLE,
            !IS_COMPOSITE,
            IS_RESOLVE_PROXIES,
            !IS_UNSETTABLE,
            IS_UNIQUE,
            !IS_DERIVED,
            !IS_ORDERED);
        initEReference(
            getSSystemEventType_InstancesList(),
            this.getSSystemEvent(),
            this.getSSystemEvent_Type(),
            "instancesList", //$NON-NLS-1$
            null,
            0,
            -1,
            ISSystemEventType.class,
            !IS_TRANSIENT,
            !IS_VOLATILE,
            IS_CHANGEABLE,
            !IS_COMPOSITE,
            IS_RESOLVE_PROXIES,
            !IS_UNSETTABLE,
            IS_UNIQUE,
            !IS_DERIVED,
            !IS_ORDERED);

        initEClass(
            sSystemEventEClass,
            ISSystemEvent.class,
            "SSystemEvent", //$NON-NLS-1$
            !IS_ABSTRACT,
            !IS_INTERFACE,
            IS_GENERATED_INSTANCE_CLASS);
        initEReference(
            getSSystemEvent_Base_Property(),
            theUMLPackage.getProperty(),
            null,
            "base_Property", //$NON-NLS-1$
            null,
            1,
            1,
            ISSystemEvent.class,
            !IS_TRANSIENT,
            !IS_VOLATILE,
            IS_CHANGEABLE,
            !IS_COMPOSITE,
            IS_RESOLVE_PROXIES,
            !IS_UNSETTABLE,
            IS_UNIQUE,
            !IS_DERIVED,
            !IS_ORDERED);
        initEReference(
            getSSystemEvent_Type(),
            this.getSSystemEventType(),
            this.getSSystemEventType_InstancesList(),
            "type", //$NON-NLS-1$
            null,
            1,
            1,
            ISSystemEvent.class,
            !IS_TRANSIENT,
            !IS_VOLATILE,
            IS_CHANGEABLE,
            !IS_COMPOSITE,
            IS_RESOLVE_PROXIES,
            !IS_UNSETTABLE,
            IS_UNIQUE,
            !IS_DERIVED,
            !IS_ORDERED);

        initEClass(
            sDysfunctionalAssociationEClass,
            ISDysfunctionalAssociation.class,
            "SDysfunctionalAssociation", //$NON-NLS-1$
            !IS_ABSTRACT,
            !IS_INTERFACE,
            IS_GENERATED_INSTANCE_CLASS);
        initEReference(
            getSDysfunctionalAssociation_SPortLAnalysis(),
            this.getSPortLAnalysis(),
            null,
            "sPortLAnalysis", //$NON-NLS-1$
            null,
            0,
            1,
            ISDysfunctionalAssociation.class,
            !IS_TRANSIENT,
            !IS_VOLATILE,
            IS_CHANGEABLE,
            !IS_COMPOSITE,
            IS_RESOLVE_PROXIES,
            !IS_UNSETTABLE,
            IS_UNIQUE,
            !IS_DERIVED,
            !IS_ORDERED);
        initEReference(
            getSDysfunctionalAssociation_SBarrierLAnalysis(),
            this.getSBarrierLAnalysis(),
            null,
            "sBarrierLAnalysis", //$NON-NLS-1$
            null,
            0,
            1,
            ISDysfunctionalAssociation.class,
            !IS_TRANSIENT,
            !IS_VOLATILE,
            IS_CHANGEABLE,
            !IS_COMPOSITE,
            IS_RESOLVE_PROXIES,
            !IS_UNSETTABLE,
            IS_UNIQUE,
            !IS_DERIVED,
            !IS_ORDERED);
        initEReference(
            getSDysfunctionalAssociation_SFailureModeLAnalysis(),
            this.getAbstractSFailureModeLAnalysis(),
            null,
            "sFailureModeLAnalysis", //$NON-NLS-1$
            null,
            1,
            1,
            ISDysfunctionalAssociation.class,
            !IS_TRANSIENT,
            !IS_VOLATILE,
            IS_CHANGEABLE,
            !IS_COMPOSITE,
            IS_RESOLVE_PROXIES,
            !IS_UNSETTABLE,
            IS_UNIQUE,
            !IS_DERIVED,
            !IS_ORDERED);
        initEReference(
            getSDysfunctionalAssociation_Base_Connector(),
            theUMLPackage.getConnector(),
            null,
            "base_Connector", //$NON-NLS-1$
            null,
            1,
            1,
            ISDysfunctionalAssociation.class,
            !IS_TRANSIENT,
            !IS_VOLATILE,
            IS_CHANGEABLE,
            !IS_COMPOSITE,
            IS_RESOLVE_PROXIES,
            !IS_UNSETTABLE,
            IS_UNIQUE,
            !IS_DERIVED,
            !IS_ORDERED);

        EOperation op = initEOperation(
            getSDysfunctionalAssociation__Constraint1__DiagnosticChain_Map(),
            ecorePackage.getEBoolean(),
            "Constraint1", //$NON-NLS-1$
            0,
            1,
            IS_UNIQUE,
            IS_ORDERED);
        addEParameter(op, ecorePackage.getEDiagnosticChain(), "diagnostics", 0, 1, IS_UNIQUE, IS_ORDERED); //$NON-NLS-1$
        EGenericType g1 = createEGenericType(ecorePackage.getEMap());
        EGenericType g2 = createEGenericType(ecorePackage.getEJavaObject());
        g1.getETypeArguments().add(g2);
        g2 = createEGenericType(ecorePackage.getEJavaObject());
        g1.getETypeArguments().add(g2);
        addEParameter(op, g1, "context", 0, 1, IS_UNIQUE, IS_ORDERED); //$NON-NLS-1$

        initEClass(
            sAndGateLAnalysisEClass,
            ISAndGateLAnalysis.class,
            "SAndGateLAnalysis", //$NON-NLS-1$
            !IS_ABSTRACT,
            !IS_INTERFACE,
            IS_GENERATED_INSTANCE_CLASS);
        initEReference(
            getSAndGateLAnalysis_Base_Property(),
            theUMLPackage.getProperty(),
            null,
            "base_Property", //$NON-NLS-1$
            null,
            1,
            1,
            ISAndGateLAnalysis.class,
            !IS_TRANSIENT,
            !IS_VOLATILE,
            IS_CHANGEABLE,
            !IS_COMPOSITE,
            IS_RESOLVE_PROXIES,
            !IS_UNSETTABLE,
            IS_UNIQUE,
            !IS_DERIVED,
            !IS_ORDERED);

        initEClass(
            sOrGateLAnalysisEClass,
            ISOrGateLAnalysis.class,
            "SOrGateLAnalysis", //$NON-NLS-1$
            !IS_ABSTRACT,
            !IS_INTERFACE,
            IS_GENERATED_INSTANCE_CLASS);
        initEReference(
            getSOrGateLAnalysis_Base_Property(),
            theUMLPackage.getProperty(),
            null,
            "base_Property", //$NON-NLS-1$
            null,
            1,
            1,
            ISOrGateLAnalysis.class,
            !IS_TRANSIENT,
            !IS_VOLATILE,
            IS_CHANGEABLE,
            !IS_COMPOSITE,
            IS_RESOLVE_PROXIES,
            !IS_UNSETTABLE,
            IS_UNIQUE,
            !IS_DERIVED,
            !IS_ORDERED);

        initEClass(
            sUltimelyFailureModeEClass,
            ISUltimelyFailureMode.class,
            "SUltimelyFailureMode", //$NON-NLS-1$
            !IS_ABSTRACT,
            !IS_INTERFACE,
            IS_GENERATED_INSTANCE_CLASS);
        initEReference(
            getSUltimelyFailureMode_Base_Property(),
            theUMLPackage.getProperty(),
            null,
            "base_Property", //$NON-NLS-1$
            null,
            1,
            1,
            ISUltimelyFailureMode.class,
            !IS_TRANSIENT,
            !IS_VOLATILE,
            IS_CHANGEABLE,
            !IS_COMPOSITE,
            IS_RESOLVE_PROXIES,
            !IS_UNSETTABLE,
            IS_UNIQUE,
            !IS_DERIVED,
            !IS_ORDERED);

        initEClass(
            sAbsentFailureModeEClass,
            ISAbsentFailureMode.class,
            "SAbsentFailureMode", //$NON-NLS-1$
            !IS_ABSTRACT,
            !IS_INTERFACE,
            IS_GENERATED_INSTANCE_CLASS);
        initEReference(
            getSAbsentFailureMode_Base_Property(),
            theUMLPackage.getProperty(),
            null,
            "base_Property", //$NON-NLS-1$
            null,
            1,
            1,
            ISAbsentFailureMode.class,
            !IS_TRANSIENT,
            !IS_VOLATILE,
            IS_CHANGEABLE,
            !IS_COMPOSITE,
            IS_RESOLVE_PROXIES,
            !IS_UNSETTABLE,
            IS_UNIQUE,
            !IS_DERIVED,
            !IS_ORDERED);

        initEClass(
            sErroneousFailureModeEClass,
            ISErroneousFailureMode.class,
            "SErroneousFailureMode", //$NON-NLS-1$
            !IS_ABSTRACT,
            !IS_INTERFACE,
            IS_GENERATED_INSTANCE_CLASS);
        initEReference(
            getSErroneousFailureMode_Base_Property(),
            theUMLPackage.getProperty(),
            null,
            "base_Property", //$NON-NLS-1$
            null,
            1,
            1,
            ISErroneousFailureMode.class,
            !IS_TRANSIENT,
            !IS_VOLATILE,
            IS_CHANGEABLE,
            !IS_COMPOSITE,
            IS_RESOLVE_PROXIES,
            !IS_UNSETTABLE,
            IS_UNIQUE,
            !IS_DERIVED,
            !IS_ORDERED);

        initEClass(
            sLocalEventEClass,
            ISLocalEvent.class,
            "SLocalEvent", //$NON-NLS-1$
            !IS_ABSTRACT,
            !IS_INTERFACE,
            IS_GENERATED_INSTANCE_CLASS);
        initEReference(
            getSLocalEvent_Base_Property(),
            theUMLPackage.getProperty(),
            null,
            "base_Property", //$NON-NLS-1$
            null,
            1,
            1,
            ISLocalEvent.class,
            !IS_TRANSIENT,
            !IS_VOLATILE,
            IS_CHANGEABLE,
            !IS_COMPOSITE,
            IS_RESOLVE_PROXIES,
            !IS_UNSETTABLE,
            IS_UNIQUE,
            !IS_DERIVED,
            !IS_ORDERED);

        // Initialize enums and add enum literals
        initEEnum(sDirectionLAnalysisEEnum, SDirectionLAnalysis.class, "SDirectionLAnalysis"); //$NON-NLS-1$
        addEEnumLiteral(sDirectionLAnalysisEEnum, SDirectionLAnalysis.IN);
        addEEnumLiteral(sDirectionLAnalysisEEnum, SDirectionLAnalysis.OUT);
        addEEnumLiteral(sDirectionLAnalysisEEnum, SDirectionLAnalysis.UNDEFINED);

        // Create resource
        createResource(eNS_URI);

        // Create annotations
        // http://www.eclipse.org/uml2/2.0.0/UML
        createUMLAnnotations();
    }

    /**
     * Initializes the annotations for <b>http://www.eclipse.org/uml2/2.0.0/UML</b>.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * 
     * @generated
     */
    protected void createUMLAnnotations() {
        String source = "http://www.eclipse.org/uml2/2.0.0/UML"; //$NON-NLS-1$
        addAnnotation(this, source, new String[] {"originalName", "ESFLocalAnalysis" //$NON-NLS-1$ //$NON-NLS-2$
        });
        addAnnotation(
            sDysfunctionalAssociationEClass,
            source,
            new String[] {"originalName", "SDysfunctionalAssociation " //$NON-NLS-1$ //$NON-NLS-2$
            });
    }

} // ESFLocalAnalysisPackage
