/*******************************************************************************
 * Copyright (c) 2016 ALL4TEC & CEA LIST.
 * All rights reserved. This program and the accompanying materials
 * are made available under the terms of the Eclipse Public License v1.0
 * which accompanies this distribution, and is available at
 * http://www.eclipse.org/legal/epl-v10.html
 *   
 * Contributors:
 *      ALL4TEC & CEA LIST - initial API and implementation
 *******************************************************************************/
package org.polarsys.esf.esflocalanalysis.impl;

import java.util.Collection;

import org.eclipse.emf.common.notify.Notification;

import org.eclipse.emf.common.notify.NotificationChain;
import org.eclipse.emf.common.util.EList;

import org.eclipse.emf.ecore.EClass;
import org.eclipse.emf.ecore.InternalEObject;

import org.eclipse.emf.ecore.impl.ENotificationImpl;

import org.eclipse.emf.ecore.util.EObjectContainmentWithInverseEList;
import org.eclipse.emf.ecore.util.InternalEList;
import org.polarsys.esf.esfarchitectureconcepts.ISBlock;

import org.polarsys.esf.esflocalanalysis.IAbstractSFailureEventLAnalysis;
import org.polarsys.esf.esflocalanalysis.IAbstractSFailureModeLAnalysis;
import org.polarsys.esf.esflocalanalysis.IAbstractSLogicalGateLAnalysis;
import org.polarsys.esf.esflocalanalysis.IESFLocalAnalysisPackage;
import org.polarsys.esf.esflocalanalysis.ISBarrierLAnalysis;
import org.polarsys.esf.esflocalanalysis.ISBlockLAnalysis;
import org.polarsys.esf.esflocalanalysis.ISPortLAnalysis;
import org.polarsys.esf.esflocalanalysis.ISPropagationLink;

/**
 * <!-- begin-user-doc -->
 * An implementation of the model object '<em><b>SBlock LAnalysis</b></em>'.
 * <!-- end-user-doc -->
 * <p>
 * The following features are implemented:
 * </p>
 * <ul>
 * <li>{@link org.polarsys.esf.esflocalanalysis.impl.SBlockLAnalysis#getSBlock <em>SBlock</em>}</li>
 * <li>{@link org.polarsys.esf.esflocalanalysis.impl.SBlockLAnalysis#getSFailureEventsLAnalysisList <em>SFailure Events
 * LAnalysis List</em>}</li>
 * <li>{@link org.polarsys.esf.esflocalanalysis.impl.SBlockLAnalysis#getSPortLAnalysis <em>SPort LAnalysis</em>}</li>
 * <li>{@link org.polarsys.esf.esflocalanalysis.impl.SBlockLAnalysis#getBase_Class <em>Base Class</em>}</li>
 * <li>{@link org.polarsys.esf.esflocalanalysis.impl.SBlockLAnalysis#getSLogicalGatesLAnalysisList <em>SLogical Gates
 * LAnalysis List</em>}</li>
 * <li>{@link org.polarsys.esf.esflocalanalysis.impl.SBlockLAnalysis#getSFailureModesLAnalysisList <em>SFailure Modes
 * LAnalysis List</em>}</li>
 * <li>{@link org.polarsys.esf.esflocalanalysis.impl.SBlockLAnalysis#getSBarriersLAnalysisList <em>SBarriers LAnalysis
 * List</em>}</li>
 * <li>{@link org.polarsys.esf.esflocalanalysis.impl.SBlockLAnalysis#getSPropagationLinksList <em>SPropagation Links
 * List</em>}</li>
 * </ul>
 *
 * @generated
 */
public class SBlockLAnalysis
    extends AbstractSLocalAnalysisElement
    implements ISBlockLAnalysis {

    /**
     * The cached value of the '{@link #getSBlock() <em>SBlock</em>}' reference.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * 
     * @see #getSBlock()
     * @generated
     * @ordered
     */
    protected ISBlock sBlock;

    /**
     * The cached value of the '{@link #getSFailureEventsLAnalysisList() <em>SFailure Events LAnalysis List</em>}'
     * containment reference list.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * 
     * @see #getSFailureEventsLAnalysisList()
     * @generated
     * @ordered
     */
    protected EList<IAbstractSFailureEventLAnalysis> sFailureEventsLAnalysisList;

    /**
     * The cached value of the '{@link #getSPortLAnalysis() <em>SPort LAnalysis</em>}' containment reference.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * 
     * @see #getSPortLAnalysis()
     * @generated
     * @ordered
     */
    protected ISPortLAnalysis sPortLAnalysis;

    /**
     * The cached value of the '{@link #getBase_Class() <em>Base Class</em>}' reference.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * 
     * @see #getBase_Class()
     * @generated
     * @ordered
     */
    protected org.eclipse.uml2.uml.Class base_Class;

    /**
     * The cached value of the '{@link #getSLogicalGatesLAnalysisList() <em>SLogical Gates LAnalysis List</em>}'
     * containment reference list.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * 
     * @see #getSLogicalGatesLAnalysisList()
     * @generated
     * @ordered
     */
    protected EList<IAbstractSLogicalGateLAnalysis> sLogicalGatesLAnalysisList;

    /**
     * The cached value of the '{@link #getSFailureModesLAnalysisList() <em>SFailure Modes LAnalysis List</em>}'
     * containment reference list.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * 
     * @see #getSFailureModesLAnalysisList()
     * @generated
     * @ordered
     */
    protected EList<IAbstractSFailureModeLAnalysis> sFailureModesLAnalysisList;

    /**
     * The cached value of the '{@link #getSBarriersLAnalysisList() <em>SBarriers LAnalysis List</em>}' containment
     * reference list.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * 
     * @see #getSBarriersLAnalysisList()
     * @generated
     * @ordered
     */
    protected EList<ISBarrierLAnalysis> sBarriersLAnalysisList;

    /**
     * The cached value of the '{@link #getSPropagationLinksList() <em>SPropagation Links List</em>}' containment
     * reference list.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * 
     * @see #getSPropagationLinksList()
     * @generated
     * @ordered
     */
    protected EList<ISPropagationLink> sPropagationLinksList;

    /**
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * 
     * @generated
     */
    protected SBlockLAnalysis() {
        super();
    }

    /**
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * 
     * @generated
     */
    @Override
    protected EClass eStaticClass() {
        return IESFLocalAnalysisPackage.Literals.SBLOCK_LANALYSIS;
    }

    /**
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * 
     * @generated
     */
    public ISBlock getSBlock() {
        if (sBlock != null && sBlock.eIsProxy()) {
            InternalEObject oldSBlock = (InternalEObject) sBlock;
            sBlock = (ISBlock) eResolveProxy(oldSBlock);
            if (sBlock != oldSBlock) {
                if (eNotificationRequired())
                    eNotify(
                        new ENotificationImpl(
                            this,
                            Notification.RESOLVE,
                            IESFLocalAnalysisPackage.SBLOCK_LANALYSIS__SBLOCK,
                            oldSBlock,
                            sBlock));
            }
        }
        return sBlock;
    }

    /**
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * 
     * @generated
     */
    public ISBlock basicGetSBlock() {
        return sBlock;
    }

    /**
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * 
     * @generated
     */
    public void setSBlock(ISBlock newSBlock) {
        ISBlock oldSBlock = sBlock;
        sBlock = newSBlock;
        if (eNotificationRequired())
            eNotify(
                new ENotificationImpl(
                    this,
                    Notification.SET,
                    IESFLocalAnalysisPackage.SBLOCK_LANALYSIS__SBLOCK,
                    oldSBlock,
                    sBlock));
    }

    /**
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * 
     * @generated
     */
    public EList<IAbstractSFailureEventLAnalysis> getSFailureEventsLAnalysisList() {
        if (sFailureEventsLAnalysisList == null) {
            sFailureEventsLAnalysisList = new EObjectContainmentWithInverseEList<IAbstractSFailureEventLAnalysis>(
                IAbstractSFailureEventLAnalysis.class,
                this,
                IESFLocalAnalysisPackage.SBLOCK_LANALYSIS__SFAILURE_EVENTS_LANALYSIS_LIST,
                IESFLocalAnalysisPackage.ABSTRACT_SFAILURE_EVENT_LANALYSIS__SBLOCK_LANALYSIS);
        }
        return sFailureEventsLAnalysisList;
    }

    /**
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * 
     * @generated
     */
    public EList<ISPropagationLink> getSPropagationLinksList() {
        if (sPropagationLinksList == null) {
            sPropagationLinksList = new EObjectContainmentWithInverseEList<ISPropagationLink>(
                ISPropagationLink.class,
                this,
                IESFLocalAnalysisPackage.SBLOCK_LANALYSIS__SPROPAGATION_LINKS_LIST,
                IESFLocalAnalysisPackage.SPROPAGATION_LINK__SBLOCK_LANALYSIS);
        }
        return sPropagationLinksList;
    }

    /**
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * 
     * @generated
     */
    @SuppressWarnings("unchecked")
    @Override
    public NotificationChain eInverseAdd(InternalEObject otherEnd, int featureID, NotificationChain msgs) {
        switch (featureID) {
            case IESFLocalAnalysisPackage.SBLOCK_LANALYSIS__SFAILURE_EVENTS_LANALYSIS_LIST:
                return ((InternalEList<InternalEObject>) (InternalEList<?>) getSFailureEventsLAnalysisList())
                    .basicAdd(otherEnd, msgs);
            case IESFLocalAnalysisPackage.SBLOCK_LANALYSIS__SPORT_LANALYSIS:
                if (sPortLAnalysis != null)
                    msgs = ((InternalEObject) sPortLAnalysis).eInverseRemove(
                        this,
                        EOPPOSITE_FEATURE_BASE - IESFLocalAnalysisPackage.SBLOCK_LANALYSIS__SPORT_LANALYSIS,
                        null,
                        msgs);
                return basicSetSPortLAnalysis((ISPortLAnalysis) otherEnd, msgs);
            case IESFLocalAnalysisPackage.SBLOCK_LANALYSIS__SLOGICAL_GATES_LANALYSIS_LIST:
                return ((InternalEList<InternalEObject>) (InternalEList<?>) getSLogicalGatesLAnalysisList())
                    .basicAdd(otherEnd, msgs);
            case IESFLocalAnalysisPackage.SBLOCK_LANALYSIS__SFAILURE_MODES_LANALYSIS_LIST:
                return ((InternalEList<InternalEObject>) (InternalEList<?>) getSFailureModesLAnalysisList())
                    .basicAdd(otherEnd, msgs);
            case IESFLocalAnalysisPackage.SBLOCK_LANALYSIS__SBARRIERS_LANALYSIS_LIST:
                return ((InternalEList<InternalEObject>) (InternalEList<?>) getSBarriersLAnalysisList())
                    .basicAdd(otherEnd, msgs);
            case IESFLocalAnalysisPackage.SBLOCK_LANALYSIS__SPROPAGATION_LINKS_LIST:
                return ((InternalEList<InternalEObject>) (InternalEList<?>) getSPropagationLinksList())
                    .basicAdd(otherEnd, msgs);
        }
        return super.eInverseAdd(otherEnd, featureID, msgs);
    }

    /**
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * 
     * @generated
     */
    @Override
    public NotificationChain eInverseRemove(InternalEObject otherEnd, int featureID, NotificationChain msgs) {
        switch (featureID) {
            case IESFLocalAnalysisPackage.SBLOCK_LANALYSIS__SFAILURE_EVENTS_LANALYSIS_LIST:
                return ((InternalEList<?>) getSFailureEventsLAnalysisList()).basicRemove(otherEnd, msgs);
            case IESFLocalAnalysisPackage.SBLOCK_LANALYSIS__SPORT_LANALYSIS:
                return basicSetSPortLAnalysis(null, msgs);
            case IESFLocalAnalysisPackage.SBLOCK_LANALYSIS__SLOGICAL_GATES_LANALYSIS_LIST:
                return ((InternalEList<?>) getSLogicalGatesLAnalysisList()).basicRemove(otherEnd, msgs);
            case IESFLocalAnalysisPackage.SBLOCK_LANALYSIS__SFAILURE_MODES_LANALYSIS_LIST:
                return ((InternalEList<?>) getSFailureModesLAnalysisList()).basicRemove(otherEnd, msgs);
            case IESFLocalAnalysisPackage.SBLOCK_LANALYSIS__SBARRIERS_LANALYSIS_LIST:
                return ((InternalEList<?>) getSBarriersLAnalysisList()).basicRemove(otherEnd, msgs);
            case IESFLocalAnalysisPackage.SBLOCK_LANALYSIS__SPROPAGATION_LINKS_LIST:
                return ((InternalEList<?>) getSPropagationLinksList()).basicRemove(otherEnd, msgs);
        }
        return super.eInverseRemove(otherEnd, featureID, msgs);
    }

    /**
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * 
     * @generated
     */
    public ISPortLAnalysis getSPortLAnalysis() {
        return sPortLAnalysis;
    }

    /**
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * 
     * @generated
     */
    public NotificationChain basicSetSPortLAnalysis(ISPortLAnalysis newSPortLAnalysis, NotificationChain msgs) {
        ISPortLAnalysis oldSPortLAnalysis = sPortLAnalysis;
        sPortLAnalysis = newSPortLAnalysis;
        if (eNotificationRequired()) {
            ENotificationImpl notification = new ENotificationImpl(
                this,
                Notification.SET,
                IESFLocalAnalysisPackage.SBLOCK_LANALYSIS__SPORT_LANALYSIS,
                oldSPortLAnalysis,
                newSPortLAnalysis);
            if (msgs == null)
                msgs = notification;
            else
                msgs.add(notification);
        }
        return msgs;
    }

    /**
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * 
     * @generated
     */
    public void setSPortLAnalysis(ISPortLAnalysis newSPortLAnalysis) {
        if (newSPortLAnalysis != sPortLAnalysis) {
            NotificationChain msgs = null;
            if (sPortLAnalysis != null)
                msgs = ((InternalEObject) sPortLAnalysis).eInverseRemove(
                    this,
                    IESFLocalAnalysisPackage.SPORT_LANALYSIS__SBLOCK_LANALYSIS,
                    ISPortLAnalysis.class,
                    msgs);
            if (newSPortLAnalysis != null)
                msgs = ((InternalEObject) newSPortLAnalysis).eInverseAdd(
                    this,
                    IESFLocalAnalysisPackage.SPORT_LANALYSIS__SBLOCK_LANALYSIS,
                    ISPortLAnalysis.class,
                    msgs);
            msgs = basicSetSPortLAnalysis(newSPortLAnalysis, msgs);
            if (msgs != null)
                msgs.dispatch();
        } else if (eNotificationRequired())
            eNotify(
                new ENotificationImpl(
                    this,
                    Notification.SET,
                    IESFLocalAnalysisPackage.SBLOCK_LANALYSIS__SPORT_LANALYSIS,
                    newSPortLAnalysis,
                    newSPortLAnalysis));
    }

    /**
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * 
     * @generated
     */
    public org.eclipse.uml2.uml.Class getBase_Class() {
        if (base_Class != null && base_Class.eIsProxy()) {
            InternalEObject oldBase_Class = (InternalEObject) base_Class;
            base_Class = (org.eclipse.uml2.uml.Class) eResolveProxy(oldBase_Class);
            if (base_Class != oldBase_Class) {
                if (eNotificationRequired())
                    eNotify(
                        new ENotificationImpl(
                            this,
                            Notification.RESOLVE,
                            IESFLocalAnalysisPackage.SBLOCK_LANALYSIS__BASE_CLASS,
                            oldBase_Class,
                            base_Class));
            }
        }
        return base_Class;
    }

    /**
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * 
     * @generated
     */
    public org.eclipse.uml2.uml.Class basicGetBase_Class() {
        return base_Class;
    }

    /**
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * 
     * @generated
     */
    public void setBase_Class(org.eclipse.uml2.uml.Class newBase_Class) {
        org.eclipse.uml2.uml.Class oldBase_Class = base_Class;
        base_Class = newBase_Class;
        if (eNotificationRequired())
            eNotify(
                new ENotificationImpl(
                    this,
                    Notification.SET,
                    IESFLocalAnalysisPackage.SBLOCK_LANALYSIS__BASE_CLASS,
                    oldBase_Class,
                    base_Class));
    }

    /**
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * 
     * @generated
     */
    public EList<IAbstractSLogicalGateLAnalysis> getSLogicalGatesLAnalysisList() {
        if (sLogicalGatesLAnalysisList == null) {
            sLogicalGatesLAnalysisList = new EObjectContainmentWithInverseEList<IAbstractSLogicalGateLAnalysis>(
                IAbstractSLogicalGateLAnalysis.class,
                this,
                IESFLocalAnalysisPackage.SBLOCK_LANALYSIS__SLOGICAL_GATES_LANALYSIS_LIST,
                IESFLocalAnalysisPackage.ABSTRACT_SLOGICAL_GATE_LANALYSIS__SBLOCK_LANALYSIS);
        }
        return sLogicalGatesLAnalysisList;
    }

    /**
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * 
     * @generated
     */
    public EList<IAbstractSFailureModeLAnalysis> getSFailureModesLAnalysisList() {
        if (sFailureModesLAnalysisList == null) {
            sFailureModesLAnalysisList = new EObjectContainmentWithInverseEList<IAbstractSFailureModeLAnalysis>(
                IAbstractSFailureModeLAnalysis.class,
                this,
                IESFLocalAnalysisPackage.SBLOCK_LANALYSIS__SFAILURE_MODES_LANALYSIS_LIST,
                IESFLocalAnalysisPackage.ABSTRACT_SFAILURE_MODE_LANALYSIS__SBLOCK_LANALYSIS);
        }
        return sFailureModesLAnalysisList;
    }

    /**
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * 
     * @generated
     */
    public EList<ISBarrierLAnalysis> getSBarriersLAnalysisList() {
        if (sBarriersLAnalysisList == null) {
            sBarriersLAnalysisList = new EObjectContainmentWithInverseEList<ISBarrierLAnalysis>(
                ISBarrierLAnalysis.class,
                this,
                IESFLocalAnalysisPackage.SBLOCK_LANALYSIS__SBARRIERS_LANALYSIS_LIST,
                IESFLocalAnalysisPackage.SBARRIER_LANALYSIS__SBLOCK_LANALYSIS);
        }
        return sBarriersLAnalysisList;
    }

    /**
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * 
     * @generated
     */
    @Override
    public Object eGet(int featureID, boolean resolve, boolean coreType) {
        switch (featureID) {
            case IESFLocalAnalysisPackage.SBLOCK_LANALYSIS__SBLOCK:
                if (resolve)
                    return getSBlock();
                return basicGetSBlock();
            case IESFLocalAnalysisPackage.SBLOCK_LANALYSIS__SFAILURE_EVENTS_LANALYSIS_LIST:
                return getSFailureEventsLAnalysisList();
            case IESFLocalAnalysisPackage.SBLOCK_LANALYSIS__SPORT_LANALYSIS:
                return getSPortLAnalysis();
            case IESFLocalAnalysisPackage.SBLOCK_LANALYSIS__BASE_CLASS:
                if (resolve)
                    return getBase_Class();
                return basicGetBase_Class();
            case IESFLocalAnalysisPackage.SBLOCK_LANALYSIS__SLOGICAL_GATES_LANALYSIS_LIST:
                return getSLogicalGatesLAnalysisList();
            case IESFLocalAnalysisPackage.SBLOCK_LANALYSIS__SFAILURE_MODES_LANALYSIS_LIST:
                return getSFailureModesLAnalysisList();
            case IESFLocalAnalysisPackage.SBLOCK_LANALYSIS__SBARRIERS_LANALYSIS_LIST:
                return getSBarriersLAnalysisList();
            case IESFLocalAnalysisPackage.SBLOCK_LANALYSIS__SPROPAGATION_LINKS_LIST:
                return getSPropagationLinksList();
        }
        return super.eGet(featureID, resolve, coreType);
    }

    /**
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * 
     * @generated
     */
    @SuppressWarnings("unchecked")
    @Override
    public void eSet(int featureID, Object newValue) {
        switch (featureID) {
            case IESFLocalAnalysisPackage.SBLOCK_LANALYSIS__SBLOCK:
                setSBlock((ISBlock) newValue);
                return;
            case IESFLocalAnalysisPackage.SBLOCK_LANALYSIS__SFAILURE_EVENTS_LANALYSIS_LIST:
                getSFailureEventsLAnalysisList().clear();
                getSFailureEventsLAnalysisList()
                    .addAll((Collection<? extends IAbstractSFailureEventLAnalysis>) newValue);
                return;
            case IESFLocalAnalysisPackage.SBLOCK_LANALYSIS__SPORT_LANALYSIS:
                setSPortLAnalysis((ISPortLAnalysis) newValue);
                return;
            case IESFLocalAnalysisPackage.SBLOCK_LANALYSIS__BASE_CLASS:
                setBase_Class((org.eclipse.uml2.uml.Class) newValue);
                return;
            case IESFLocalAnalysisPackage.SBLOCK_LANALYSIS__SLOGICAL_GATES_LANALYSIS_LIST:
                getSLogicalGatesLAnalysisList().clear();
                getSLogicalGatesLAnalysisList().addAll((Collection<? extends IAbstractSLogicalGateLAnalysis>) newValue);
                return;
            case IESFLocalAnalysisPackage.SBLOCK_LANALYSIS__SFAILURE_MODES_LANALYSIS_LIST:
                getSFailureModesLAnalysisList().clear();
                getSFailureModesLAnalysisList().addAll((Collection<? extends IAbstractSFailureModeLAnalysis>) newValue);
                return;
            case IESFLocalAnalysisPackage.SBLOCK_LANALYSIS__SBARRIERS_LANALYSIS_LIST:
                getSBarriersLAnalysisList().clear();
                getSBarriersLAnalysisList().addAll((Collection<? extends ISBarrierLAnalysis>) newValue);
                return;
            case IESFLocalAnalysisPackage.SBLOCK_LANALYSIS__SPROPAGATION_LINKS_LIST:
                getSPropagationLinksList().clear();
                getSPropagationLinksList().addAll((Collection<? extends ISPropagationLink>) newValue);
                return;
        }
        super.eSet(featureID, newValue);
    }

    /**
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * 
     * @generated
     */
    @Override
    public void eUnset(int featureID) {
        switch (featureID) {
            case IESFLocalAnalysisPackage.SBLOCK_LANALYSIS__SBLOCK:
                setSBlock((ISBlock) null);
                return;
            case IESFLocalAnalysisPackage.SBLOCK_LANALYSIS__SFAILURE_EVENTS_LANALYSIS_LIST:
                getSFailureEventsLAnalysisList().clear();
                return;
            case IESFLocalAnalysisPackage.SBLOCK_LANALYSIS__SPORT_LANALYSIS:
                setSPortLAnalysis((ISPortLAnalysis) null);
                return;
            case IESFLocalAnalysisPackage.SBLOCK_LANALYSIS__BASE_CLASS:
                setBase_Class((org.eclipse.uml2.uml.Class) null);
                return;
            case IESFLocalAnalysisPackage.SBLOCK_LANALYSIS__SLOGICAL_GATES_LANALYSIS_LIST:
                getSLogicalGatesLAnalysisList().clear();
                return;
            case IESFLocalAnalysisPackage.SBLOCK_LANALYSIS__SFAILURE_MODES_LANALYSIS_LIST:
                getSFailureModesLAnalysisList().clear();
                return;
            case IESFLocalAnalysisPackage.SBLOCK_LANALYSIS__SBARRIERS_LANALYSIS_LIST:
                getSBarriersLAnalysisList().clear();
                return;
            case IESFLocalAnalysisPackage.SBLOCK_LANALYSIS__SPROPAGATION_LINKS_LIST:
                getSPropagationLinksList().clear();
                return;
        }
        super.eUnset(featureID);
    }

    /**
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * 
     * @generated
     */
    @Override
    public boolean eIsSet(int featureID) {
        switch (featureID) {
            case IESFLocalAnalysisPackage.SBLOCK_LANALYSIS__SBLOCK:
                return sBlock != null;
            case IESFLocalAnalysisPackage.SBLOCK_LANALYSIS__SFAILURE_EVENTS_LANALYSIS_LIST:
                return sFailureEventsLAnalysisList != null && !sFailureEventsLAnalysisList.isEmpty();
            case IESFLocalAnalysisPackage.SBLOCK_LANALYSIS__SPORT_LANALYSIS:
                return sPortLAnalysis != null;
            case IESFLocalAnalysisPackage.SBLOCK_LANALYSIS__BASE_CLASS:
                return base_Class != null;
            case IESFLocalAnalysisPackage.SBLOCK_LANALYSIS__SLOGICAL_GATES_LANALYSIS_LIST:
                return sLogicalGatesLAnalysisList != null && !sLogicalGatesLAnalysisList.isEmpty();
            case IESFLocalAnalysisPackage.SBLOCK_LANALYSIS__SFAILURE_MODES_LANALYSIS_LIST:
                return sFailureModesLAnalysisList != null && !sFailureModesLAnalysisList.isEmpty();
            case IESFLocalAnalysisPackage.SBLOCK_LANALYSIS__SBARRIERS_LANALYSIS_LIST:
                return sBarriersLAnalysisList != null && !sBarriersLAnalysisList.isEmpty();
            case IESFLocalAnalysisPackage.SBLOCK_LANALYSIS__SPROPAGATION_LINKS_LIST:
                return sPropagationLinksList != null && !sPropagationLinksList.isEmpty();
        }
        return super.eIsSet(featureID);
    }

} // SBlockLAnalysis
