/*******************************************************************************
 * Copyright (c) 2016 ALL4TEC & CEA LIST.
 * All rights reserved. This program and the accompanying materials
 * are made available under the terms of the Eclipse Public License v1.0
 * which accompanies this distribution, and is available at
 * http://www.eclipse.org/legal/epl-v10.html
 *   
 * Contributors:
 *      ALL4TEC & CEA LIST - initial API and implementation
 *******************************************************************************/
package org.polarsys.esf.esflocalanalysis.impl;

import java.lang.reflect.InvocationTargetException;

import java.util.Map;

import org.eclipse.emf.common.notify.Notification;

import org.eclipse.emf.common.util.BasicDiagnostic;
import org.eclipse.emf.common.util.Diagnostic;
import org.eclipse.emf.common.util.DiagnosticChain;
import org.eclipse.emf.common.util.EList;

import org.eclipse.emf.ecore.EClass;
import org.eclipse.emf.ecore.InternalEObject;

import org.eclipse.emf.ecore.impl.ENotificationImpl;

import org.eclipse.emf.ecore.plugin.EcorePlugin;

import org.eclipse.emf.ecore.util.EObjectValidator;

import org.eclipse.uml2.uml.Connector;

import org.polarsys.esf.esflocalanalysis.IAbstractSFailureModeLAnalysis;
import org.polarsys.esf.esflocalanalysis.IESFLocalAnalysisPackage;
import org.polarsys.esf.esflocalanalysis.ISBarrierLAnalysis;
import org.polarsys.esf.esflocalanalysis.ISDysfunctionalAssociation;
import org.polarsys.esf.esflocalanalysis.ISPortLAnalysis;

import org.polarsys.esf.esflocalanalysis.util.ESFLocalAnalysisValidator;

/**
 * <!-- begin-user-doc -->
 * An implementation of the model object '<em><b>SDysfunctional Association</b></em>'.
 * <!-- end-user-doc -->
 * <p>
 * The following features are implemented:
 * </p>
 * <ul>
 * <li>{@link org.polarsys.esf.esflocalanalysis.impl.SDysfunctionalAssociation#getSPortLAnalysis <em>SPort
 * LAnalysis</em>}</li>
 * <li>{@link org.polarsys.esf.esflocalanalysis.impl.SDysfunctionalAssociation#getSBarrierLAnalysis <em>SBarrier
 * LAnalysis</em>}</li>
 * <li>{@link org.polarsys.esf.esflocalanalysis.impl.SDysfunctionalAssociation#getSFailureModeLAnalysis <em>SFailure
 * Mode LAnalysis</em>}</li>
 * <li>{@link org.polarsys.esf.esflocalanalysis.impl.SDysfunctionalAssociation#getBase_Connector <em>Base
 * Connector</em>}</li>
 * </ul>
 *
 * @generated
 */
public class SDysfunctionalAssociation
    extends AbstractSLocalAnalysisElement
    implements ISDysfunctionalAssociation {

    /**
     * The cached value of the '{@link #getSPortLAnalysis() <em>SPort LAnalysis</em>}' reference.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * 
     * @see #getSPortLAnalysis()
     * @generated
     * @ordered
     */
    protected ISPortLAnalysis sPortLAnalysis;

    /**
     * The cached value of the '{@link #getSBarrierLAnalysis() <em>SBarrier LAnalysis</em>}' reference.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * 
     * @see #getSBarrierLAnalysis()
     * @generated
     * @ordered
     */
    protected ISBarrierLAnalysis sBarrierLAnalysis;

    /**
     * The cached value of the '{@link #getSFailureModeLAnalysis() <em>SFailure Mode LAnalysis</em>}' reference.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * 
     * @see #getSFailureModeLAnalysis()
     * @generated
     * @ordered
     */
    protected IAbstractSFailureModeLAnalysis sFailureModeLAnalysis;

    /**
     * The cached value of the '{@link #getBase_Connector() <em>Base Connector</em>}' reference.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * 
     * @see #getBase_Connector()
     * @generated
     * @ordered
     */
    protected Connector base_Connector;

    /**
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * 
     * @generated
     */
    protected SDysfunctionalAssociation() {
        super();
    }

    /**
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * 
     * @generated
     */
    @Override
    protected EClass eStaticClass() {
        return IESFLocalAnalysisPackage.Literals.SDYSFUNCTIONAL_ASSOCIATION;
    }

    /**
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * 
     * @generated
     */
    public ISPortLAnalysis getSPortLAnalysis() {
        if (sPortLAnalysis != null && sPortLAnalysis.eIsProxy()) {
            InternalEObject oldSPortLAnalysis = (InternalEObject) sPortLAnalysis;
            sPortLAnalysis = (ISPortLAnalysis) eResolveProxy(oldSPortLAnalysis);
            if (sPortLAnalysis != oldSPortLAnalysis) {
                if (eNotificationRequired())
                    eNotify(
                        new ENotificationImpl(
                            this,
                            Notification.RESOLVE,
                            IESFLocalAnalysisPackage.SDYSFUNCTIONAL_ASSOCIATION__SPORT_LANALYSIS,
                            oldSPortLAnalysis,
                            sPortLAnalysis));
            }
        }
        return sPortLAnalysis;
    }

    /**
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * 
     * @generated
     */
    public ISPortLAnalysis basicGetSPortLAnalysis() {
        return sPortLAnalysis;
    }

    /**
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * 
     * @generated
     */
    public void setSPortLAnalysis(ISPortLAnalysis newSPortLAnalysis) {
        ISPortLAnalysis oldSPortLAnalysis = sPortLAnalysis;
        sPortLAnalysis = newSPortLAnalysis;
        if (eNotificationRequired())
            eNotify(
                new ENotificationImpl(
                    this,
                    Notification.SET,
                    IESFLocalAnalysisPackage.SDYSFUNCTIONAL_ASSOCIATION__SPORT_LANALYSIS,
                    oldSPortLAnalysis,
                    sPortLAnalysis));
    }

    /**
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * 
     * @generated
     */
    public ISBarrierLAnalysis getSBarrierLAnalysis() {
        if (sBarrierLAnalysis != null && sBarrierLAnalysis.eIsProxy()) {
            InternalEObject oldSBarrierLAnalysis = (InternalEObject) sBarrierLAnalysis;
            sBarrierLAnalysis = (ISBarrierLAnalysis) eResolveProxy(oldSBarrierLAnalysis);
            if (sBarrierLAnalysis != oldSBarrierLAnalysis) {
                if (eNotificationRequired())
                    eNotify(
                        new ENotificationImpl(
                            this,
                            Notification.RESOLVE,
                            IESFLocalAnalysisPackage.SDYSFUNCTIONAL_ASSOCIATION__SBARRIER_LANALYSIS,
                            oldSBarrierLAnalysis,
                            sBarrierLAnalysis));
            }
        }
        return sBarrierLAnalysis;
    }

    /**
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * 
     * @generated
     */
    public ISBarrierLAnalysis basicGetSBarrierLAnalysis() {
        return sBarrierLAnalysis;
    }

    /**
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * 
     * @generated
     */
    public void setSBarrierLAnalysis(ISBarrierLAnalysis newSBarrierLAnalysis) {
        ISBarrierLAnalysis oldSBarrierLAnalysis = sBarrierLAnalysis;
        sBarrierLAnalysis = newSBarrierLAnalysis;
        if (eNotificationRequired())
            eNotify(
                new ENotificationImpl(
                    this,
                    Notification.SET,
                    IESFLocalAnalysisPackage.SDYSFUNCTIONAL_ASSOCIATION__SBARRIER_LANALYSIS,
                    oldSBarrierLAnalysis,
                    sBarrierLAnalysis));
    }

    /**
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * 
     * @generated
     */
    public IAbstractSFailureModeLAnalysis getSFailureModeLAnalysis() {
        if (sFailureModeLAnalysis != null && sFailureModeLAnalysis.eIsProxy()) {
            InternalEObject oldSFailureModeLAnalysis = (InternalEObject) sFailureModeLAnalysis;
            sFailureModeLAnalysis = (IAbstractSFailureModeLAnalysis) eResolveProxy(oldSFailureModeLAnalysis);
            if (sFailureModeLAnalysis != oldSFailureModeLAnalysis) {
                if (eNotificationRequired())
                    eNotify(
                        new ENotificationImpl(
                            this,
                            Notification.RESOLVE,
                            IESFLocalAnalysisPackage.SDYSFUNCTIONAL_ASSOCIATION__SFAILURE_MODE_LANALYSIS,
                            oldSFailureModeLAnalysis,
                            sFailureModeLAnalysis));
            }
        }
        return sFailureModeLAnalysis;
    }

    /**
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * 
     * @generated
     */
    public IAbstractSFailureModeLAnalysis basicGetSFailureModeLAnalysis() {
        return sFailureModeLAnalysis;
    }

    /**
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * 
     * @generated
     */
    public void setSFailureModeLAnalysis(IAbstractSFailureModeLAnalysis newSFailureModeLAnalysis) {
        IAbstractSFailureModeLAnalysis oldSFailureModeLAnalysis = sFailureModeLAnalysis;
        sFailureModeLAnalysis = newSFailureModeLAnalysis;
        if (eNotificationRequired())
            eNotify(
                new ENotificationImpl(
                    this,
                    Notification.SET,
                    IESFLocalAnalysisPackage.SDYSFUNCTIONAL_ASSOCIATION__SFAILURE_MODE_LANALYSIS,
                    oldSFailureModeLAnalysis,
                    sFailureModeLAnalysis));
    }

    /**
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * 
     * @generated
     */
    public Connector getBase_Connector() {
        if (base_Connector != null && base_Connector.eIsProxy()) {
            InternalEObject oldBase_Connector = (InternalEObject) base_Connector;
            base_Connector = (Connector) eResolveProxy(oldBase_Connector);
            if (base_Connector != oldBase_Connector) {
                if (eNotificationRequired())
                    eNotify(
                        new ENotificationImpl(
                            this,
                            Notification.RESOLVE,
                            IESFLocalAnalysisPackage.SDYSFUNCTIONAL_ASSOCIATION__BASE_CONNECTOR,
                            oldBase_Connector,
                            base_Connector));
            }
        }
        return base_Connector;
    }

    /**
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * 
     * @generated
     */
    public Connector basicGetBase_Connector() {
        return base_Connector;
    }

    /**
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * 
     * @generated
     */
    public void setBase_Connector(Connector newBase_Connector) {
        Connector oldBase_Connector = base_Connector;
        base_Connector = newBase_Connector;
        if (eNotificationRequired())
            eNotify(
                new ENotificationImpl(
                    this,
                    Notification.SET,
                    IESFLocalAnalysisPackage.SDYSFUNCTIONAL_ASSOCIATION__BASE_CONNECTOR,
                    oldBase_Connector,
                    base_Connector));
    }

    /**
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * 
     * @generated
     */
    public boolean Constraint1(DiagnosticChain diagnostics, Map<Object, Object> context) {
        // TODO: implement this method
        // -> specify the condition that violates the invariant
        // -> verify the details of the diagnostic, including severity and message
        // Ensure that you remove @generated or mark it @generated NOT
        if (false) {
            if (diagnostics != null) {
                diagnostics.add(
                    new BasicDiagnostic(
                        Diagnostic.ERROR,
                        ESFLocalAnalysisValidator.DIAGNOSTIC_SOURCE,
                        ESFLocalAnalysisValidator.SDYSFUNCTIONAL_ASSOCIATION__CONSTRAINT1,
                        EcorePlugin.INSTANCE.getString(
                            "_UI_GenericInvariant_diagnostic", //$NON-NLS-1$
                            new Object[] {"Constraint1", EObjectValidator.getObjectLabel(this, context)}), //$NON-NLS-1$
                        new Object[] {this}));
            }
            return false;
        }
        return true;
    }

    /**
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * 
     * @generated
     */
    @Override
    public Object eGet(int featureID, boolean resolve, boolean coreType) {
        switch (featureID) {
            case IESFLocalAnalysisPackage.SDYSFUNCTIONAL_ASSOCIATION__SPORT_LANALYSIS:
                if (resolve)
                    return getSPortLAnalysis();
                return basicGetSPortLAnalysis();
            case IESFLocalAnalysisPackage.SDYSFUNCTIONAL_ASSOCIATION__SBARRIER_LANALYSIS:
                if (resolve)
                    return getSBarrierLAnalysis();
                return basicGetSBarrierLAnalysis();
            case IESFLocalAnalysisPackage.SDYSFUNCTIONAL_ASSOCIATION__SFAILURE_MODE_LANALYSIS:
                if (resolve)
                    return getSFailureModeLAnalysis();
                return basicGetSFailureModeLAnalysis();
            case IESFLocalAnalysisPackage.SDYSFUNCTIONAL_ASSOCIATION__BASE_CONNECTOR:
                if (resolve)
                    return getBase_Connector();
                return basicGetBase_Connector();
        }
        return super.eGet(featureID, resolve, coreType);
    }

    /**
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * 
     * @generated
     */
    @Override
    public void eSet(int featureID, Object newValue) {
        switch (featureID) {
            case IESFLocalAnalysisPackage.SDYSFUNCTIONAL_ASSOCIATION__SPORT_LANALYSIS:
                setSPortLAnalysis((ISPortLAnalysis) newValue);
                return;
            case IESFLocalAnalysisPackage.SDYSFUNCTIONAL_ASSOCIATION__SBARRIER_LANALYSIS:
                setSBarrierLAnalysis((ISBarrierLAnalysis) newValue);
                return;
            case IESFLocalAnalysisPackage.SDYSFUNCTIONAL_ASSOCIATION__SFAILURE_MODE_LANALYSIS:
                setSFailureModeLAnalysis((IAbstractSFailureModeLAnalysis) newValue);
                return;
            case IESFLocalAnalysisPackage.SDYSFUNCTIONAL_ASSOCIATION__BASE_CONNECTOR:
                setBase_Connector((Connector) newValue);
                return;
        }
        super.eSet(featureID, newValue);
    }

    /**
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * 
     * @generated
     */
    @Override
    public void eUnset(int featureID) {
        switch (featureID) {
            case IESFLocalAnalysisPackage.SDYSFUNCTIONAL_ASSOCIATION__SPORT_LANALYSIS:
                setSPortLAnalysis((ISPortLAnalysis) null);
                return;
            case IESFLocalAnalysisPackage.SDYSFUNCTIONAL_ASSOCIATION__SBARRIER_LANALYSIS:
                setSBarrierLAnalysis((ISBarrierLAnalysis) null);
                return;
            case IESFLocalAnalysisPackage.SDYSFUNCTIONAL_ASSOCIATION__SFAILURE_MODE_LANALYSIS:
                setSFailureModeLAnalysis((IAbstractSFailureModeLAnalysis) null);
                return;
            case IESFLocalAnalysisPackage.SDYSFUNCTIONAL_ASSOCIATION__BASE_CONNECTOR:
                setBase_Connector((Connector) null);
                return;
        }
        super.eUnset(featureID);
    }

    /**
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * 
     * @generated
     */
    @Override
    public boolean eIsSet(int featureID) {
        switch (featureID) {
            case IESFLocalAnalysisPackage.SDYSFUNCTIONAL_ASSOCIATION__SPORT_LANALYSIS:
                return sPortLAnalysis != null;
            case IESFLocalAnalysisPackage.SDYSFUNCTIONAL_ASSOCIATION__SBARRIER_LANALYSIS:
                return sBarrierLAnalysis != null;
            case IESFLocalAnalysisPackage.SDYSFUNCTIONAL_ASSOCIATION__SFAILURE_MODE_LANALYSIS:
                return sFailureModeLAnalysis != null;
            case IESFLocalAnalysisPackage.SDYSFUNCTIONAL_ASSOCIATION__BASE_CONNECTOR:
                return base_Connector != null;
        }
        return super.eIsSet(featureID);
    }

    /**
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * 
     * @generated
     */
    @Override
    @SuppressWarnings("unchecked")
    public Object eInvoke(int operationID, EList<?> arguments) throws InvocationTargetException {
        switch (operationID) {
            case IESFLocalAnalysisPackage.SDYSFUNCTIONAL_ASSOCIATION___CONSTRAINT1__DIAGNOSTICCHAIN_MAP:
                return Constraint1((DiagnosticChain) arguments.get(0), (Map<Object, Object>) arguments.get(1));
        }
        return super.eInvoke(operationID, arguments);
    }

} // SDysfunctionalAssociation
