/*******************************************************************************
 * Copyright (c) 2016 ALL4TEC & CEA LIST.
 * All rights reserved. This program and the accompanying materials
 * are made available under the terms of the Eclipse Public License v1.0
 * which accompanies this distribution, and is available at
 * http://www.eclipse.org/legal/epl-v10.html
 *   
 * Contributors:
 *      ALL4TEC & CEA LIST - initial API and implementation
 *******************************************************************************/
package org.polarsys.esf.esflocalanalysis.impl;

import java.util.Collection;

import org.eclipse.emf.common.notify.Notification;

import org.eclipse.emf.common.notify.NotificationChain;
import org.eclipse.emf.common.util.EList;

import org.eclipse.emf.ecore.EClass;
import org.eclipse.emf.ecore.InternalEObject;

import org.eclipse.emf.ecore.impl.ENotificationImpl;

import org.polarsys.esf.esfcore.impl.AbstractSSafetyAnalysis;

import org.polarsys.esf.esflocalanalysis.IESFLocalAnalysisPackage;
import org.polarsys.esf.esflocalanalysis.ISBlockLAnalysis;
import org.polarsys.esf.esflocalanalysis.ISLocalAnalysis;
import org.polarsys.esf.esflocalanalysis.ISSystemEventsLibrary;

/**
 * <!-- begin-user-doc -->
 * An implementation of the model object '<em><b>SLocal Analysis</b></em>'.
 * <!-- end-user-doc -->
 * <p>
 * The following features are implemented:
 * </p>
 * <ul>
 * <li>{@link org.polarsys.esf.esflocalanalysis.impl.SLocalAnalysis#getSBlocksLAnalysisList <em>SBlocks LAnalysis
 * List</em>}</li>
 * <li>{@link org.polarsys.esf.esflocalanalysis.impl.SLocalAnalysis#getBase_Package <em>Base Package</em>}</li>
 * <li>{@link org.polarsys.esf.esflocalanalysis.impl.SLocalAnalysis#getSSystemEventsLibrary <em>SSystem Events
 * Library</em>}</li>
 * </ul>
 *
 * @generated
 */
public class SLocalAnalysis
    extends AbstractSSafetyAnalysis
    implements ISLocalAnalysis {

    /**
     * The cached value of the '{@link #getBase_Package() <em>Base Package</em>}' reference.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * 
     * @see #getBase_Package()
     * @generated
     * @ordered
     */
    protected org.eclipse.uml2.uml.Package base_Package;

    /**
     * The cached value of the '{@link #getSSystemEventsLibrary() <em>SSystem Events Library</em>}' containment
     * reference.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * 
     * @see #getSSystemEventsLibrary()
     * @generated
     * @ordered
     */
    protected ISSystemEventsLibrary sSystemEventsLibrary;

    /**
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * 
     * @generated
     */
    protected SLocalAnalysis() {
        super();
    }

    /**
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * 
     * @generated
     */
    @Override
    protected EClass eStaticClass() {
        return IESFLocalAnalysisPackage.Literals.SLOCAL_ANALYSIS;
    }

    /**
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * 
     * @generated
     */
    public EList<ISBlockLAnalysis> getSBlocksLAnalysisList() {
        // TODO: implement this method to return the 'SBlocks LAnalysis List' reference list
        // Ensure that you remove @generated or mark it @generated NOT
        throw new UnsupportedOperationException();
    }

    /**
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * 
     * @generated
     */
    public org.eclipse.uml2.uml.Package getBase_Package() {
        if (base_Package != null && base_Package.eIsProxy()) {
            InternalEObject oldBase_Package = (InternalEObject) base_Package;
            base_Package = (org.eclipse.uml2.uml.Package) eResolveProxy(oldBase_Package);
            if (base_Package != oldBase_Package) {
                if (eNotificationRequired())
                    eNotify(
                        new ENotificationImpl(
                            this,
                            Notification.RESOLVE,
                            IESFLocalAnalysisPackage.SLOCAL_ANALYSIS__BASE_PACKAGE,
                            oldBase_Package,
                            base_Package));
            }
        }
        return base_Package;
    }

    /**
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * 
     * @generated
     */
    public org.eclipse.uml2.uml.Package basicGetBase_Package() {
        return base_Package;
    }

    /**
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * 
     * @generated
     */
    public void setBase_Package(org.eclipse.uml2.uml.Package newBase_Package) {
        org.eclipse.uml2.uml.Package oldBase_Package = base_Package;
        base_Package = newBase_Package;
        if (eNotificationRequired())
            eNotify(
                new ENotificationImpl(
                    this,
                    Notification.SET,
                    IESFLocalAnalysisPackage.SLOCAL_ANALYSIS__BASE_PACKAGE,
                    oldBase_Package,
                    base_Package));
    }

    /**
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * 
     * @generated
     */
    public ISSystemEventsLibrary getSSystemEventsLibrary() {
        return sSystemEventsLibrary;
    }

    /**
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * 
     * @generated
     */
    public NotificationChain basicSetSSystemEventsLibrary(
        ISSystemEventsLibrary newSSystemEventsLibrary,
        NotificationChain msgs) {
        ISSystemEventsLibrary oldSSystemEventsLibrary = sSystemEventsLibrary;
        sSystemEventsLibrary = newSSystemEventsLibrary;
        if (eNotificationRequired()) {
            ENotificationImpl notification = new ENotificationImpl(
                this,
                Notification.SET,
                IESFLocalAnalysisPackage.SLOCAL_ANALYSIS__SSYSTEM_EVENTS_LIBRARY,
                oldSSystemEventsLibrary,
                newSSystemEventsLibrary);
            if (msgs == null)
                msgs = notification;
            else
                msgs.add(notification);
        }
        return msgs;
    }

    /**
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * 
     * @generated
     */
    public void setSSystemEventsLibrary(ISSystemEventsLibrary newSSystemEventsLibrary) {
        if (newSSystemEventsLibrary != sSystemEventsLibrary) {
            NotificationChain msgs = null;
            if (sSystemEventsLibrary != null)
                msgs = ((InternalEObject) sSystemEventsLibrary).eInverseRemove(
                    this,
                    EOPPOSITE_FEATURE_BASE - IESFLocalAnalysisPackage.SLOCAL_ANALYSIS__SSYSTEM_EVENTS_LIBRARY,
                    null,
                    msgs);
            if (newSSystemEventsLibrary != null)
                msgs = ((InternalEObject) newSSystemEventsLibrary).eInverseAdd(
                    this,
                    EOPPOSITE_FEATURE_BASE - IESFLocalAnalysisPackage.SLOCAL_ANALYSIS__SSYSTEM_EVENTS_LIBRARY,
                    null,
                    msgs);
            msgs = basicSetSSystemEventsLibrary(newSSystemEventsLibrary, msgs);
            if (msgs != null)
                msgs.dispatch();
        } else if (eNotificationRequired())
            eNotify(
                new ENotificationImpl(
                    this,
                    Notification.SET,
                    IESFLocalAnalysisPackage.SLOCAL_ANALYSIS__SSYSTEM_EVENTS_LIBRARY,
                    newSSystemEventsLibrary,
                    newSSystemEventsLibrary));
    }

    /**
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * 
     * @generated
     */
    @Override
    public NotificationChain eInverseRemove(InternalEObject otherEnd, int featureID, NotificationChain msgs) {
        switch (featureID) {
            case IESFLocalAnalysisPackage.SLOCAL_ANALYSIS__SSYSTEM_EVENTS_LIBRARY:
                return basicSetSSystemEventsLibrary(null, msgs);
        }
        return super.eInverseRemove(otherEnd, featureID, msgs);
    }

    /**
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * 
     * @generated
     */
    @Override
    public Object eGet(int featureID, boolean resolve, boolean coreType) {
        switch (featureID) {
            case IESFLocalAnalysisPackage.SLOCAL_ANALYSIS__SBLOCKS_LANALYSIS_LIST:
                return getSBlocksLAnalysisList();
            case IESFLocalAnalysisPackage.SLOCAL_ANALYSIS__BASE_PACKAGE:
                if (resolve)
                    return getBase_Package();
                return basicGetBase_Package();
            case IESFLocalAnalysisPackage.SLOCAL_ANALYSIS__SSYSTEM_EVENTS_LIBRARY:
                return getSSystemEventsLibrary();
        }
        return super.eGet(featureID, resolve, coreType);
    }

    /**
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * 
     * @generated
     */
    @SuppressWarnings("unchecked")
    @Override
    public void eSet(int featureID, Object newValue) {
        switch (featureID) {
            case IESFLocalAnalysisPackage.SLOCAL_ANALYSIS__SBLOCKS_LANALYSIS_LIST:
                getSBlocksLAnalysisList().clear();
                getSBlocksLAnalysisList().addAll((Collection<? extends ISBlockLAnalysis>) newValue);
                return;
            case IESFLocalAnalysisPackage.SLOCAL_ANALYSIS__BASE_PACKAGE:
                setBase_Package((org.eclipse.uml2.uml.Package) newValue);
                return;
            case IESFLocalAnalysisPackage.SLOCAL_ANALYSIS__SSYSTEM_EVENTS_LIBRARY:
                setSSystemEventsLibrary((ISSystemEventsLibrary) newValue);
                return;
        }
        super.eSet(featureID, newValue);
    }

    /**
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * 
     * @generated
     */
    @Override
    public void eUnset(int featureID) {
        switch (featureID) {
            case IESFLocalAnalysisPackage.SLOCAL_ANALYSIS__SBLOCKS_LANALYSIS_LIST:
                getSBlocksLAnalysisList().clear();
                return;
            case IESFLocalAnalysisPackage.SLOCAL_ANALYSIS__BASE_PACKAGE:
                setBase_Package((org.eclipse.uml2.uml.Package) null);
                return;
            case IESFLocalAnalysisPackage.SLOCAL_ANALYSIS__SSYSTEM_EVENTS_LIBRARY:
                setSSystemEventsLibrary((ISSystemEventsLibrary) null);
                return;
        }
        super.eUnset(featureID);
    }

    /**
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * 
     * @generated
     */
    @Override
    public boolean eIsSet(int featureID) {
        switch (featureID) {
            case IESFLocalAnalysisPackage.SLOCAL_ANALYSIS__SBLOCKS_LANALYSIS_LIST:
                return !getSBlocksLAnalysisList().isEmpty();
            case IESFLocalAnalysisPackage.SLOCAL_ANALYSIS__BASE_PACKAGE:
                return base_Package != null;
            case IESFLocalAnalysisPackage.SLOCAL_ANALYSIS__SSYSTEM_EVENTS_LIBRARY:
                return sSystemEventsLibrary != null;
        }
        return super.eIsSet(featureID);
    }

} // SLocalAnalysis
