/*******************************************************************************
 * Copyright (c) 2016 ALL4TEC & CEA LIST.
 * All rights reserved. This program and the accompanying materials
 * are made available under the terms of the Eclipse Public License v1.0
 * which accompanies this distribution, and is available at
 * http://www.eclipse.org/legal/epl-v10.html
 *   
 * Contributors:
 *      ALL4TEC & CEA LIST - initial API and implementation
 *******************************************************************************/
package org.polarsys.esf.esflocalanalysis.impl;

import java.util.Collection;

import org.eclipse.emf.common.notify.Notification;

import org.eclipse.emf.common.notify.NotificationChain;
import org.eclipse.emf.common.util.EList;

import org.eclipse.emf.ecore.EClass;
import org.eclipse.emf.ecore.InternalEObject;

import org.eclipse.emf.ecore.impl.ENotificationImpl;

import org.eclipse.emf.ecore.util.EObjectResolvingEList;

import org.eclipse.emf.ecore.util.EcoreUtil;
import org.eclipse.uml2.uml.Port;

import org.polarsys.esf.esfarchitectureconcepts.ISPort;

import org.polarsys.esf.esflocalanalysis.IAbstractSFailureModeLAnalysis;
import org.polarsys.esf.esflocalanalysis.IESFLocalAnalysisPackage;
import org.polarsys.esf.esflocalanalysis.ISBlockLAnalysis;
import org.polarsys.esf.esflocalanalysis.ISPortLAnalysis;
import org.polarsys.esf.esflocalanalysis.SDirectionLAnalysis;

/**
 * <!-- begin-user-doc -->
 * An implementation of the model object '<em><b>SPort LAnalysis</b></em>'.
 * <!-- end-user-doc -->
 * <p>
 * The following features are implemented:
 * </p>
 * <ul>
 * <li>{@link org.polarsys.esf.esflocalanalysis.impl.SPortLAnalysis#getSFailureModesLAnalysisList <em>SFailure Modes
 * LAnalysis List</em>}</li>
 * <li>{@link org.polarsys.esf.esflocalanalysis.impl.SPortLAnalysis#getSBlockLAnalysis <em>SBlock LAnalysis</em>}</li>
 * <li>{@link org.polarsys.esf.esflocalanalysis.impl.SPortLAnalysis#getSPort <em>SPort</em>}</li>
 * <li>{@link org.polarsys.esf.esflocalanalysis.impl.SPortLAnalysis#getBase_Port <em>Base Port</em>}</li>
 * <li>{@link org.polarsys.esf.esflocalanalysis.impl.SPortLAnalysis#getSDirectionLAnalysis <em>SDirection
 * LAnalysis</em>}</li>
 * </ul>
 *
 * @generated
 */
public class SPortLAnalysis
    extends AbstractSLocalAnalysisElement
    implements ISPortLAnalysis {

    /**
     * The cached value of the '{@link #getSFailureModesLAnalysisList() <em>SFailure Modes LAnalysis List</em>}'
     * reference list.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * 
     * @see #getSFailureModesLAnalysisList()
     * @generated
     * @ordered
     */
    protected EList<IAbstractSFailureModeLAnalysis> sFailureModesLAnalysisList;

    /**
     * The cached value of the '{@link #getSPort() <em>SPort</em>}' reference.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * 
     * @see #getSPort()
     * @generated
     * @ordered
     */
    protected ISPort sPort;

    /**
     * The cached value of the '{@link #getBase_Port() <em>Base Port</em>}' reference.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * 
     * @see #getBase_Port()
     * @generated
     * @ordered
     */
    protected Port base_Port;

    /**
     * The default value of the '{@link #getSDirectionLAnalysis() <em>SDirection LAnalysis</em>}' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * 
     * @see #getSDirectionLAnalysis()
     * @generated
     * @ordered
     */
    protected static final SDirectionLAnalysis SDIRECTION_LANALYSIS_EDEFAULT = SDirectionLAnalysis.IN;

    /**
     * The cached value of the '{@link #getSDirectionLAnalysis() <em>SDirection LAnalysis</em>}' attribute.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * 
     * @see #getSDirectionLAnalysis()
     * @generated
     * @ordered
     */
    protected SDirectionLAnalysis sDirectionLAnalysis = SDIRECTION_LANALYSIS_EDEFAULT;

    /**
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * 
     * @generated
     */
    protected SPortLAnalysis() {
        super();
    }

    /**
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * 
     * @generated
     */
    @Override
    protected EClass eStaticClass() {
        return IESFLocalAnalysisPackage.Literals.SPORT_LANALYSIS;
    }

    /**
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * 
     * @generated
     */
    public EList<IAbstractSFailureModeLAnalysis> getSFailureModesLAnalysisList() {
        if (sFailureModesLAnalysisList == null) {
            sFailureModesLAnalysisList = new EObjectResolvingEList<IAbstractSFailureModeLAnalysis>(
                IAbstractSFailureModeLAnalysis.class,
                this,
                IESFLocalAnalysisPackage.SPORT_LANALYSIS__SFAILURE_MODES_LANALYSIS_LIST);
        }
        return sFailureModesLAnalysisList;
    }

    /**
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * 
     * @generated
     */
    public ISBlockLAnalysis getSBlockLAnalysis() {
        if (eContainerFeatureID() != IESFLocalAnalysisPackage.SPORT_LANALYSIS__SBLOCK_LANALYSIS)
            return null;
        return (ISBlockLAnalysis) eInternalContainer();
    }

    /**
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * 
     * @generated
     */
    public NotificationChain basicSetSBlockLAnalysis(ISBlockLAnalysis newSBlockLAnalysis, NotificationChain msgs) {
        msgs = eBasicSetContainer(
            (InternalEObject) newSBlockLAnalysis,
            IESFLocalAnalysisPackage.SPORT_LANALYSIS__SBLOCK_LANALYSIS,
            msgs);
        return msgs;
    }

    /**
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * 
     * @generated
     */
    public void setSBlockLAnalysis(ISBlockLAnalysis newSBlockLAnalysis) {
        if (newSBlockLAnalysis != eInternalContainer()
            || (eContainerFeatureID() != IESFLocalAnalysisPackage.SPORT_LANALYSIS__SBLOCK_LANALYSIS
                && newSBlockLAnalysis != null)) {
            if (EcoreUtil.isAncestor(this, newSBlockLAnalysis))
                throw new IllegalArgumentException("Recursive containment not allowed for " + toString()); //$NON-NLS-1$
            NotificationChain msgs = null;
            if (eInternalContainer() != null)
                msgs = eBasicRemoveFromContainer(msgs);
            if (newSBlockLAnalysis != null)
                msgs = ((InternalEObject) newSBlockLAnalysis).eInverseAdd(
                    this,
                    IESFLocalAnalysisPackage.SBLOCK_LANALYSIS__SPORT_LANALYSIS,
                    ISBlockLAnalysis.class,
                    msgs);
            msgs = basicSetSBlockLAnalysis(newSBlockLAnalysis, msgs);
            if (msgs != null)
                msgs.dispatch();
        } else if (eNotificationRequired())
            eNotify(
                new ENotificationImpl(
                    this,
                    Notification.SET,
                    IESFLocalAnalysisPackage.SPORT_LANALYSIS__SBLOCK_LANALYSIS,
                    newSBlockLAnalysis,
                    newSBlockLAnalysis));
    }

    /**
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * 
     * @generated
     */
    public ISPort getSPort() {
        if (sPort != null && sPort.eIsProxy()) {
            InternalEObject oldSPort = (InternalEObject) sPort;
            sPort = (ISPort) eResolveProxy(oldSPort);
            if (sPort != oldSPort) {
                if (eNotificationRequired())
                    eNotify(
                        new ENotificationImpl(
                            this,
                            Notification.RESOLVE,
                            IESFLocalAnalysisPackage.SPORT_LANALYSIS__SPORT,
                            oldSPort,
                            sPort));
            }
        }
        return sPort;
    }

    /**
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * 
     * @generated
     */
    public ISPort basicGetSPort() {
        return sPort;
    }

    /**
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * 
     * @generated
     */
    public void setSPort(ISPort newSPort) {
        ISPort oldSPort = sPort;
        sPort = newSPort;
        if (eNotificationRequired())
            eNotify(
                new ENotificationImpl(
                    this,
                    Notification.SET,
                    IESFLocalAnalysisPackage.SPORT_LANALYSIS__SPORT,
                    oldSPort,
                    sPort));
    }

    /**
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * 
     * @generated
     */
    public Port getBase_Port() {
        if (base_Port != null && base_Port.eIsProxy()) {
            InternalEObject oldBase_Port = (InternalEObject) base_Port;
            base_Port = (Port) eResolveProxy(oldBase_Port);
            if (base_Port != oldBase_Port) {
                if (eNotificationRequired())
                    eNotify(
                        new ENotificationImpl(
                            this,
                            Notification.RESOLVE,
                            IESFLocalAnalysisPackage.SPORT_LANALYSIS__BASE_PORT,
                            oldBase_Port,
                            base_Port));
            }
        }
        return base_Port;
    }

    /**
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * 
     * @generated
     */
    public Port basicGetBase_Port() {
        return base_Port;
    }

    /**
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * 
     * @generated
     */
    public void setBase_Port(Port newBase_Port) {
        Port oldBase_Port = base_Port;
        base_Port = newBase_Port;
        if (eNotificationRequired())
            eNotify(
                new ENotificationImpl(
                    this,
                    Notification.SET,
                    IESFLocalAnalysisPackage.SPORT_LANALYSIS__BASE_PORT,
                    oldBase_Port,
                    base_Port));
    }

    /**
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * 
     * @generated
     */
    public SDirectionLAnalysis getSDirectionLAnalysis() {
        return sDirectionLAnalysis;
    }

    /**
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * 
     * @generated
     */
    public void setSDirectionLAnalysis(SDirectionLAnalysis newSDirectionLAnalysis) {
        SDirectionLAnalysis oldSDirectionLAnalysis = sDirectionLAnalysis;
        sDirectionLAnalysis = newSDirectionLAnalysis == null ? SDIRECTION_LANALYSIS_EDEFAULT : newSDirectionLAnalysis;
        if (eNotificationRequired())
            eNotify(
                new ENotificationImpl(
                    this,
                    Notification.SET,
                    IESFLocalAnalysisPackage.SPORT_LANALYSIS__SDIRECTION_LANALYSIS,
                    oldSDirectionLAnalysis,
                    sDirectionLAnalysis));
    }

    /**
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * 
     * @generated
     */
    @Override
    public NotificationChain eInverseAdd(InternalEObject otherEnd, int featureID, NotificationChain msgs) {
        switch (featureID) {
            case IESFLocalAnalysisPackage.SPORT_LANALYSIS__SBLOCK_LANALYSIS:
                if (eInternalContainer() != null)
                    msgs = eBasicRemoveFromContainer(msgs);
                return basicSetSBlockLAnalysis((ISBlockLAnalysis) otherEnd, msgs);
        }
        return super.eInverseAdd(otherEnd, featureID, msgs);
    }

    /**
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * 
     * @generated
     */
    @Override
    public NotificationChain eInverseRemove(InternalEObject otherEnd, int featureID, NotificationChain msgs) {
        switch (featureID) {
            case IESFLocalAnalysisPackage.SPORT_LANALYSIS__SBLOCK_LANALYSIS:
                return basicSetSBlockLAnalysis(null, msgs);
        }
        return super.eInverseRemove(otherEnd, featureID, msgs);
    }

    /**
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * 
     * @generated
     */
    @Override
    public NotificationChain eBasicRemoveFromContainerFeature(NotificationChain msgs) {
        switch (eContainerFeatureID()) {
            case IESFLocalAnalysisPackage.SPORT_LANALYSIS__SBLOCK_LANALYSIS:
                return eInternalContainer().eInverseRemove(
                    this,
                    IESFLocalAnalysisPackage.SBLOCK_LANALYSIS__SPORT_LANALYSIS,
                    ISBlockLAnalysis.class,
                    msgs);
        }
        return super.eBasicRemoveFromContainerFeature(msgs);
    }

    /**
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * 
     * @generated
     */
    @Override
    public Object eGet(int featureID, boolean resolve, boolean coreType) {
        switch (featureID) {
            case IESFLocalAnalysisPackage.SPORT_LANALYSIS__SFAILURE_MODES_LANALYSIS_LIST:
                return getSFailureModesLAnalysisList();
            case IESFLocalAnalysisPackage.SPORT_LANALYSIS__SBLOCK_LANALYSIS:
                return getSBlockLAnalysis();
            case IESFLocalAnalysisPackage.SPORT_LANALYSIS__SPORT:
                if (resolve)
                    return getSPort();
                return basicGetSPort();
            case IESFLocalAnalysisPackage.SPORT_LANALYSIS__BASE_PORT:
                if (resolve)
                    return getBase_Port();
                return basicGetBase_Port();
            case IESFLocalAnalysisPackage.SPORT_LANALYSIS__SDIRECTION_LANALYSIS:
                return getSDirectionLAnalysis();
        }
        return super.eGet(featureID, resolve, coreType);
    }

    /**
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * 
     * @generated
     */
    @SuppressWarnings("unchecked")
    @Override
    public void eSet(int featureID, Object newValue) {
        switch (featureID) {
            case IESFLocalAnalysisPackage.SPORT_LANALYSIS__SFAILURE_MODES_LANALYSIS_LIST:
                getSFailureModesLAnalysisList().clear();
                getSFailureModesLAnalysisList().addAll((Collection<? extends IAbstractSFailureModeLAnalysis>) newValue);
                return;
            case IESFLocalAnalysisPackage.SPORT_LANALYSIS__SBLOCK_LANALYSIS:
                setSBlockLAnalysis((ISBlockLAnalysis) newValue);
                return;
            case IESFLocalAnalysisPackage.SPORT_LANALYSIS__SPORT:
                setSPort((ISPort) newValue);
                return;
            case IESFLocalAnalysisPackage.SPORT_LANALYSIS__BASE_PORT:
                setBase_Port((Port) newValue);
                return;
            case IESFLocalAnalysisPackage.SPORT_LANALYSIS__SDIRECTION_LANALYSIS:
                setSDirectionLAnalysis((SDirectionLAnalysis) newValue);
                return;
        }
        super.eSet(featureID, newValue);
    }

    /**
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * 
     * @generated
     */
    @Override
    public void eUnset(int featureID) {
        switch (featureID) {
            case IESFLocalAnalysisPackage.SPORT_LANALYSIS__SFAILURE_MODES_LANALYSIS_LIST:
                getSFailureModesLAnalysisList().clear();
                return;
            case IESFLocalAnalysisPackage.SPORT_LANALYSIS__SBLOCK_LANALYSIS:
                setSBlockLAnalysis((ISBlockLAnalysis) null);
                return;
            case IESFLocalAnalysisPackage.SPORT_LANALYSIS__SPORT:
                setSPort((ISPort) null);
                return;
            case IESFLocalAnalysisPackage.SPORT_LANALYSIS__BASE_PORT:
                setBase_Port((Port) null);
                return;
            case IESFLocalAnalysisPackage.SPORT_LANALYSIS__SDIRECTION_LANALYSIS:
                setSDirectionLAnalysis(SDIRECTION_LANALYSIS_EDEFAULT);
                return;
        }
        super.eUnset(featureID);
    }

    /**
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * 
     * @generated
     */
    @Override
    public boolean eIsSet(int featureID) {
        switch (featureID) {
            case IESFLocalAnalysisPackage.SPORT_LANALYSIS__SFAILURE_MODES_LANALYSIS_LIST:
                return sFailureModesLAnalysisList != null && !sFailureModesLAnalysisList.isEmpty();
            case IESFLocalAnalysisPackage.SPORT_LANALYSIS__SBLOCK_LANALYSIS:
                return getSBlockLAnalysis() != null;
            case IESFLocalAnalysisPackage.SPORT_LANALYSIS__SPORT:
                return sPort != null;
            case IESFLocalAnalysisPackage.SPORT_LANALYSIS__BASE_PORT:
                return base_Port != null;
            case IESFLocalAnalysisPackage.SPORT_LANALYSIS__SDIRECTION_LANALYSIS:
                return sDirectionLAnalysis != SDIRECTION_LANALYSIS_EDEFAULT;
        }
        return super.eIsSet(featureID);
    }

    /**
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * 
     * @generated
     */
    @Override
    public String toString() {
        if (eIsProxy())
            return super.toString();

        StringBuffer result = new StringBuffer(super.toString());
        result.append(" (sDirectionLAnalysis: "); //$NON-NLS-1$
        result.append(sDirectionLAnalysis);
        result.append(')');
        return result.toString();
    }

} // SPortLAnalysis
