/*******************************************************************************
 * Copyright (c) 2016 ALL4TEC & CEA LIST.
 * All rights reserved. This program and the accompanying materials
 * are made available under the terms of the Eclipse Public License v1.0
 * which accompanies this distribution, and is available at
 * http://www.eclipse.org/legal/epl-v10.html
 *   
 * Contributors:
 *      ALL4TEC & CEA LIST - initial API and implementation
 *******************************************************************************/
package org.polarsys.esf.esflocalanalysis.impl;

import org.eclipse.emf.common.notify.Notification;
import org.eclipse.emf.common.notify.NotificationChain;

import org.eclipse.emf.ecore.EClass;
import org.eclipse.emf.ecore.InternalEObject;

import org.eclipse.emf.ecore.impl.ENotificationImpl;

import org.eclipse.emf.ecore.util.EcoreUtil;
import org.eclipse.uml2.uml.Connector;

import org.polarsys.esf.esflocalanalysis.IAbstractSPropagationElement;
import org.polarsys.esf.esflocalanalysis.IESFLocalAnalysisPackage;
import org.polarsys.esf.esflocalanalysis.ISBlockLAnalysis;
import org.polarsys.esf.esflocalanalysis.ISPropagationLink;

/**
 * <!-- begin-user-doc -->
 * An implementation of the model object '<em><b>SPropagation Link</b></em>'.
 * <!-- end-user-doc -->
 * <p>
 * The following features are implemented:
 * </p>
 * <ul>
 * <li>{@link org.polarsys.esf.esflocalanalysis.impl.SPropagationLink#getElementTarget <em>Element Target</em>}</li>
 * <li>{@link org.polarsys.esf.esflocalanalysis.impl.SPropagationLink#getBase_Connector <em>Base Connector</em>}</li>
 * <li>{@link org.polarsys.esf.esflocalanalysis.impl.SPropagationLink#getSBlockLAnalysis <em>SBlock LAnalysis</em>}</li>
 * <li>{@link org.polarsys.esf.esflocalanalysis.impl.SPropagationLink#getElementSource <em>Element Source</em>}</li>
 * </ul>
 *
 * @generated
 */
public class SPropagationLink
    extends AbstractSLocalAnalysisElement
    implements ISPropagationLink {

    /**
     * The cached value of the '{@link #getElementTarget() <em>Element Target</em>}' reference.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * 
     * @see #getElementTarget()
     * @generated
     * @ordered
     */
    protected IAbstractSPropagationElement elementTarget;

    /**
     * The cached value of the '{@link #getBase_Connector() <em>Base Connector</em>}' reference.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * 
     * @see #getBase_Connector()
     * @generated
     * @ordered
     */
    protected Connector base_Connector;

    /**
     * The cached value of the '{@link #getElementSource() <em>Element Source</em>}' reference.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * 
     * @see #getElementSource()
     * @generated
     * @ordered
     */
    protected IAbstractSPropagationElement elementSource;

    /**
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * 
     * @generated
     */
    protected SPropagationLink() {
        super();
    }

    /**
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * 
     * @generated
     */
    @Override
    protected EClass eStaticClass() {
        return IESFLocalAnalysisPackage.Literals.SPROPAGATION_LINK;
    }

    /**
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * 
     * @generated
     */
    public IAbstractSPropagationElement getElementTarget() {
        if (elementTarget != null && elementTarget.eIsProxy()) {
            InternalEObject oldElementTarget = (InternalEObject) elementTarget;
            elementTarget = (IAbstractSPropagationElement) eResolveProxy(oldElementTarget);
            if (elementTarget != oldElementTarget) {
                if (eNotificationRequired())
                    eNotify(
                        new ENotificationImpl(
                            this,
                            Notification.RESOLVE,
                            IESFLocalAnalysisPackage.SPROPAGATION_LINK__ELEMENT_TARGET,
                            oldElementTarget,
                            elementTarget));
            }
        }
        return elementTarget;
    }

    /**
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * 
     * @generated
     */
    public IAbstractSPropagationElement basicGetElementTarget() {
        return elementTarget;
    }

    /**
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * 
     * @generated
     */
    public NotificationChain basicSetElementTarget(
        IAbstractSPropagationElement newElementTarget,
        NotificationChain msgs) {
        IAbstractSPropagationElement oldElementTarget = elementTarget;
        elementTarget = newElementTarget;
        if (eNotificationRequired()) {
            ENotificationImpl notification = new ENotificationImpl(
                this,
                Notification.SET,
                IESFLocalAnalysisPackage.SPROPAGATION_LINK__ELEMENT_TARGET,
                oldElementTarget,
                newElementTarget);
            if (msgs == null)
                msgs = notification;
            else
                msgs.add(notification);
        }
        return msgs;
    }

    /**
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * 
     * @generated
     */
    public void setElementTarget(IAbstractSPropagationElement newElementTarget) {
        if (newElementTarget != elementTarget) {
            NotificationChain msgs = null;
            if (elementTarget != null)
                msgs = ((InternalEObject) elementTarget).eInverseRemove(
                    this,
                    IESFLocalAnalysisPackage.ABSTRACT_SPROPAGATION_ELEMENT__IN_SPROPAGATION_LINKS_LIST,
                    IAbstractSPropagationElement.class,
                    msgs);
            if (newElementTarget != null)
                msgs = ((InternalEObject) newElementTarget).eInverseAdd(
                    this,
                    IESFLocalAnalysisPackage.ABSTRACT_SPROPAGATION_ELEMENT__IN_SPROPAGATION_LINKS_LIST,
                    IAbstractSPropagationElement.class,
                    msgs);
            msgs = basicSetElementTarget(newElementTarget, msgs);
            if (msgs != null)
                msgs.dispatch();
        } else if (eNotificationRequired())
            eNotify(
                new ENotificationImpl(
                    this,
                    Notification.SET,
                    IESFLocalAnalysisPackage.SPROPAGATION_LINK__ELEMENT_TARGET,
                    newElementTarget,
                    newElementTarget));
    }

    /**
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * 
     * @generated
     */
    public Connector getBase_Connector() {
        if (base_Connector != null && base_Connector.eIsProxy()) {
            InternalEObject oldBase_Connector = (InternalEObject) base_Connector;
            base_Connector = (Connector) eResolveProxy(oldBase_Connector);
            if (base_Connector != oldBase_Connector) {
                if (eNotificationRequired())
                    eNotify(
                        new ENotificationImpl(
                            this,
                            Notification.RESOLVE,
                            IESFLocalAnalysisPackage.SPROPAGATION_LINK__BASE_CONNECTOR,
                            oldBase_Connector,
                            base_Connector));
            }
        }
        return base_Connector;
    }

    /**
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * 
     * @generated
     */
    public Connector basicGetBase_Connector() {
        return base_Connector;
    }

    /**
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * 
     * @generated
     */
    public void setBase_Connector(Connector newBase_Connector) {
        Connector oldBase_Connector = base_Connector;
        base_Connector = newBase_Connector;
        if (eNotificationRequired())
            eNotify(
                new ENotificationImpl(
                    this,
                    Notification.SET,
                    IESFLocalAnalysisPackage.SPROPAGATION_LINK__BASE_CONNECTOR,
                    oldBase_Connector,
                    base_Connector));
    }

    /**
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * 
     * @generated
     */
    public ISBlockLAnalysis getSBlockLAnalysis() {
        if (eContainerFeatureID() != IESFLocalAnalysisPackage.SPROPAGATION_LINK__SBLOCK_LANALYSIS)
            return null;
        return (ISBlockLAnalysis) eInternalContainer();
    }

    /**
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * 
     * @generated
     */
    public NotificationChain basicSetSBlockLAnalysis(ISBlockLAnalysis newSBlockLAnalysis, NotificationChain msgs) {
        msgs = eBasicSetContainer(
            (InternalEObject) newSBlockLAnalysis,
            IESFLocalAnalysisPackage.SPROPAGATION_LINK__SBLOCK_LANALYSIS,
            msgs);
        return msgs;
    }

    /**
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * 
     * @generated
     */
    public void setSBlockLAnalysis(ISBlockLAnalysis newSBlockLAnalysis) {
        if (newSBlockLAnalysis != eInternalContainer()
            || (eContainerFeatureID() != IESFLocalAnalysisPackage.SPROPAGATION_LINK__SBLOCK_LANALYSIS
                && newSBlockLAnalysis != null)) {
            if (EcoreUtil.isAncestor(this, newSBlockLAnalysis))
                throw new IllegalArgumentException("Recursive containment not allowed for " + toString()); //$NON-NLS-1$
            NotificationChain msgs = null;
            if (eInternalContainer() != null)
                msgs = eBasicRemoveFromContainer(msgs);
            if (newSBlockLAnalysis != null)
                msgs = ((InternalEObject) newSBlockLAnalysis).eInverseAdd(
                    this,
                    IESFLocalAnalysisPackage.SBLOCK_LANALYSIS__SPROPAGATION_LINKS_LIST,
                    ISBlockLAnalysis.class,
                    msgs);
            msgs = basicSetSBlockLAnalysis(newSBlockLAnalysis, msgs);
            if (msgs != null)
                msgs.dispatch();
        } else if (eNotificationRequired())
            eNotify(
                new ENotificationImpl(
                    this,
                    Notification.SET,
                    IESFLocalAnalysisPackage.SPROPAGATION_LINK__SBLOCK_LANALYSIS,
                    newSBlockLAnalysis,
                    newSBlockLAnalysis));
    }

    /**
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * 
     * @generated
     */
    public IAbstractSPropagationElement getElementSource() {
        if (elementSource != null && elementSource.eIsProxy()) {
            InternalEObject oldElementSource = (InternalEObject) elementSource;
            elementSource = (IAbstractSPropagationElement) eResolveProxy(oldElementSource);
            if (elementSource != oldElementSource) {
                if (eNotificationRequired())
                    eNotify(
                        new ENotificationImpl(
                            this,
                            Notification.RESOLVE,
                            IESFLocalAnalysisPackage.SPROPAGATION_LINK__ELEMENT_SOURCE,
                            oldElementSource,
                            elementSource));
            }
        }
        return elementSource;
    }

    /**
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * 
     * @generated
     */
    public IAbstractSPropagationElement basicGetElementSource() {
        return elementSource;
    }

    /**
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * 
     * @generated
     */
    public NotificationChain basicSetElementSource(
        IAbstractSPropagationElement newElementSource,
        NotificationChain msgs) {
        IAbstractSPropagationElement oldElementSource = elementSource;
        elementSource = newElementSource;
        if (eNotificationRequired()) {
            ENotificationImpl notification = new ENotificationImpl(
                this,
                Notification.SET,
                IESFLocalAnalysisPackage.SPROPAGATION_LINK__ELEMENT_SOURCE,
                oldElementSource,
                newElementSource);
            if (msgs == null)
                msgs = notification;
            else
                msgs.add(notification);
        }
        return msgs;
    }

    /**
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * 
     * @generated
     */
    public void setElementSource(IAbstractSPropagationElement newElementSource) {
        if (newElementSource != elementSource) {
            NotificationChain msgs = null;
            if (elementSource != null)
                msgs = ((InternalEObject) elementSource).eInverseRemove(
                    this,
                    IESFLocalAnalysisPackage.ABSTRACT_SPROPAGATION_ELEMENT__OUT_SPROPAGATION_LINKS_LIST,
                    IAbstractSPropagationElement.class,
                    msgs);
            if (newElementSource != null)
                msgs = ((InternalEObject) newElementSource).eInverseAdd(
                    this,
                    IESFLocalAnalysisPackage.ABSTRACT_SPROPAGATION_ELEMENT__OUT_SPROPAGATION_LINKS_LIST,
                    IAbstractSPropagationElement.class,
                    msgs);
            msgs = basicSetElementSource(newElementSource, msgs);
            if (msgs != null)
                msgs.dispatch();
        } else if (eNotificationRequired())
            eNotify(
                new ENotificationImpl(
                    this,
                    Notification.SET,
                    IESFLocalAnalysisPackage.SPROPAGATION_LINK__ELEMENT_SOURCE,
                    newElementSource,
                    newElementSource));
    }

    /**
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * 
     * @generated
     */
    @Override
    public NotificationChain eInverseAdd(InternalEObject otherEnd, int featureID, NotificationChain msgs) {
        switch (featureID) {
            case IESFLocalAnalysisPackage.SPROPAGATION_LINK__ELEMENT_TARGET:
                if (elementTarget != null)
                    msgs = ((InternalEObject) elementTarget).eInverseRemove(
                        this,
                        IESFLocalAnalysisPackage.ABSTRACT_SPROPAGATION_ELEMENT__IN_SPROPAGATION_LINKS_LIST,
                        IAbstractSPropagationElement.class,
                        msgs);
                return basicSetElementTarget((IAbstractSPropagationElement) otherEnd, msgs);
            case IESFLocalAnalysisPackage.SPROPAGATION_LINK__SBLOCK_LANALYSIS:
                if (eInternalContainer() != null)
                    msgs = eBasicRemoveFromContainer(msgs);
                return basicSetSBlockLAnalysis((ISBlockLAnalysis) otherEnd, msgs);
            case IESFLocalAnalysisPackage.SPROPAGATION_LINK__ELEMENT_SOURCE:
                if (elementSource != null)
                    msgs = ((InternalEObject) elementSource).eInverseRemove(
                        this,
                        IESFLocalAnalysisPackage.ABSTRACT_SPROPAGATION_ELEMENT__OUT_SPROPAGATION_LINKS_LIST,
                        IAbstractSPropagationElement.class,
                        msgs);
                return basicSetElementSource((IAbstractSPropagationElement) otherEnd, msgs);
        }
        return super.eInverseAdd(otherEnd, featureID, msgs);
    }

    /**
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * 
     * @generated
     */
    @Override
    public NotificationChain eInverseRemove(InternalEObject otherEnd, int featureID, NotificationChain msgs) {
        switch (featureID) {
            case IESFLocalAnalysisPackage.SPROPAGATION_LINK__ELEMENT_TARGET:
                return basicSetElementTarget(null, msgs);
            case IESFLocalAnalysisPackage.SPROPAGATION_LINK__SBLOCK_LANALYSIS:
                return basicSetSBlockLAnalysis(null, msgs);
            case IESFLocalAnalysisPackage.SPROPAGATION_LINK__ELEMENT_SOURCE:
                return basicSetElementSource(null, msgs);
        }
        return super.eInverseRemove(otherEnd, featureID, msgs);
    }

    /**
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * 
     * @generated
     */
    @Override
    public NotificationChain eBasicRemoveFromContainerFeature(NotificationChain msgs) {
        switch (eContainerFeatureID()) {
            case IESFLocalAnalysisPackage.SPROPAGATION_LINK__SBLOCK_LANALYSIS:
                return eInternalContainer().eInverseRemove(
                    this,
                    IESFLocalAnalysisPackage.SBLOCK_LANALYSIS__SPROPAGATION_LINKS_LIST,
                    ISBlockLAnalysis.class,
                    msgs);
        }
        return super.eBasicRemoveFromContainerFeature(msgs);
    }

    /**
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * 
     * @generated
     */
    @Override
    public Object eGet(int featureID, boolean resolve, boolean coreType) {
        switch (featureID) {
            case IESFLocalAnalysisPackage.SPROPAGATION_LINK__ELEMENT_TARGET:
                if (resolve)
                    return getElementTarget();
                return basicGetElementTarget();
            case IESFLocalAnalysisPackage.SPROPAGATION_LINK__BASE_CONNECTOR:
                if (resolve)
                    return getBase_Connector();
                return basicGetBase_Connector();
            case IESFLocalAnalysisPackage.SPROPAGATION_LINK__SBLOCK_LANALYSIS:
                return getSBlockLAnalysis();
            case IESFLocalAnalysisPackage.SPROPAGATION_LINK__ELEMENT_SOURCE:
                if (resolve)
                    return getElementSource();
                return basicGetElementSource();
        }
        return super.eGet(featureID, resolve, coreType);
    }

    /**
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * 
     * @generated
     */
    @Override
    public void eSet(int featureID, Object newValue) {
        switch (featureID) {
            case IESFLocalAnalysisPackage.SPROPAGATION_LINK__ELEMENT_TARGET:
                setElementTarget((IAbstractSPropagationElement) newValue);
                return;
            case IESFLocalAnalysisPackage.SPROPAGATION_LINK__BASE_CONNECTOR:
                setBase_Connector((Connector) newValue);
                return;
            case IESFLocalAnalysisPackage.SPROPAGATION_LINK__SBLOCK_LANALYSIS:
                setSBlockLAnalysis((ISBlockLAnalysis) newValue);
                return;
            case IESFLocalAnalysisPackage.SPROPAGATION_LINK__ELEMENT_SOURCE:
                setElementSource((IAbstractSPropagationElement) newValue);
                return;
        }
        super.eSet(featureID, newValue);
    }

    /**
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * 
     * @generated
     */
    @Override
    public void eUnset(int featureID) {
        switch (featureID) {
            case IESFLocalAnalysisPackage.SPROPAGATION_LINK__ELEMENT_TARGET:
                setElementTarget((IAbstractSPropagationElement) null);
                return;
            case IESFLocalAnalysisPackage.SPROPAGATION_LINK__BASE_CONNECTOR:
                setBase_Connector((Connector) null);
                return;
            case IESFLocalAnalysisPackage.SPROPAGATION_LINK__SBLOCK_LANALYSIS:
                setSBlockLAnalysis((ISBlockLAnalysis) null);
                return;
            case IESFLocalAnalysisPackage.SPROPAGATION_LINK__ELEMENT_SOURCE:
                setElementSource((IAbstractSPropagationElement) null);
                return;
        }
        super.eUnset(featureID);
    }

    /**
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * 
     * @generated
     */
    @Override
    public boolean eIsSet(int featureID) {
        switch (featureID) {
            case IESFLocalAnalysisPackage.SPROPAGATION_LINK__ELEMENT_TARGET:
                return elementTarget != null;
            case IESFLocalAnalysisPackage.SPROPAGATION_LINK__BASE_CONNECTOR:
                return base_Connector != null;
            case IESFLocalAnalysisPackage.SPROPAGATION_LINK__SBLOCK_LANALYSIS:
                return getSBlockLAnalysis() != null;
            case IESFLocalAnalysisPackage.SPROPAGATION_LINK__ELEMENT_SOURCE:
                return elementSource != null;
        }
        return super.eIsSet(featureID);
    }

} // SPropagationLink
