/*******************************************************************************
 * Copyright (c) 2016 ALL4TEC & CEA LIST.
 * All rights reserved. This program and the accompanying materials
 * are made available under the terms of the Eclipse Public License v1.0
 * which accompanies this distribution, and is available at
 * http://www.eclipse.org/legal/epl-v10.html
 *   
 * Contributors:
 *      ALL4TEC & CEA LIST - initial API and implementation
 *******************************************************************************/
package org.polarsys.esf.esflocalanalysis.impl;

import org.eclipse.emf.common.notify.Notification;
import org.eclipse.emf.common.notify.NotificationChain;

import org.eclipse.emf.ecore.EClass;
import org.eclipse.emf.ecore.InternalEObject;

import org.eclipse.emf.ecore.impl.ENotificationImpl;

import org.eclipse.uml2.uml.Property;

import org.polarsys.esf.esflocalanalysis.IESFLocalAnalysisPackage;
import org.polarsys.esf.esflocalanalysis.ISSystemEvent;
import org.polarsys.esf.esflocalanalysis.ISSystemEventType;

/**
 * <!-- begin-user-doc -->
 * An implementation of the model object '<em><b>SSystem Event</b></em>'.
 * <!-- end-user-doc -->
 * <p>
 * The following features are implemented:
 * </p>
 * <ul>
 * <li>{@link org.polarsys.esf.esflocalanalysis.impl.SSystemEvent#getBase_Property <em>Base Property</em>}</li>
 * <li>{@link org.polarsys.esf.esflocalanalysis.impl.SSystemEvent#getType <em>Type</em>}</li>
 * </ul>
 *
 * @generated
 */
public class SSystemEvent
    extends AbstractSFailureEventLAnalysis
    implements ISSystemEvent {

    /**
     * The cached value of the '{@link #getBase_Property() <em>Base Property</em>}' reference.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * 
     * @see #getBase_Property()
     * @generated
     * @ordered
     */
    protected Property base_Property;

    /**
     * The cached value of the '{@link #getType() <em>Type</em>}' reference.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * 
     * @see #getType()
     * @generated
     * @ordered
     */
    protected ISSystemEventType type;

    /**
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * 
     * @generated
     */
    protected SSystemEvent() {
        super();
    }

    /**
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * 
     * @generated
     */
    @Override
    protected EClass eStaticClass() {
        return IESFLocalAnalysisPackage.Literals.SSYSTEM_EVENT;
    }

    /**
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * 
     * @generated
     */
    public Property getBase_Property() {
        if (base_Property != null && base_Property.eIsProxy()) {
            InternalEObject oldBase_Property = (InternalEObject) base_Property;
            base_Property = (Property) eResolveProxy(oldBase_Property);
            if (base_Property != oldBase_Property) {
                if (eNotificationRequired())
                    eNotify(
                        new ENotificationImpl(
                            this,
                            Notification.RESOLVE,
                            IESFLocalAnalysisPackage.SSYSTEM_EVENT__BASE_PROPERTY,
                            oldBase_Property,
                            base_Property));
            }
        }
        return base_Property;
    }

    /**
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * 
     * @generated
     */
    public Property basicGetBase_Property() {
        return base_Property;
    }

    /**
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * 
     * @generated
     */
    public void setBase_Property(Property newBase_Property) {
        Property oldBase_Property = base_Property;
        base_Property = newBase_Property;
        if (eNotificationRequired())
            eNotify(
                new ENotificationImpl(
                    this,
                    Notification.SET,
                    IESFLocalAnalysisPackage.SSYSTEM_EVENT__BASE_PROPERTY,
                    oldBase_Property,
                    base_Property));
    }

    /**
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * 
     * @generated
     */
    public ISSystemEventType getType() {
        if (type != null && type.eIsProxy()) {
            InternalEObject oldType = (InternalEObject) type;
            type = (ISSystemEventType) eResolveProxy(oldType);
            if (type != oldType) {
                if (eNotificationRequired())
                    eNotify(
                        new ENotificationImpl(
                            this,
                            Notification.RESOLVE,
                            IESFLocalAnalysisPackage.SSYSTEM_EVENT__TYPE,
                            oldType,
                            type));
            }
        }
        return type;
    }

    /**
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * 
     * @generated
     */
    public ISSystemEventType basicGetType() {
        return type;
    }

    /**
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * 
     * @generated
     */
    public NotificationChain basicSetType(ISSystemEventType newType, NotificationChain msgs) {
        ISSystemEventType oldType = type;
        type = newType;
        if (eNotificationRequired()) {
            ENotificationImpl notification = new ENotificationImpl(
                this,
                Notification.SET,
                IESFLocalAnalysisPackage.SSYSTEM_EVENT__TYPE,
                oldType,
                newType);
            if (msgs == null)
                msgs = notification;
            else
                msgs.add(notification);
        }
        return msgs;
    }

    /**
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * 
     * @generated
     */
    public void setType(ISSystemEventType newType) {
        if (newType != type) {
            NotificationChain msgs = null;
            if (type != null)
                msgs = ((InternalEObject) type).eInverseRemove(
                    this,
                    IESFLocalAnalysisPackage.SSYSTEM_EVENT_TYPE__INSTANCES_LIST,
                    ISSystemEventType.class,
                    msgs);
            if (newType != null)
                msgs = ((InternalEObject) newType).eInverseAdd(
                    this,
                    IESFLocalAnalysisPackage.SSYSTEM_EVENT_TYPE__INSTANCES_LIST,
                    ISSystemEventType.class,
                    msgs);
            msgs = basicSetType(newType, msgs);
            if (msgs != null)
                msgs.dispatch();
        } else if (eNotificationRequired())
            eNotify(
                new ENotificationImpl(
                    this,
                    Notification.SET,
                    IESFLocalAnalysisPackage.SSYSTEM_EVENT__TYPE,
                    newType,
                    newType));
    }

    /**
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * 
     * @generated
     */
    @Override
    public NotificationChain eInverseAdd(InternalEObject otherEnd, int featureID, NotificationChain msgs) {
        switch (featureID) {
            case IESFLocalAnalysisPackage.SSYSTEM_EVENT__TYPE:
                if (type != null)
                    msgs = ((InternalEObject) type).eInverseRemove(
                        this,
                        IESFLocalAnalysisPackage.SSYSTEM_EVENT_TYPE__INSTANCES_LIST,
                        ISSystemEventType.class,
                        msgs);
                return basicSetType((ISSystemEventType) otherEnd, msgs);
        }
        return super.eInverseAdd(otherEnd, featureID, msgs);
    }

    /**
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * 
     * @generated
     */
    @Override
    public NotificationChain eInverseRemove(InternalEObject otherEnd, int featureID, NotificationChain msgs) {
        switch (featureID) {
            case IESFLocalAnalysisPackage.SSYSTEM_EVENT__TYPE:
                return basicSetType(null, msgs);
        }
        return super.eInverseRemove(otherEnd, featureID, msgs);
    }

    /**
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * 
     * @generated
     */
    @Override
    public Object eGet(int featureID, boolean resolve, boolean coreType) {
        switch (featureID) {
            case IESFLocalAnalysisPackage.SSYSTEM_EVENT__BASE_PROPERTY:
                if (resolve)
                    return getBase_Property();
                return basicGetBase_Property();
            case IESFLocalAnalysisPackage.SSYSTEM_EVENT__TYPE:
                if (resolve)
                    return getType();
                return basicGetType();
        }
        return super.eGet(featureID, resolve, coreType);
    }

    /**
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * 
     * @generated
     */
    @Override
    public void eSet(int featureID, Object newValue) {
        switch (featureID) {
            case IESFLocalAnalysisPackage.SSYSTEM_EVENT__BASE_PROPERTY:
                setBase_Property((Property) newValue);
                return;
            case IESFLocalAnalysisPackage.SSYSTEM_EVENT__TYPE:
                setType((ISSystemEventType) newValue);
                return;
        }
        super.eSet(featureID, newValue);
    }

    /**
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * 
     * @generated
     */
    @Override
    public void eUnset(int featureID) {
        switch (featureID) {
            case IESFLocalAnalysisPackage.SSYSTEM_EVENT__BASE_PROPERTY:
                setBase_Property((Property) null);
                return;
            case IESFLocalAnalysisPackage.SSYSTEM_EVENT__TYPE:
                setType((ISSystemEventType) null);
                return;
        }
        super.eUnset(featureID);
    }

    /**
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * 
     * @generated
     */
    @Override
    public boolean eIsSet(int featureID) {
        switch (featureID) {
            case IESFLocalAnalysisPackage.SSYSTEM_EVENT__BASE_PROPERTY:
                return base_Property != null;
            case IESFLocalAnalysisPackage.SSYSTEM_EVENT__TYPE:
                return type != null;
        }
        return super.eIsSet(featureID);
    }

} // SSystemEvent
