/*******************************************************************************
 * Copyright (c) 2016 ALL4TEC & CEA LIST.
 * All rights reserved. This program and the accompanying materials
 * are made available under the terms of the Eclipse Public License v1.0
 * which accompanies this distribution, and is available at
 * http://www.eclipse.org/legal/epl-v10.html
 *   
 * Contributors:
 *      ALL4TEC & CEA LIST - initial API and implementation
 *******************************************************************************/
package org.polarsys.esf.esflocalanalysis.impl;

import java.util.Collection;

import org.eclipse.emf.common.notify.Notification;
import org.eclipse.emf.common.notify.NotificationChain;

import org.eclipse.emf.common.util.EList;

import org.eclipse.emf.ecore.EClass;
import org.eclipse.emf.ecore.InternalEObject;

import org.eclipse.emf.ecore.impl.ENotificationImpl;

import org.eclipse.emf.ecore.util.EObjectContainmentEList;
import org.eclipse.emf.ecore.util.InternalEList;

import org.polarsys.esf.esflocalanalysis.IESFLocalAnalysisPackage;
import org.polarsys.esf.esflocalanalysis.ISSystemEventType;
import org.polarsys.esf.esflocalanalysis.ISSystemEventsLibrary;

/**
 * <!-- begin-user-doc -->
 * An implementation of the model object '<em><b>SSystem Events Library</b></em>'.
 * <!-- end-user-doc -->
 * <p>
 * The following features are implemented:
 * </p>
 * <ul>
 * <li>{@link org.polarsys.esf.esflocalanalysis.impl.SSystemEventsLibrary#getBase_Package <em>Base Package</em>}</li>
 * <li>{@link org.polarsys.esf.esflocalanalysis.impl.SSystemEventsLibrary#getSSystemEventTypesList <em>SSystem Event
 * Types List</em>}</li>
 * </ul>
 *
 * @generated
 */
public class SSystemEventsLibrary
    extends AbstractSLocalAnalysisElement
    implements ISSystemEventsLibrary {

    /**
     * The cached value of the '{@link #getBase_Package() <em>Base Package</em>}' reference.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * 
     * @see #getBase_Package()
     * @generated
     * @ordered
     */
    protected org.eclipse.uml2.uml.Package base_Package;

    /**
     * The cached value of the '{@link #getSSystemEventTypesList() <em>SSystem Event Types List</em>}' containment
     * reference list.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * 
     * @see #getSSystemEventTypesList()
     * @generated
     * @ordered
     */
    protected EList<ISSystemEventType> sSystemEventTypesList;

    /**
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * 
     * @generated
     */
    protected SSystemEventsLibrary() {
        super();
    }

    /**
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * 
     * @generated
     */
    @Override
    protected EClass eStaticClass() {
        return IESFLocalAnalysisPackage.Literals.SSYSTEM_EVENTS_LIBRARY;
    }

    /**
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * 
     * @generated
     */
    public org.eclipse.uml2.uml.Package getBase_Package() {
        if (base_Package != null && base_Package.eIsProxy()) {
            InternalEObject oldBase_Package = (InternalEObject) base_Package;
            base_Package = (org.eclipse.uml2.uml.Package) eResolveProxy(oldBase_Package);
            if (base_Package != oldBase_Package) {
                if (eNotificationRequired())
                    eNotify(
                        new ENotificationImpl(
                            this,
                            Notification.RESOLVE,
                            IESFLocalAnalysisPackage.SSYSTEM_EVENTS_LIBRARY__BASE_PACKAGE,
                            oldBase_Package,
                            base_Package));
            }
        }
        return base_Package;
    }

    /**
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * 
     * @generated
     */
    public org.eclipse.uml2.uml.Package basicGetBase_Package() {
        return base_Package;
    }

    /**
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * 
     * @generated
     */
    public void setBase_Package(org.eclipse.uml2.uml.Package newBase_Package) {
        org.eclipse.uml2.uml.Package oldBase_Package = base_Package;
        base_Package = newBase_Package;
        if (eNotificationRequired())
            eNotify(
                new ENotificationImpl(
                    this,
                    Notification.SET,
                    IESFLocalAnalysisPackage.SSYSTEM_EVENTS_LIBRARY__BASE_PACKAGE,
                    oldBase_Package,
                    base_Package));
    }

    /**
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * 
     * @generated
     */
    public EList<ISSystemEventType> getSSystemEventTypesList() {
        if (sSystemEventTypesList == null) {
            sSystemEventTypesList = new EObjectContainmentEList<ISSystemEventType>(
                ISSystemEventType.class,
                this,
                IESFLocalAnalysisPackage.SSYSTEM_EVENTS_LIBRARY__SSYSTEM_EVENT_TYPES_LIST);
        }
        return sSystemEventTypesList;
    }

    /**
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * 
     * @generated
     */
    @Override
    public NotificationChain eInverseRemove(InternalEObject otherEnd, int featureID, NotificationChain msgs) {
        switch (featureID) {
            case IESFLocalAnalysisPackage.SSYSTEM_EVENTS_LIBRARY__SSYSTEM_EVENT_TYPES_LIST:
                return ((InternalEList<?>) getSSystemEventTypesList()).basicRemove(otherEnd, msgs);
        }
        return super.eInverseRemove(otherEnd, featureID, msgs);
    }

    /**
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * 
     * @generated
     */
    @Override
    public Object eGet(int featureID, boolean resolve, boolean coreType) {
        switch (featureID) {
            case IESFLocalAnalysisPackage.SSYSTEM_EVENTS_LIBRARY__BASE_PACKAGE:
                if (resolve)
                    return getBase_Package();
                return basicGetBase_Package();
            case IESFLocalAnalysisPackage.SSYSTEM_EVENTS_LIBRARY__SSYSTEM_EVENT_TYPES_LIST:
                return getSSystemEventTypesList();
        }
        return super.eGet(featureID, resolve, coreType);
    }

    /**
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * 
     * @generated
     */
    @SuppressWarnings("unchecked")
    @Override
    public void eSet(int featureID, Object newValue) {
        switch (featureID) {
            case IESFLocalAnalysisPackage.SSYSTEM_EVENTS_LIBRARY__BASE_PACKAGE:
                setBase_Package((org.eclipse.uml2.uml.Package) newValue);
                return;
            case IESFLocalAnalysisPackage.SSYSTEM_EVENTS_LIBRARY__SSYSTEM_EVENT_TYPES_LIST:
                getSSystemEventTypesList().clear();
                getSSystemEventTypesList().addAll((Collection<? extends ISSystemEventType>) newValue);
                return;
        }
        super.eSet(featureID, newValue);
    }

    /**
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * 
     * @generated
     */
    @Override
    public void eUnset(int featureID) {
        switch (featureID) {
            case IESFLocalAnalysisPackage.SSYSTEM_EVENTS_LIBRARY__BASE_PACKAGE:
                setBase_Package((org.eclipse.uml2.uml.Package) null);
                return;
            case IESFLocalAnalysisPackage.SSYSTEM_EVENTS_LIBRARY__SSYSTEM_EVENT_TYPES_LIST:
                getSSystemEventTypesList().clear();
                return;
        }
        super.eUnset(featureID);
    }

    /**
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * 
     * @generated
     */
    @Override
    public boolean eIsSet(int featureID) {
        switch (featureID) {
            case IESFLocalAnalysisPackage.SSYSTEM_EVENTS_LIBRARY__BASE_PACKAGE:
                return base_Package != null;
            case IESFLocalAnalysisPackage.SSYSTEM_EVENTS_LIBRARY__SSYSTEM_EVENT_TYPES_LIST:
                return sSystemEventTypesList != null && !sSystemEventTypesList.isEmpty();
        }
        return super.eIsSet(featureID);
    }

} // SSystemEventsLibrary
