/*******************************************************************************
 * Copyright (c) 2016 ALL4TEC & CEA LIST.
 * All rights reserved. This program and the accompanying materials
 * are made available under the terms of the Eclipse Public License v1.0
 * which accompanies this distribution, and is available at
 * http://www.eclipse.org/legal/epl-v10.html
 *   
 * Contributors:
 *      ALL4TEC & CEA LIST - initial API and implementation
 *******************************************************************************/
package org.polarsys.esf.esflocalanalysis.util;

import java.util.Map;

import org.eclipse.emf.common.util.DiagnosticChain;
import org.eclipse.emf.common.util.ResourceLocator;

import org.eclipse.emf.ecore.EPackage;

import org.eclipse.emf.ecore.util.EObjectValidator;

import org.polarsys.esf.esflocalanalysis.*;

/**
 * <!-- begin-user-doc -->
 * The <b>Validator</b> for the model.
 * <!-- end-user-doc -->
 * 
 * @see org.polarsys.esf.esflocalanalysis.IESFLocalAnalysisPackage
 * @generated
 */
public class ESFLocalAnalysisValidator
    extends EObjectValidator {

    /**
     * The cached model package
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * 
     * @generated
     */
    public static final ESFLocalAnalysisValidator INSTANCE = new ESFLocalAnalysisValidator();

    /**
     * A constant for the {@link org.eclipse.emf.common.util.Diagnostic#getSource() source} of diagnostic
     * {@link org.eclipse.emf.common.util.Diagnostic#getCode() codes} from this package.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * 
     * @see org.eclipse.emf.common.util.Diagnostic#getSource()
     * @see org.eclipse.emf.common.util.Diagnostic#getCode()
     * @generated
     */
    public static final String DIAGNOSTIC_SOURCE = "org.polarsys.esf.esflocalanalysis"; //$NON-NLS-1$

    /**
     * The {@link org.eclipse.emf.common.util.Diagnostic#getCode() code} for constraint 'Constraint1' of 'SDysfunctional
     * Association'.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * 
     * @generated
     */
    public static final int SDYSFUNCTIONAL_ASSOCIATION__CONSTRAINT1 = 1;

    /**
     * A constant with a fixed name that can be used as the base value for additional hand written constants.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * 
     * @generated
     */
    private static final int GENERATED_DIAGNOSTIC_CODE_COUNT = 1;

    /**
     * A constant with a fixed name that can be used as the base value for additional hand written constants in a
     * derived class.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * 
     * @generated
     */
    protected static final int DIAGNOSTIC_CODE_COUNT = GENERATED_DIAGNOSTIC_CODE_COUNT;

    /**
     * Creates an instance of the switch.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * 
     * @generated
     */
    public ESFLocalAnalysisValidator() {
        super();
    }

    /**
     * Returns the package of this validator switch.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * 
     * @generated
     */
    @Override
    protected EPackage getEPackage() {
        return IESFLocalAnalysisPackage.eINSTANCE;
    }

    /**
     * Calls <code>validateXXX</code> for the corresponding classifier of the model.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * 
     * @generated
     */
    @Override
    protected boolean validate(
        int classifierID,
        Object value,
        DiagnosticChain diagnostics,
        Map<Object, Object> context) {
        switch (classifierID) {
            case IESFLocalAnalysisPackage.ABSTRACT_SLOCAL_ANALYSIS_ELEMENT:
                return validateAbstractSLocalAnalysisElement(
                    (IAbstractSLocalAnalysisElement) value,
                    diagnostics,
                    context);
            case IESFLocalAnalysisPackage.SPORT_LANALYSIS:
                return validateSPortLAnalysis((ISPortLAnalysis) value, diagnostics, context);
            case IESFLocalAnalysisPackage.ABSTRACT_SFAILURE_MODE_LANALYSIS:
                return validateAbstractSFailureModeLAnalysis(
                    (IAbstractSFailureModeLAnalysis) value,
                    diagnostics,
                    context);
            case IESFLocalAnalysisPackage.ABSTRACT_SPROPAGATION_ELEMENT:
                return validateAbstractSPropagationElement((IAbstractSPropagationElement) value, diagnostics, context);
            case IESFLocalAnalysisPackage.SPROPAGATION_LINK:
                return validateSPropagationLink((ISPropagationLink) value, diagnostics, context);
            case IESFLocalAnalysisPackage.SBLOCK_LANALYSIS:
                return validateSBlockLAnalysis((ISBlockLAnalysis) value, diagnostics, context);
            case IESFLocalAnalysisPackage.ABSTRACT_SFAILURE_EVENT_LANALYSIS:
                return validateAbstractSFailureEventLAnalysis(
                    (IAbstractSFailureEventLAnalysis) value,
                    diagnostics,
                    context);
            case IESFLocalAnalysisPackage.ABSTRACT_SLOGICAL_GATE_LANALYSIS:
                return validateAbstractSLogicalGateLAnalysis(
                    (IAbstractSLogicalGateLAnalysis) value,
                    diagnostics,
                    context);
            case IESFLocalAnalysisPackage.SBARRIER_LANALYSIS:
                return validateSBarrierLAnalysis((ISBarrierLAnalysis) value, diagnostics, context);
            case IESFLocalAnalysisPackage.SLOCAL_ANALYSIS:
                return validateSLocalAnalysis((ISLocalAnalysis) value, diagnostics, context);
            case IESFLocalAnalysisPackage.SSYSTEM_EVENTS_LIBRARY:
                return validateSSystemEventsLibrary((ISSystemEventsLibrary) value, diagnostics, context);
            case IESFLocalAnalysisPackage.SSYSTEM_EVENT_TYPE:
                return validateSSystemEventType((ISSystemEventType) value, diagnostics, context);
            case IESFLocalAnalysisPackage.SSYSTEM_EVENT:
                return validateSSystemEvent((ISSystemEvent) value, diagnostics, context);
            case IESFLocalAnalysisPackage.SDYSFUNCTIONAL_ASSOCIATION:
                return validateSDysfunctionalAssociation((ISDysfunctionalAssociation) value, diagnostics, context);
            case IESFLocalAnalysisPackage.SAND_GATE_LANALYSIS:
                return validateSAndGateLAnalysis((ISAndGateLAnalysis) value, diagnostics, context);
            case IESFLocalAnalysisPackage.SOR_GATE_LANALYSIS:
                return validateSOrGateLAnalysis((ISOrGateLAnalysis) value, diagnostics, context);
            case IESFLocalAnalysisPackage.SULTIMELY_FAILURE_MODE:
                return validateSUltimelyFailureMode((ISUltimelyFailureMode) value, diagnostics, context);
            case IESFLocalAnalysisPackage.SABSENT_FAILURE_MODE:
                return validateSAbsentFailureMode((ISAbsentFailureMode) value, diagnostics, context);
            case IESFLocalAnalysisPackage.SERRONEOUS_FAILURE_MODE:
                return validateSErroneousFailureMode((ISErroneousFailureMode) value, diagnostics, context);
            case IESFLocalAnalysisPackage.SLOCAL_EVENT:
                return validateSLocalEvent((ISLocalEvent) value, diagnostics, context);
            case IESFLocalAnalysisPackage.SDIRECTION_LANALYSIS:
                return validateSDirectionLAnalysis((SDirectionLAnalysis) value, diagnostics, context);
            default:
                return true;
        }
    }

    /**
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * 
     * @generated
     */
    public boolean validateAbstractSLocalAnalysisElement(
        IAbstractSLocalAnalysisElement abstractSLocalAnalysisElement,
        DiagnosticChain diagnostics,
        Map<Object, Object> context) {
        return validate_EveryDefaultConstraint(abstractSLocalAnalysisElement, diagnostics, context);
    }

    /**
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * 
     * @generated
     */
    public boolean validateSPortLAnalysis(
        ISPortLAnalysis sPortLAnalysis,
        DiagnosticChain diagnostics,
        Map<Object, Object> context) {
        return validate_EveryDefaultConstraint(sPortLAnalysis, diagnostics, context);
    }

    /**
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * 
     * @generated
     */
    public boolean validateAbstractSFailureModeLAnalysis(
        IAbstractSFailureModeLAnalysis abstractSFailureModeLAnalysis,
        DiagnosticChain diagnostics,
        Map<Object, Object> context) {
        return validate_EveryDefaultConstraint(abstractSFailureModeLAnalysis, diagnostics, context);
    }

    /**
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * 
     * @generated
     */
    public boolean validateAbstractSPropagationElement(
        IAbstractSPropagationElement abstractSPropagationElement,
        DiagnosticChain diagnostics,
        Map<Object, Object> context) {
        return validate_EveryDefaultConstraint(abstractSPropagationElement, diagnostics, context);
    }

    /**
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * 
     * @generated
     */
    public boolean validateSPropagationLink(
        ISPropagationLink sPropagationLink,
        DiagnosticChain diagnostics,
        Map<Object, Object> context) {
        return validate_EveryDefaultConstraint(sPropagationLink, diagnostics, context);
    }

    /**
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * 
     * @generated
     */
    public boolean validateSLocalAnalysis(
        ISLocalAnalysis sLocalAnalysis,
        DiagnosticChain diagnostics,
        Map<Object, Object> context) {
        return validate_EveryDefaultConstraint(sLocalAnalysis, diagnostics, context);
    }

    /**
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * 
     * @generated
     */
    public boolean validateSSystemEventsLibrary(
        ISSystemEventsLibrary sSystemEventsLibrary,
        DiagnosticChain diagnostics,
        Map<Object, Object> context) {
        return validate_EveryDefaultConstraint(sSystemEventsLibrary, diagnostics, context);
    }

    /**
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * 
     * @generated
     */
    public boolean validateSSystemEventType(
        ISSystemEventType sSystemEventType,
        DiagnosticChain diagnostics,
        Map<Object, Object> context) {
        return validate_EveryDefaultConstraint(sSystemEventType, diagnostics, context);
    }

    /**
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * 
     * @generated
     */
    public boolean validateSSystemEvent(
        ISSystemEvent sSystemEvent,
        DiagnosticChain diagnostics,
        Map<Object, Object> context) {
        return validate_EveryDefaultConstraint(sSystemEvent, diagnostics, context);
    }

    /**
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * 
     * @generated
     */
    public boolean validateSBlockLAnalysis(
        ISBlockLAnalysis sBlockLAnalysis,
        DiagnosticChain diagnostics,
        Map<Object, Object> context) {
        return validate_EveryDefaultConstraint(sBlockLAnalysis, diagnostics, context);
    }

    /**
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * 
     * @generated
     */
    public boolean validateAbstractSFailureEventLAnalysis(
        IAbstractSFailureEventLAnalysis abstractSFailureEventLAnalysis,
        DiagnosticChain diagnostics,
        Map<Object, Object> context) {
        return validate_EveryDefaultConstraint(abstractSFailureEventLAnalysis, diagnostics, context);
    }

    /**
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * 
     * @generated
     */
    public boolean validateAbstractSLogicalGateLAnalysis(
        IAbstractSLogicalGateLAnalysis abstractSLogicalGateLAnalysis,
        DiagnosticChain diagnostics,
        Map<Object, Object> context) {
        return validate_EveryDefaultConstraint(abstractSLogicalGateLAnalysis, diagnostics, context);
    }

    /**
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * 
     * @generated
     */
    public boolean validateSBarrierLAnalysis(
        ISBarrierLAnalysis sBarrierLAnalysis,
        DiagnosticChain diagnostics,
        Map<Object, Object> context) {
        return validate_EveryDefaultConstraint(sBarrierLAnalysis, diagnostics, context);
    }

    /**
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * 
     * @generated
     */
    public boolean validateSDysfunctionalAssociation(
        ISDysfunctionalAssociation sDysfunctionalAssociation,
        DiagnosticChain diagnostics,
        Map<Object, Object> context) {
        if (!validate_NoCircularContainment(sDysfunctionalAssociation, diagnostics, context))
            return false;
        boolean result = validate_EveryMultiplicityConforms(sDysfunctionalAssociation, diagnostics, context);
        if (result || diagnostics != null)
            result &= validate_EveryDataValueConforms(sDysfunctionalAssociation, diagnostics, context);
        if (result || diagnostics != null)
            result &= validate_EveryReferenceIsContained(sDysfunctionalAssociation, diagnostics, context);
        if (result || diagnostics != null)
            result &= validate_EveryBidirectionalReferenceIsPaired(sDysfunctionalAssociation, diagnostics, context);
        if (result || diagnostics != null)
            result &= validate_EveryProxyResolves(sDysfunctionalAssociation, diagnostics, context);
        if (result || diagnostics != null)
            result &= validate_UniqueID(sDysfunctionalAssociation, diagnostics, context);
        if (result || diagnostics != null)
            result &= validate_EveryKeyUnique(sDysfunctionalAssociation, diagnostics, context);
        if (result || diagnostics != null)
            result &= validate_EveryMapEntryUnique(sDysfunctionalAssociation, diagnostics, context);
        if (result || diagnostics != null)
            result &= validateSDysfunctionalAssociation_Constraint1(sDysfunctionalAssociation, diagnostics, context);
        return result;
    }

    /**
     * Validates the Constraint1 constraint of '<em>SDysfunctional Association</em>'.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * 
     * @generated
     */
    public boolean validateSDysfunctionalAssociation_Constraint1(
        ISDysfunctionalAssociation sDysfunctionalAssociation,
        DiagnosticChain diagnostics,
        Map<Object, Object> context) {
        return sDysfunctionalAssociation.Constraint1(diagnostics, context);
    }

    /**
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * 
     * @generated
     */
    public boolean validateSAndGateLAnalysis(
        ISAndGateLAnalysis sAndGateLAnalysis,
        DiagnosticChain diagnostics,
        Map<Object, Object> context) {
        return validate_EveryDefaultConstraint(sAndGateLAnalysis, diagnostics, context);
    }

    /**
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * 
     * @generated
     */
    public boolean validateSOrGateLAnalysis(
        ISOrGateLAnalysis sOrGateLAnalysis,
        DiagnosticChain diagnostics,
        Map<Object, Object> context) {
        return validate_EveryDefaultConstraint(sOrGateLAnalysis, diagnostics, context);
    }

    /**
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * 
     * @generated
     */
    public boolean validateSUltimelyFailureMode(
        ISUltimelyFailureMode sUltimelyFailureMode,
        DiagnosticChain diagnostics,
        Map<Object, Object> context) {
        return validate_EveryDefaultConstraint(sUltimelyFailureMode, diagnostics, context);
    }

    /**
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * 
     * @generated
     */
    public boolean validateSAbsentFailureMode(
        ISAbsentFailureMode sAbsentFailureMode,
        DiagnosticChain diagnostics,
        Map<Object, Object> context) {
        return validate_EveryDefaultConstraint(sAbsentFailureMode, diagnostics, context);
    }

    /**
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * 
     * @generated
     */
    public boolean validateSErroneousFailureMode(
        ISErroneousFailureMode sErroneousFailureMode,
        DiagnosticChain diagnostics,
        Map<Object, Object> context) {
        return validate_EveryDefaultConstraint(sErroneousFailureMode, diagnostics, context);
    }

    /**
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * 
     * @generated
     */
    public boolean validateSLocalEvent(
        ISLocalEvent sLocalEvent,
        DiagnosticChain diagnostics,
        Map<Object, Object> context) {
        return validate_EveryDefaultConstraint(sLocalEvent, diagnostics, context);
    }

    /**
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * 
     * @generated
     */
    public boolean validateSDirectionLAnalysis(
        SDirectionLAnalysis sDirectionLAnalysis,
        DiagnosticChain diagnostics,
        Map<Object, Object> context) {
        return true;
    }

    /**
     * Returns the resource locator that will be used to fetch messages for this validator's diagnostics.
     * <!-- begin-user-doc -->
     * <!-- end-user-doc -->
     * 
     * @generated
     */
    @Override
    public ResourceLocator getResourceLocator() {
        // TODO
        // Specialize this to return a resource locator for messages specific to this validator.
        // Ensure that you remove @generated or mark it @generated NOT
        return super.getResourceLocator();
    }

} // ESFLocalAnalysisValidator
