/*******************************************************************************
 * Copyright (c) 2016 ALL4TEC & CEA LIST.
 * All rights reserved. This program and the accompanying materials
 * are made available under the terms of the Eclipse Public License v1.0
 * which accompanies this distribution, and is available at
 * http://www.eclipse.org/legal/epl-v10.html
 *   
 * Contributors:
 *      ALL4TEC & CEA LIST - initial API and implementation
 *******************************************************************************/
package org.polarsys.esf.esflocalanalysis.impl;

import org.polarsys.esf.esfarchitectureconcepts.impl.ESFArchitectureConceptsFactory;
import org.polarsys.esf.esflocalanalysis.IESFLocalAnalysisFactory;
import org.polarsys.esf.esflocalanalysis.IMESFLocalAnalysisFactory;
import org.polarsys.esf.esflocalanalysis.IMSLocalAnalysis;

/**
 * This factory overrides the generated factory {@link ESFArchitectureConceptsFactory}
 * and returns the new generated interfaces.
 *
 * @author $Author: ymunoz $
 * @version $Revision: 186 $
 */
public class MESFLocalAnalysisFactory
    extends ESFLocalAnalysisFactory
    implements IMESFLocalAnalysisFactory {

    /**
     * Default constructor.
     */
    public MESFLocalAnalysisFactory() {
        super();
    }

    /**
     * @return The initialised factory
     */
    public static IMESFLocalAnalysisFactory init() {
        IESFLocalAnalysisFactory vFactory = ESFLocalAnalysisFactory.init();

        // Check if the factory returned by the standard implementation can suit,
        // otherwise create a new instance
        if (!(vFactory instanceof IMESFLocalAnalysisFactory)) {
            vFactory = new MESFLocalAnalysisFactory();
        }

        return (IMESFLocalAnalysisFactory) vFactory;
    }

    /**
     * {@inheritDoc}
     */
    @Override
    public IMSLocalAnalysis createSLocalAnalysis() {
        IMSLocalAnalysis vLocalAnalysis = new MSLocalAnalysis();
        return vLocalAnalysis;
    }

}
