package org.polarsys.esf.esflocalanalysis.impl;

/*******************************************************************************
 * Copyright (c) 2016 ALL4TEC & CEA LIST.
 * All rights reserved. This program and the accompanying materials
 * are made available under the terms of the Eclipse Public License v1.0
 * which accompanies this distribution, and is available at
 * http://www.eclipse.org/legal/epl-v10.html
 *   
 * Contributors:
 *      ALL4TEC & CEA LIST - initial API and implementation
 *******************************************************************************/
import org.eclipse.emf.common.util.BasicEList;
import org.eclipse.emf.common.util.EList;
import org.eclipse.emf.ecore.util.EcoreEList.UnmodifiableEList;
import org.eclipse.uml2.uml.Element;
import org.eclipse.uml2.uml.Package;
import org.eclipse.uml2.uml.util.UMLUtil;
import org.polarsys.esf.esfcore.impl.GenericAbstractSElement;
import org.polarsys.esf.esflocalanalysis.IMSLocalAnalysis;
import org.polarsys.esf.esflocalanalysis.ISBlockLAnalysis;

/**
 * This class can override the generated class {@link SLocalAnalysis} and will be
 * used by the custom factory.
 *
 * @author $Author: ymunoz $
 * @version $Revision: 168 $
 */
public class MSLocalAnalysis
    extends SLocalAnalysis
    implements IMSLocalAnalysis {

    /**
     * Default constructor.
     */
    public MSLocalAnalysis() {
        super();
    }

    /**
     * {@inheritDoc}
     */
    @Override
    public String getName() {
        return GenericAbstractSElement.getName(getBase_Package());
    }

    /**
     * {@inheritDoc}
     */
    @Override
    public String getUUID() {
        return GenericAbstractSElement.getUUID(getBase_Package());
    }

    /**
     * {@inheritDoc}
     */
    @Override
    public EList<ISBlockLAnalysis> getSBlocksLAnalysisList() {
        EList<ISBlockLAnalysis> vSSafetyConceptsList = new BasicEList<ISBlockLAnalysis>();
        Package vBase = getBase_Package();

        if (vBase != null) {
            for (Element vElement : vBase.getOwnedElements()) {
                if (UMLUtil.getStereotypeApplication(vElement, SBlockLAnalysis.class) != null) {
                    ISBlockLAnalysis vBlockLAnalysis =
                        (ISBlockLAnalysis) UMLUtil.getStereotypeApplication(vElement, SBlockLAnalysis.class);
                    vSSafetyConceptsList.add(vBlockLAnalysis);
                }
            }
        }

        UnmodifiableEList<ISBlockLAnalysis> vUSSafetyConceptsList =
            new UnmodifiableEList<ISBlockLAnalysis>(
                this,
                ESFLocalAnalysisPackage.eINSTANCE.getSLocalAnalysis_SBlocksLAnalysisList(),
                vSSafetyConceptsList.size(),
                vSSafetyConceptsList.toArray());

        return vUSSafetyConceptsList;
    }

}
